unit Foreval_Lib;

{******************************************************************************}
{                                                                              }
{                      SOREL  (C)CopyRight 1999-2003. Russia.                  }
{                                                                              }
{                       ForevalLib -  construct interface of Foreval.dll       }
{                                                                              }
{                                  ver. 8.4.16.110                             }
{******************************************************************************}

//Note !!!!!

//Rus:
{
      ( dll)       STRING.    dll 

       Delphi:
Delphi 2009: tools/options/debugger options/language exceptions/(notify on language exception - off)  (EConvertError - on)
}


//Eng:
{
At direct connection to the program (without dll) or compile to package to include key STRING. At compilation in dll to disconnect key

Before compilation it is necessary to prohibit all exceptions of Delphi:
Delphi 2009: tools/options/debugger options/language exceptions/(notify on language exception - off) or (EConvertError - on)
}




{$DEFINE STRING}

interface
uses
Foreval_Main, Foreval_Command, SysUtils, ForevalD_Lib;


type  TCompFunc = record
                    Func: TFunction;
              XchBrSDeep: Integer;
               XchBrNXch: Integer;
            DinLoadSDeep: Integer;
             DinLoadNMem: Integer;
         DinLoadOverFlow: Integer;
               CmplSDeep: Integer;
            CmplOverFlow: Integer;
            CopyStackXch: Integer;
               CalcConst: Integer;
         MaxReplaceLevel: Integer;
                 end;


type
TAttribL = record
           Adr:   Cardinal;
           RType: Cardinal;
          end;



const
{flSet}
fl_DISABLE              = 0;
fl_ENABLE               = 1;
fl_AUTO                 = 2;
fl_YES                  = 3;
fl_NO                   = 4;
fl_SYNTAX_EXTENSION     = 10;
fl_VAR_NAME_SHIFT       = 11;
fl_FUNC_NAME_SHIFT      = 12;
fl_CALC_CONST           = 13;
fl_EXTERNAL_EXCEPTION   = 14;
fl_REPLACE_FUNCTION     = 15;
fl_DINAMIC_LOAD         = 16;
fl_SAVE_EAX             = 17;
fl_SAVE_EBX             = 18;
fl_SAVE_ECX             = 19;
fl_SAVE_EDX             = 20;
fl_SAVE_ESP             = 21;
fl_SAVE_EBP             = 22;
fl_SAVE_ESI             = 23;
fl_SAVE_EDI             = 24;
fl_STACK_DEEP           = 25;
fl_SINGLE               = 26;
fl_INTEGER              = 27;
fl_DOUBLE               = 28;
fl_EXTENDED             = 29;
fl_DIFFER               = 30;
fl_DATA_TYPE            = 31;
fl_PARAM_TYPE           = 32;
fl_CORRECT_POWER        = 33;
fl_EXCHANGE_BRANCH      = 34;
fl_GLOBAL_OPTIMIZATION  = 35;
fl_SET_ID               = 36;
fl_CLST                 = 37;
fl_ADDRESS              = 38;
fl_INLINE               = 39;
fl_FUNC_STACK_DEEP      = 40;
fl_FUNC_ID              = 41;
fl_NUM_ARG              = 42;
fl_ARROW                = 43;
fl_ARG_TYPE             = 44;
fl_ARG_TYPE_LIST        = 45;
fl_SAVE_REG             = 46;
fl_CALL_TYPE            = 47;
fl_CLEAR                = 48;
fl_PARAM_LIST           = 49;
fl_VAR_LIST             = 50;
fl_FREE                 = 51;
fl_ADD_FUNC_LIST        = 54;
fl_CMPL_FUNC_LIST       = 55;
fl_CLEAR_NAMES_FUNC     = 56;
fl_EAX                  = 57;
fl_EBX                  = 58;
fl_ECX                  = 59;
fl_EDX                  = 60;
fl_ESP                  = 61;
fl_STRING_TYPE          = 62;
fl_STRING               = 63;
fl_PCHAR                = 64;
fl_ANSISTRING           = 65;
fl_CLOSE_ARG            = 66;
fl_PACKAGE_COMPILE      = 67;
fl_TRIG_OPTIMIZATION    = 68;
fl_HYP_OPTIMIZATION     = 69;
fl_SHOW_EXCEPTION       = 99;
fl_ARRAY_DOUBLE         = 70;
fl_ARRAY_EXTENDED       = 71;
fl_ARRAY_SINGLE         = 72;
fl_ARRAY_INTEGER        = 73;
fl_STRING_INTERNAL      = 74;
fl_ERROR_CODE           = 75;




             


{flAddNewFunction}
fl_MEMORY_EAX           = 100;
fl_MEMORY_EBX           = 101;
fl_MEMORY_ECX           = 102;
fl_MEMORY_EDX           = 103;
fl_MEMORY_STACK_CPU     = 104;
fl_KERNEL_I             = 105;
fl_KERNEL_F             = 106;
fl_KERNEL_FI            = 107;
fl_KERNEL_FF            = 108;
fl_STACK_FPU            = 109;
fl_STACK_CPU            = 110;
fl_INFINITE_EABX        = 111;
fl_INFINITE_EBCX        = 112;
fl_INFINITE_ECDX        = 113;
fl_INFINITE_STACK_CPU   = 114;
fl_RIGHT                = 115;
fl_BACK                 = 116;
fl_UNKNOWN              = 117;
fl_MEMORY_ADDRESSES     = 118;
fl_PRECOMPILED          = 119;



{flGetErrorCode}
fl_ACCESS_VIOLATION           = 200;
fl_OUT_OF_MEMORY              = 201;
fl_STACK_OVERFLOW             = 202;
fl_ZERO_DIVIDE                = 203;
fl_INVALID_OPERATION          = 204;
fl_OVERFLOW                   = 205;
fl_UNDERFLOW                  = 206;
fl_INT_OVERFLOW               = 207;
fl_UNKNOWN_SYMBOL             = 208;
fl_MISSING_LEFT_BRACKET       = 209;
fl_MISSING_RIGHT_BRACKET      = 210;
fl_MISSING_OPERATION          = 211;
fl_WRONG_NUMBER_ARGUMENTS     = 212;
fl_MISSING_EXPRESSION         = 213;
fl_UNKNOWN_FUNCTION           = 214;
fl_ERROR_AT_ADDITION_FUNCTION = 215;
fl_NONEXISTENT_FUNCTION       = 216;
fl_INCORRECT_ARGUMENT         = 217;
fl_MISSING_ARGUMENT           = 218;




{flGet}
fl_VERSION                         = 301;
fl_MAJOR                           = 302;
fl_MINOR                           = 303;
fl_RELEASE                         = 304;
fl_ABOUT                           = 305;
fl_AUTHOR                          = 306;
fl_EXCHANGE_BRANCH_STACK_DEEP      = 316;
fl_EXCHANGE_BRANCHE_NUM            = 317;
fl_DINAMIC_LOAD_STACK_DEEP         = 318;
fl_DINAMIC_LOAD_NUM                = 319;
fl_DINAMIC_LOAD_OVFL               = 320;
fl_COMPILE_STACK_DEEP              = 321;
fl_COMPILE_OVFL                    = 322;
fl_REPLACE_FUNCTION_NUM            = 323;
fl_CALC_CONST_NUM                  = 324;
fl_USE_EAX                         = 325;
fl_USE_EBX                         = 326;
fl_USE_ECX                         = 327;
fl_USE_EDX                         = 328;
fl_USE_ESP                         = 329;
fl_USE_EBP                         = 330;
fl_USE_ESI                         = 331;
fl_USE_EDI                         = 332;
fl_MAX_REPLACE_LEVEL               = 333;
fl_LENGTH_CODE                     = 334;
fl_PACKAGE_COMPILE_LAST_ADDR       = 335;
fl_PRECOMPILED_LAST_ADDR           = 336;

{Internal Function}
 fl_SQR     =     15;       //          {flAddNameFunction}
 fl_SQRT =        16;       //          {flAddNameFunction}
 fl_LN =          17;       //          {flAddNameFunction}
 fl_EXP =         18;       //+    {flAddNameFunction,flGet}
 fl_LOG2 =        19;       //          {flAddNameFunction}
 fl_LOG10 =       20;       //          {flAddNameFunction}
 fl_SIN =         35;       //          {flAddNameFunction}
 fl_COS =         36;       //          {flAddNameFunction}
 fl_TAN =         37;       //          {flAddNameFunction}
 fl_COTAN =       38;       //          {flAddNameFunction}
 fl_ARCSIN =      39;       //+    {flAddNameFunction,flGet}
 fl_ARCCOS =      40;       //+    {flAddNameFunction,flGet}
 fl_ARCTAN =      41;       //          {flAddNameFunction}
 fl_ARCCOTAN =    42;       //          {flAddNameFunction}
 fl_SINH =        43;       //+    {flAddNameFunction,flGet}
 fl_COSH =        44;       //+    {flAddNameFunction,flGet}
 fl_TANH =        45;       //+    {flAddNameFunction,flGet}
 fl_COTANH =      46;       //+    {flAddNameFunction,flGet}
 fl_ARCSINH =     47;       //+    {flAddNameFunction,flGet}
 fl_ARCCOSH =     48;       //+    {flAddNameFunction,flGet}
 fl_ARCTANH =     49;       //+    {flAddNameFunction,flGet}
 fl_ARCCOTANH =   50;       //+    {flAddNameFunction,flGet}
 fl_ABS =         51;       //          {flAddNameFunction}
 fl_TRUNC =       52;       //          {flAddNameFunction}
 fl_LOGN =        53;       //+    {flAddNameFunction,flGet}
 fl_FACTORIAL =   55;       //+    {flAddNameFunction,flGet}
 fl_POWER =       59;       //          {flAddNameFunction}
 fl_ROOT =        60;       //          {flAddNameFunction}
 fl_IPOWER =      56;       //        {flGet}
 fl_FPOWER =      54;       //        {flGet}
 fl_FROOT =       61;       //        {flGet}
 fl_IROOT =       62;       //        {flGet}


type
TAddFuncStruct = record
                  addr:  Pointer;
                   Arg:  Cardinal;
              CallType:  Cardinal;
               ArgType:  Cardinal;
           ArgTypeList:  Pointer;
            ClearStack:  Cardinal;
                 Arrow:  Cardinal;
               DeepFPU:  Cardinal;
                Set_ID:  Cardinal;
               Id_Func:  Cardinal;
               SaveReg:  Cardinal;
            CodeInline:  Pointer;
              SizeCode:  Cardinal;
                //ArgAdr:  TArrayI;  //   - fl_PRECOMPILED
                  end;

type
PFloatType = Foreval_Main.PFloatType;   {?}
type
TFloatType = Foreval_Main.TFloatType;   {?}
type
PIntegType = Foreval_Main.PIntegType;   {?}
type
TArrayS = Foreval_Main.TArrayS;   {?}
type
PArrayI = Foreval_Main.PArrayI;
type
TSetFunction = record
                Func: TFunction;
                Addr: TAddress;
               end;

type
TArraySt = array of String;
type
   PInternalVar = ^TInternalVar;
   TInternalVar = record
                Variable: Extended;
                Name:  String;
                Next:  PInternalVar;
               end;
type
TAddress = Foreval_Main.TAddress;


 type TForevalDll = class(TForevalH) end;



 procedure FreeCmplFuncList;
 procedure FreeFunction(Func: Cardinal);





 procedure  flSet(Mode,Value1,Value2: Integer);  stdcall;
 procedure  flCompile(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; Ptr: Pointer; var Addr: Pointer);         stdcall;
 procedure  flCompileDiff(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF};  N: Cardinal; var Addr: Pointer);     stdcall;
 procedure  flSetDiffVar(NName: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});                                      stdcall;
 procedure  flSetDiffExpr(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});                                      stdcall;
 procedure  flDiffExpr(N: Cardinal);                                                                               stdcall;
 procedure  flCompileDiffExpr(var Addr: Pointer);                                                                  stdcall;
 procedure  flPerform(act,subj: Cardinal);                                                                         stdcall;
 procedure  flSetFunction(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; FAdr: Pointer; var ID: Cardinal);     stdcall;
 procedure  flAddNameFunction(Code: Cardinal; NName: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});              stdcall;
 procedure  flGetErrorString(var S:{$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});                     stdcall;
 procedure  flGetDiffString(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; N: Cardinal; var S: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}); stdcall;
 procedure  flGetErrorCode(var ECode: Cardinal); stdcall;
 procedure  flSetVar(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF};  ExAddr: Pointer; VType: Cardinal);      stdcall;
 procedure  flSetParam(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; Ptr: Pointer; VType: Cardinal);             stdcall;
 procedure  flGet(What,Func: Cardinal; var Get: Cardinal);               stdcall;
 procedure  flResultS(Addr: Pointer; var Res: Single);       stdcall;
 procedure  flResultD(Addr: Pointer; var Res: Double);       stdcall;
 procedure  flResultE(Addr: Pointer; var Res: Extended);     stdcall;
 procedure  flResult(Addr: Pointer);     stdcall;



 function ArrayIToStr(P: Pointer): String;
 function PtrToStr(P: Pointer): String;


var
 DF: array of TCompFunc;
 Foreval: TForevalDll;
 ExtLibException: TExternalException; //  
 _STRINGTYPE: Integer;
 PkgData: TArrayPkg;
 PkgExpr: String;
 PkgLastAddr: Cardinal;
 F_PkgCmpl,F_PCEr: Boolean;
 VSI,ATL,CVA: TArrayI;
 F_CurrentIntFunc: Cardinal; // -  fl_PRECOMPILED
 InternalVarList, BInternalVarList: PInternalVar;
 E_Code: Integer;
 Func: TAddFuncStruct;
 IDF1: Cardinal;
 ForevD: TForevalD_Custom;
 S_DiffExpr: String;




implementation
(*
NOTE:
    Foreval    (Pointer)    : String, PChar, AnsiString, TArrayI
   : PtrToStr, StrToPtr.


String variables in procedures Foreval are transferred through pointers (Pointer) and can have types: String, PChar, AnsiString, TArrayI
Their conversion is fulfilled by procedures: PtrToStr, StrToPtr.
*)



function ArrayIToStr(P: Pointer): String;
 var
   S: String;
   L,i: Integer;
   AI:  PArrayI;
begin
  AI:=@TArrayI(P);
  L:=AI^[0];

  S:='';
  for i:= 1 to L do
   begin
     S:=S+chr(AI^[i]);
   end;

  ArrayIToStr:=Copy(S,1,Length(S));
end;


function StrToArrayI(S: String):Pointer;
var
L,i: Integer;
AI: TArrayI;
begin
 L:=Length(S);
 SetLength(VSI,L+1);
 VSI[0]:=L;
 for i:= 1 to L do
   begin
     VSI[i]:=Integer(S[i]);
   end;

 StrToArrayI:=@VSI[0];
end;


function PtrToStr(P: Pointer): String;
var
S: String;
begin
 if _STRINGTYPE = fl_STRING then S:=String(P)
 else
 if  _STRINGTYPE = fl_PCHAR then S:=String(PChar(P))
 else
 if  _STRINGTYPE = fl_ANSISTRING then S:=String(AnsiString(P))
 else
 if _STRINGTYPE = fl_STRING_INTERNAL then S:=ArrayIToStr(P);

 PtrToStr:=Copy(S,1,Length(S));
end;


function StrToPtr(S: String): Pointer;
begin
 if _STRINGTYPE = fl_STRING then StrToPtr:=Pointer(S)
 else
 if _STRINGTYPE = fl_PCHAR  then StrToPtr:=PChar(S)
 else
 if _STRINGTYPE = fl_ANSISTRING then  StrToPtr:=PAnsiString(S)
 else
 if _STRINGTYPE = fl_STRING_INTERNAL then StrToPtr:=StrToArrayI(S);
end;


procedure DeleteSpace(S: String; var S1: String);
var i: Integer;
begin
i:=Length(S);

 while i >= 1 do
 begin
    if S[i] = ' ' then
   begin
    Delete(S,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S,1,Length(S));
end;



procedure FreeCmplFuncList;
var
i: Integer;
begin
For i:=1 to Length(DF)-1 do
 begin
  if DF[i].Func.ICode <> 0 then
  Foreval.FreeExtFunc(DF[i].Func);
 end;
end;


procedure FreeFunction(Func: Cardinal);
label 1;
var
i: Integer;
begin
 //. -
 For i:=0 to High(DF) do
 begin
  if Func = DF[i].Func.ICode then
  begin
   Foreval.FreeExtFunc(DF[i].Func);
   DF[i].Func.ICode:=0;
   goto 1;
  end;
 end;
 // -
  Foreval.DeleteFunc:=Func;

1:
end;


procedure PackageCompile;
var
CFunc: TFunction;
Attr: TAttrib;
begin
 Attr.Adr:=0;
 Attr.RType:=0;
 Attr.Shift:=0;
 Delete(PkgExpr,Length(PkgExpr),1); //& - 
 Foreval.PackageCompile:=True;     //    SetExtExpression
 Foreval.SetPkgData(PkgData);
 Foreval.SetExtExpression(PkgExpr,Attr,CFunc);

 if CFunc.ICode <> 0 then
 begin
  SetLength(DF,Length(DF)+1);
  DF[High(DF)].Func:=CFunc;
  DF[High(DF)].XchBrSDeep:=Foreval.XchBrSDeep;
  DF[High(DF)].XchBrNXch:=Foreval.XchBrNXch;
  DF[High(DF)].DinLoadSDeep:=Foreval.DinLoadSDeep;
  DF[High(DF)].DinLoadNMem:=Foreval.DinLoadNMem;
  if Foreval.DinLoadOverFlow = True then DF[High(DF)].DinLoadOverFlow:=1
  else DF[High(DF)].DinLoadOverFlow:=0;
  DF[High(DF)].CmplSDeep:=Foreval.CmplMaxStack;
  if Foreval.CmplOverFlow = True then
  DF[High(DF)].CmplOverFlow:=1
  else DF[High(DF)].CmplOverFlow:=0;
  DF[High(DF)].CopyStackXch:=Foreval.CopyStackXch;
  DF[High(DF)].CalcConst:=Foreval.CalcConst;
  DF[High(DF)].MaxReplaceLevel:=Foreval.MaxReplaceLevel;
 end;

 PkgLastAddr:=CFunc.ICode;
 F_PkgCmpl:=False;
 PkgExpr:='';
 PkgData:=nil;
end;




procedure    pcGetFuncVarName(S: String; var FN: String; var VNS: TArraySt);
var                                        //S=Func(x1,x2,...,xn)
  i,N,P,L: Integer;
begin
 VNS:=nil;
 N:=pos('(',S);
 if N <> 0  then
 begin
  FN:=Copy(S,1,N-1);   P:=N+1; L:=Length(S);
  for i := N+1 to L - 1 do
  begin
   if S[i] = ',' then begin  SetLength(VNS,Length(VNS)+1); VNS[High(VNS)]:=Copy(S,P,i-P); P:=i+1; end;
  end;
  SetLength(VNS,Length(VNS)+1); VNS[High(VNS)]:=Copy(S,P,L-P);
 end
 else
 begin
   E_Code:=fl_ERROR_AT_ADDITION_FUNCTION;
 end;

end;


procedure pcFindVar(S: String; NV: String; P: Integer;  var Bl: Boolean; var NNV: String);
var
i,LV,LS: Integer;
begin
LV:=Length(NV);
LS:=Length(S);
Bl:=False;
if (P = 1) and (LV = LS) then Bl:=True
else
if P = 1 then
begin
 if (S[P+LV] = '+') or (S[P+LV] = '-') or (S[P+LV] = '/') or
    (S[P+LV] = '*') or (S[P+LV] = '^') or (S[P+LV] = '!') or (S[P+LV] = '[') then
    begin
      Bl:=True;
    end;
end
else
if P = LS-LV+1  then
begin
  if (S[P-1] = '+') or  (S[P-1] = '-') or (S[P-1] = '*')  or
     (S[P-1] = '/') or  (S[P-1] = '^')   then
   begin
     Bl:=True;
   end;
end
else
if ((S[P-1] = '(')  or  (S[P-1] = '{') or (S[P-1] = '[')  or
    (S[P-1] = '+')  or  (S[P-1] = '-') or (S[P-1] = '*')  or
    (S[P-1] = '/')  or  (S[P-1] = '^') or (S[P-1] = '|')  or
    (S[P-1] = ',')  or  (S[P-1] = '=') or (S[P-1] = '<')  or (S[P-1] = '>'))
    and
   ((S[P+LV] = '+') or (S[P+LV] = '-') or (S[P+LV] = '/') or
    (S[P+LV] = '*') or (S[P+LV] = '^') or (S[P+LV] = '!') or
    (S[P+LV] = ')') or (S[P+LV] = ']') or (S[P+LV] = '}') or
    (S[P+LV] = '|') or (S[P+LV] = '[') or (S[P+LV] = ',') or
    (S[P+LV] = '=') or (S[P+LV] = '<') or (S[P+LV] = '>'))
    then
   begin
     Bl:=True;
   end;


if Bl = True then begin NNV:=NV+'#'+IntToStr(F_CurrentIntFunc); end;
//F_CurrentIntFunc -  -  fl_PreCompiled

end;


function pcPosN(S: String; FS: String; P: Integer): Integer;
label 1, endp;
var
 N,i,j,L,LFS: Integer;
begin
L:=Length(S);
LFS:=Length(FS);
pcPosN:=0;
for i := P to L do
begin
    for j := 1 to LFS do
    begin
    //  !!
      if Foreval.VarShift = False then
      begin
       if LowerCase(S[i+j-1]) <> LowerCase(FS[j]) then  goto 1
      end
      else
       if (S[i+j]) <> (FS[j]) then  goto 1;
    end;
    pcPosN:=i; goto endp;
1:
end;

endp:
end;


procedure pcSetIntVar(VNS: TArraySt; ATL: TArrayI);
var
FD1,FD2: PInternalVar;
LS,LL,i: Integer;
SN,SV,num: String;
Bl: Boolean;
begin

LS:=Length(VNS); LL:=Length(ATL);
//LS=LL!!!
SetLength(CVA,LS);
for i := 0 to LS-1 do
begin
  new(FD1); FD1^.Next:=nil;
  FD1^.Name:=Copy(LowerCase(VNS[i]),1,Length(VNS[i]))+'#'+IntToStr(F_CurrentIntFunc);
  flSetVar({$IFDEF STRING}FD1^.Name{$ELSE}Pointer(FD1^.Name){$ENDIF},@FD1^.Variable,ATL[i]{fl_Extended});
  CVA[i]:=TAddress(@FD1^.Variable);
  InternalVarList^.Next:=FD1;
  InternalVarList:=FD1;
end;

end;




procedure pcFreeIntVar;
var
FD1,FD2: PInternalVar;
begin

FD1:=BInternalVarList;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;

end;



procedure pcSetFunc(VNS: TArraySt; S: String; var SF: String);
label 1;
var
 P,i,L,BP: Integer;
 NNV,S1: String;
 Bl: Boolean;
 SN: String;
begin

 pcSetIntVar(VNS,ATL);

 L:=Length(VNS);

 for i:=0 to L-1  do
 begin
  P:=1; BP:=1;
1:
  P:=pcPosN(S,VNS[i],BP);  // G_int1:=i;   : 
  if P <> 0 then
  begin
    pcFindVar(S,VNS[i],P,Bl,NNV);
    if Bl = True then
    begin
      Delete(S,P,Length(VNS[i]));
      Insert(NNV,S,P);
      BP:=P+Length(NNV);
    end
    else
    BP:=BP+1;
    goto 1;
  end;

 end;

 SF:=Copy(S,1,Length(S));
end;




procedure flSet(Mode,Value1,Value2: Integer);
begin
if mode = fl_ENABLE then
begin
  if value1 =  fl_SYNTAX_EXTENSION    then Foreval.SyntaxExtension:=True   else
  if value1 =  fl_EXTERNAL_EXCEPTION  then Foreval.ExternalException:=True else
  if value1 =  fl_SHOW_EXCEPTION      then begin Foreval.ShowException:=True; ForevD.ShowException:=True; end else
  if value1 =  fl_VAR_NAME_SHIFT      then begin Foreval.VarShift:=True;  ForevD.VarShift:=True;  end           else
  if value1 =  fl_FUNC_NAME_SHIFT     then begin Foreval.FuncShift:=True; ForevD.FuncShift:=True; end           else
  if value1 =  fl_CALC_CONST          then Foreval.CalcConstant:=True      else
  if value1 =  fl_SAVE_EAX            then Foreval.SetReg(1,1)             else
  if value1 =  fl_SAVE_EBX            then Foreval.SetReg(2,1)             else
  if value1 =  fl_SAVE_ECX            then Foreval.SetReg(3,1)             else
  if value1 =  fl_SAVE_EDX            then Foreval.SetReg(4,1)             else
  if value1 =  fl_SAVE_ESP            then Foreval.SetReg(5,1)             else
  if value1 =  fl_SAVE_EBP            then Foreval.SetReg(6,1)             else
  if value1 =  fl_SAVE_ESI            then Foreval.SetReg(7,1)             else
  if value1 =  fl_SAVE_EDI            then Foreval.SetReg(8,1)             else
  if value1 =  fl_CORRECT_POWER       then Foreval.CorrectIPWR:=1          else
  if value1 =  fl_DINAMIC_LOAD        then Foreval.DinamicLoadOptimization:=1 else
  if value1 =  fl_EXCHANGE_BRANCH     then Foreval.TreeOptimization:=1     else
  if value1 =  fl_GLOBAL_OPTIMIZATION then Foreval.GlobalOptimization:=True else
  if value1 =  fl_SET_ID              then Foreval.SetF(7,Value1,1)        else
  if value1 =  fl_CLST                then Foreval.SetF(10,Value1,1)       else
  if value1 =  fl_CLOSE_ARG           then Foreval.CloseArg:=True          else
  if value1 =  fl_PACKAGE_COMPILE     then F_PkgCmpl:=True                 else
  if value1 =  fl_TRIG_OPTIMIZATION   then Foreval.SpecTrigOptim:=1        else
  if value1 =  fl_HYP_OPTIMIZATION    then Foreval.SpecHYPOptim:=1;

end
else
if mode = fl_DISABLE then
begin
  if value1 =  fl_SYNTAX_EXTENSION    then Foreval.SyntaxExtension:=False   else
  if value1 =  fl_EXTERNAL_EXCEPTION  then Foreval.ExternalException:=False else
  if value1 =  fl_SHOW_EXCEPTION      then begin Foreval.ShowException:=False; ForevD.ShowException:=False; end else
  if value1 =  fl_VAR_NAME_SHIFT      then begin Foreval.VarShift:=False;  ForevD.VarShift:=False;  end           else
  if value1 =  fl_FUNC_NAME_SHIFT     then begin Foreval.FuncShift:=False; ForevD.FuncShift:=False; end           else
  if value1 =  fl_CALC_CONST          then Foreval.CalcConstant:=False      else
  if value1 =  fl_SAVE_EAX            then Foreval.SetReg(1,0)              else
  if value1 =  fl_SAVE_EBX            then Foreval.SetReg(2,0)              else
  if value1 =  fl_SAVE_ECX            then Foreval.SetReg(3,0)              else
  if value1 =  fl_SAVE_EDX            then Foreval.SetReg(4,0)              else
  if value1 =  fl_SAVE_ESP            then Foreval.SetReg(5,0)             else
  if value1 =  fl_SAVE_EBP            then Foreval.SetReg(6,0)             else
  if value1 =  fl_SAVE_ESI            then Foreval.SetReg(7,0)             else
  if value1 =  fl_SAVE_EDI            then Foreval.SetReg(8,0)             else
  if value1 =  fl_CORRECT_POWER       then Foreval.CorrectIPWR:=0           else
  if value1 =  fl_DINAMIC_LOAD        then Foreval.DinamicLoadOptimization:=0 else
  if value1 =  fl_EXCHANGE_BRANCH     then Foreval.TreeOptimization:=0      else
  if value1 =  fl_GLOBAL_OPTIMIZATION then Foreval.GlobalOptimization:=False else
  if value1 =  fl_SET_ID              then Foreval.SetF(7,Value1,0)          else
  if value1 =  fl_CLST                then Foreval.SetF(10,Value1,0)         else
  if value1 =  fl_CLOSE_ARG           then Foreval.CloseArg:=False           else
  if value1 =  fl_PACKAGE_COMPILE     then PackageCompile                    else
  if value1 =  fl_TRIG_OPTIMIZATION   then Foreval.SpecTrigOptim:=0          else
  if value1 =  fl_HYP_OPTIMIZATION    then Foreval.SpecHYPOptim:=0;

end
else
if mode = fl_STRING_TYPE then
begin
 case Value1 of
 fl_STRING:           _STRINGTYPE:=Value1;
 fl_PCHAR:            _STRINGTYPE:=Value1;
 fl_ANSISTRING:       _STRINGTYPE:=Value1;
 fl_STRING_INTERNAL:  _STRINGTYPE:=Value1;
 end;
end
else
if mode = fl_AUTO then
begin
  if value1 =  fl_DINAMIC_LOAD        then Foreval.DinamicLoadOptimization:=2 else
  if value1 =  fl_EXCHANGE_BRANCH     then Foreval.TreeOptimization:=2;
end
else
if  mode =  fl_REPLACE_FUNCTION     then Foreval.SetLevelReplace(value1)
else
if  mode =  fl_STACK_DEEP        then
begin
 if (value1 >= 1) and (value1 <= 8) then
 begin
  Foreval.SetStackDeep(value1);
  Foreval.SaveInStack:=True;
 end
 else
 if value1 = 0 then Foreval.SaveInStack:=False;
end
else
if  mode = fl_PARAM_TYPE then
    case value1 of
    fl_SINGLE:    Foreval.ParamType:=_SINGLE;
    fl_DOUBLE:    Foreval.ParamType:=_DOUBLE;
    fl_EXTENDED:  Foreval.ParamType:=_EXTENDED;
    end
else
if  mode = fl_DATA_TYPE then
    case value1 of
    fl_SINGLE:    Foreval.DataType:=_SINGLE;
    fl_DOUBLE:    Foreval.DataType:=_DOUBLE;
    fl_EXTENDED:  Foreval.DataType:=_EXTENDED;
    end
else
if mode = fl_EXTERNAL_EXCEPTION then
begin
 Foreval.ExtException:=TExternalException(value1);
 ForevD.ExtException:=TExternalException(value1)
end
else
if mode = fl_ADDRESS then Foreval.SetF(2,Value1,Value2)
else
if mode = fl_INLINE then
begin
 if Value2 = 0 then
 begin
  Foreval.SetF(3,Value1,0);
 end
 else
 begin
  Foreval.SetF(3,Value1,1);
  Foreval.SetF(4,Value1,Value2);
 end
end
else
if mode = fl_FUNC_STACK_DEEP then
begin
 if Value2 = fl_UNKNOWN then Value2:=-1;
 Foreval.SetF(5,Value1,Value2);
end
else
if mode = fl_FUNC_ID         then Foreval.SetF(6,Value1,Value2)
else
if mode = fl_NUM_ARG         then Foreval.SetF(8,Value1,Value2)
else
if mode = fl_ARROW           then
begin
 if Value2 = fl_RIGHT then
  Foreval.SetF(9,Value1,0)
 else
 if Value2 = fl_BACK then
  Foreval.SetF(9,Value1,1);
end
else
if mode = fl_ARG_TYPE then
begin
 case Value2 of
  fl_SINGLE:   Foreval.SetF(11,Value1,_Single);
  fl_DOUBLE:   Foreval.SetF(11,Value1,_Double);
  fl_EXTENDED: Foreval.SetF(11,Value1,_Extended);
  fl_INTEGER:  Foreval.SetF(11,Value1,_Integer);
  fl_DIFFER:   Foreval.SetF(11,Value1,_Differ);
 end;
end
else
if mode = fl_ARG_TYPE_LIST then Foreval.SetF(12,Value1,Value2)
else
if mode = fl_SAVE_REG       then Foreval.SetF(13,Value1,Value2)
else
if mode = fl_CALL_TYPE then
begin
 case Value2 of
  fl_MEMORY_EAX:                      Foreval.SetF(14,Value1,-3);
  fl_MEMORY_EBX:                      Foreval.SetF(14,Value1,-4);
  fl_MEMORY_ECX:                      Foreval.SetF(14,Value1,-5);
  fl_MEMORY_EDX:                      Foreval.SetF(14,Value1,-6);
  fl_MEMORY_STACK_CPU:                Foreval.SetF(14,Value1,-7);
  fl_STACK_FPU:                       Foreval.SetF(14,Value1,-8);
  fl_STACK_CPU:                       Foreval.SetF(14,Value1,-10);
  fl_INFINITE_EABX:                   Foreval.SetF(14,Value1,-11);
  fl_INFINITE_EBCX:                   Foreval.SetF(14,Value1,-12);
  fl_INFINITE_ECDX:                   Foreval.SetF(14,Value1,-13);
  fl_INFINITE_STACK_CPU:              Foreval.SetF(14,Value1,-14);
  fl_KERNEL_I:                        Foreval.SetF(14,Value1,1);
  fl_KERNEL_F:                        Foreval.SetF(14,Value1,2);
  fl_KERNEL_FI:                       Foreval.SetF(14,Value1,3);
  fl_KERNEL_FF:                       Foreval.SetF(14,Value1,4);
 end;
end;
end;



procedure  flPerform(act,subj: Cardinal);
begin
  if act = fl_CLEAR then
  begin
   case subj of
    fl_PARAM_LIST:  Foreval.ClearParam;
    fl_VAR_LIST:    Foreval.ClearVar;
    fl_ERROR_CODE:  Foreval.ErrorCode:=0;
   end
  end
  else
  if act = fl_FREE then
  begin
   case subj of
    fl_PARAM_LIST:     Foreval.FreeParam;
    fl_VAR_LIST:       Foreval.FreeVar;
    fl_ADD_FUNC_LIST:  Foreval.FreeAddFunction;
    fl_CMPL_FUNC_LIST: FreeCmplFuncList;
    else
    FreeFunction(subj);
   end;
  end
  else
  if act = fl_CLEAR_NAMES_FUNC then Foreval.ClearNameFunc:=subj;
end;



procedure flCompile(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF};  Ptr: Pointer; var Addr: Pointer);
var
CFunc: TFunction;
PAtr,HPAtr: ^TAttrib;
Atr: TAttrib;
Func: String;
begin
{$IFDEF STRING}
Func:=Expr;
{$ELSE}
Func:=PtrToStr(Expr);
{$ENDIF}

Addr:=nil;

DeleteSpace(Func,Func);

new(PAtr);
 if Ptr = nil then
 begin
  PAtr^.Adr:=0;
  PAtr^.RType:=0;
  PAtr^.Shift:=0;
 end
 else
 begin
  HPAtr:=Ptr;
  case HPAtr^.Adr of
   fl_EAX:        PAtr^.Adr:=1;
   fl_EBX:        PAtr^.Adr:=2;
   fl_ECX:        PAtr^.Adr:=3;
   fl_EDX:        PAtr^.Adr:=4;
   fl_ESP:        PAtr^.Adr:=5;
  else
   PAtr^.Adr:=HPAtr.Adr;
  end;

  case HPAtr^.RType of
   fl_SINGLE:         PAtr^.RType:=_Single;
   fl_INTEGER:        PAtr^.RType:=_Integer;
   fl_DOUBLE:         PAtr^.RType:=_Double;
   fl_EXTENDED:       PAtr^.RType:=_Extended;
  end;

   PAtr^.Shift:=HPAtr^.Shift;
 end;

if F_PkgCmpl = True then
begin
  PkgExpr:=PkgExpr+Func+'&';
  SetLength(PkgData,Length(PkgData)+1);
  PkgData[High(PkgData)].Adr:=PAtr^.Adr;
  PkgData[High(PkgData)].RType:=PAtr^.RType;
  PkgData[High(PkgData)].Shift:=PAtr^.Shift;
end
else
begin
 Foreval.SetExtExpression(Func,PAtr^,CFunc);

 if CFunc.ICode <> 0 then
 begin
  SetLength(DF,Length(DF)+1);
  DF[High(DF)].Func:=CFunc;
  DF[High(DF)].XchBrSDeep:=Foreval.XchBrSDeep;
  DF[High(DF)].XchBrNXch:=Foreval.XchBrNXch;
  DF[High(DF)].DinLoadSDeep:=Foreval.DinLoadSDeep;
  DF[High(DF)].DinLoadNMem:=Foreval.DinLoadNMem;
  if Foreval.DinLoadOverFlow = True then DF[High(DF)].DinLoadOverFlow:=1
  else DF[High(DF)].DinLoadOverFlow:=0;
  DF[High(DF)].CmplSDeep:=Foreval.CmplMaxStack;
  if Foreval.CmplOverFlow = True then
  DF[High(DF)].CmplOverFlow:=1
  else DF[High(DF)].CmplOverFlow:=0;
  DF[High(DF)].CopyStackXch:=Foreval.CopyStackXch;
  DF[High(DF)].CalcConst:=Foreval.CalcConst;
  DF[High(DF)].MaxReplaceLevel:=Foreval.MaxReplaceLevel;
  Addr:=Pointer(CFunc.ICode);
 end;

end;

PAtr:=nil;
end;



procedure flGetErrorCode(var ECode: Cardinal);
var
EC: Cardinal;
begin
ECode:=0;
if Foreval.ErrorCode <> 0 then
begin
 case  Foreval.ErrorCode of
   E_ZeroDivide:                        ECode:=fl_ZERO_DIVIDE;
   E_InvalidOp:                         ECode:=fl_INVALID_OPERATION;
   E_OverFlow:                          ECode:=fl_OVERFLOW;
   E_UnderFlow:                         ECode:=fl_UNDERFLOW;
   E_IntOverFlow:                       ECode:=fl_INT_OVERFLOW;
   E_AccessViolation:                   ECode:=fl_ACCESS_VIOLATION;
   E_OutOfMemory:                       ECode:=fl_OUT_OF_MEMORY;
   E_StackOverFlow:                     ECode:=fl_STACK_OVERFLOW;
   E_UNKNOWN_SYMBOL:                    ECode:=fl_UNKNOWN_SYMBOL;
   E_MISSING_BRACKET_LEFT:              ECode:=fl_MISSING_LEFT_BRACKET;
   E_MISSING_BRACKET_RIGHT:             ECode:=fl_MISSING_RIGHT_BRACKET;
   E_INCOINCIDENCE_NUMBER_ARGUMENTS:    ECode:=fl_WRONG_NUMBER_ARGUMENTS;
   E_MISSING_OPERATION:                 ECode:=fl_MISSING_OPERATION;
   E_MISSING_EXPRESSION:                ECode:=fl_MISSING_EXPRESSION;
   E_UNKNOWN_FUNCTION:                  ECode:=fl_UNKNOWN_FUNCTION;
   E_ERROR_AT_ADDITION_FUNCTION:        ECode:=fl_ERROR_AT_ADDITION_FUNCTION;
   E_NONEXISTENT_FUNCTION:              ECode:=fl_NONEXISTENT_FUNCTION;
   E_INCORRECT_ARGUMENT:                ECode:=fl_INCORRECT_ARGUMENT;
   E_MISSING_ARGUMENT:                  Ecode:=fl_MISSING_ARGUMENT;
  end;
end
else
begin
  ForevD.fdGetSyntaxErrorCode(ECode);
end;
end;





procedure flSetVar(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF};  ExAddr: Pointer; VType: Cardinal);
begin
case VType of
fl_SINGLE:   Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_SINGLE);
fl_INTEGER:  Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_INTEGER);
fl_DOUBLE:   Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_DOUBLE);
fl_EXTENDED: Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_EXTENDED);
fl_ARRAY_DOUBLE: Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_ARRAYD);
fl_ARRAY_EXTENDED: Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_ARRAYE);
fl_ARRAY_SINGLE: Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_ARRAYS);
fl_ARRAY_INTEGER: Foreval.SetNewVar({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},Cardinal(ExAddr),_ARRAYI);
end;

end;



procedure flSetParam(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; Ptr: Pointer; VType: Cardinal);
var
T: Extended;
begin
T:=0;
case VType of
  fl_SINGLE:   T:=Single(Ptr^);
  fl_INTEGER:  T:=Integer(Ptr^);
  fl_DOUBLE:   T:=Double(Ptr^);
  fl_EXTENDED: T:=Extended(Ptr^);
end;
Foreval.Parameter[{$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF}]:=T;
end;






procedure flSetFunction(Name: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; FAdr: Pointer; var ID: Cardinal);
label endp, pcend;
var
Func: TAdditionalFunc;
FuncStruct: TAddFuncStruct;
i,ECode,P,N,ftype,idf: Integer;
TypeL: PArrayI;
TypeC: TCode;
PF: ^TAddFuncStruct;
Arg1,Arg2,CError,CP,adr: Cardinal;
SN,SF: String;
VNS: TArraySt;
CAdr: Pointer;
begin

ECode:=0;  CError:=0;
PF:=FAdr;
FuncStruct:=PF^;

try
Func.Name:=Copy({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF}));
Func.Arg:=FuncStruct.Arg;
Func.Id_Func:=FuncStruct.Id_Func;
Func.NST:=FuncStruct.DeepFPU;
Func.SaveReg:=FuncStruct.SaveReg;
Func.CLST:=0;
Func.Arrow:=0;
Func.Set_ID:=0;

if (FuncStruct.Addr = nil) and (FuncStruct.CodeInline <> nil) and (FuncStruct.SizeCode > 0) then
begin
 Func.addr:=nil;
 Func.inl:=1;
 SetLength(Func.inlCode,FuncStruct.SizeCode);
 TypeC:=TCode(FuncStruct.CodeInline);
 for i:=0 to FuncStruct.SizeCode-1 do
 begin
  Func.inlCode[i]:=TypeC[i];
 end;
end
else
if FuncStruct.Addr <> nil then
begin
 Func.addr:=FuncStruct.Addr;
 Func.inl:=0;
 Func.inlCode:=nil;
end;

if FuncStruct.CallType <> fl_PRECOMPILED then
   if (Func.Addr = nil) and (Func.inl = 0) then  ECode:=E_ERROR_AT_ADDITION_FUNCTION;


if FuncStruct.DeepFPU = fl_UNKNOWN then Func.NST:=-1
else
if FuncStruct.DeepFPU > 8 then ECode:=E_ERROR_AT_ADDITION_FUNCTION;


if FuncStruct.ClearStack = fl_ENABLE then  Func.CLST:=1
 else
 if FuncStruct.ClearStack = fl_DISABLE then Func.CLST:=0
 else
 if (FuncStruct.CallType = fl_MEMORY_STACK_CPU) or (FuncStruct.CallType = fl_STACK_CPU) or
    (FuncStruct.CallType = fl_INFINITE_STACK_CPU)
    then ECode:=E_ERROR_AT_ADDITION_FUNCTION;



if FuncStruct.Arrow = fl_RIGHT then  Func.Arrow:=0
 else
 if FuncStruct.Arrow = fl_BACK then Func.Arrow:=1
 else
 if (FuncStruct.CallType = fl_STACK_CPU) and (FuncStruct.Arg > 1)
 then  ECode:=E_ERROR_AT_ADDITION_FUNCTION;



if  FuncStruct.Set_ID = fl_Enable then Func.Set_ID:=1
 else
 if  FuncStruct.Set_ID = fl_Disable then Func.Set_ID:=0
 else
 if ((FuncStruct.CallType <> fl_KERNEL_I) and (FuncStruct.CallType <> fl_KERNEL_F) and
    (FuncStruct.CallType <> fl_KERNEL_FI) and (FuncStruct.CallType <> fl_KERNEL_FF))
     then ECode:=E_ERROR_AT_ADDITION_FUNCTION;


if ((FuncStruct.CallType <> fl_KERNEL_I) and (FuncStruct.CallType <> fl_KERNEL_F) and
   (FuncStruct.CallType <> fl_KERNEL_FI) and (FuncStruct.CallType <> fl_KERNEL_FF)) then
begin
 case FuncStruct.ArgType of
  fl_SINGLE:         Func.ArgType:=_Single;
  fl_DOUBLE:         Func.ArgType:=_Double;
  fl_EXTENDED:       Func.ArgType:=_Extended;
  fl_INTEGER:        Func.ArgType:=_Integer;
  fl_ARRAY_DOUBLE:   Func.ArgType:=_Integer;
  fl_ARRAY_EXTENDED: Func.ArgType:=_Integer;
  fl_ARRAY_SINGLE:   Func.ArgType:=_Integer;
  fl_ARRAY_INTEGER:  Func.ArgType:=_Integer;
  fl_ADDRESS:        Func.ArgType:=_Address;
  //fl_DIFFER:   Func.ArgType:=_Differ;
 else
 if (FuncStruct.ArgType = fl_DIFFER) or (FuncStruct.ArgTypeList <> nil) then
    Func.ArgType:=_Differ
 else
  ECode:=E_ERROR_AT_ADDITION_FUNCTION;
 end;
 if Func.inl = 1 then  ECode:=E_ERROR_AT_ADDITION_FUNCTION;
end;


if (FuncStruct.ArgType = fl_DIFFER) or (FuncStruct.ArgTypeList <> nil) then
begin
 Func.ArgType:=_Differ;
 SetLength(Func.ArgTypeList,FuncStruct.Arg);
 TypeL:=@TArrayI(FuncStruct.ArgTypeList);

 for i:=0 to FuncStruct.Arg-1 do
  case TypeL^[i] of
   fl_INTEGER:         Func.ArgTypeList[i]:=_Integer;
   fl_DOUBLE:          Func.ArgTypeList[i]:=_Double;
   fl_EXTENDED:        Func.ArgTypeList[i]:=_Extended;
   fl_SINGLE:          Func.ArgTypeList[i]:=_Single;
   fl_ARRAY_DOUBLE:    Func.ArgTypeList[i]:=_Integer;
   fl_ARRAY_EXTENDED:  Func.ArgTypeList[i]:=_Integer;
   fl_ARRAY_SINGLE:    Func.ArgTypeList[i]:=_Integer;
   fl_ARRAY_INTEGER:   Func.ArgTypeList[i]:=_Integer;
   fl_ADDRESS:         Func.ArgTypeList[i]:=_Address;
  else
   ECode:=E_ERROR_AT_ADDITION_FUNCTION
  end;
end;


if ((FuncStruct.CallType = fl_INFINITE_EABX) or (FuncStruct.CallType = fl_INFINITE_EBCX) or
   (FuncStruct.CallType = fl_INFINITE_ECDX) or (FuncStruct.CallType = fl_INFINITE_STACK_CPU)) then
   begin
     case FuncStruct.ArgType of
       fl_SINGLE:  ;
       fl_DOUBLE:   ;
       fl_EXTENDED: ;
       fl_INTEGER:  ;
     else
     ECode:=E_ERROR_AT_ADDITION_FUNCTION;
     end;
   end;


if FuncStruct.CallType = fl_MEMORY_EAX               then Func.FType:=-3
else
if FuncStruct.CallType = fl_MEMORY_EBX               then Func.FType:=-4
else
if FuncStruct.CallType = fl_MEMORY_ECX               then Func.FType:=-5
else
if FuncStruct.CallType = fl_MEMORY_EDX               then Func.FType:=-6
else
if FuncStruct.CallType = fl_MEMORY_STACK_CPU         then Func.FType:=-7
else
if FuncStruct.CallType = fl_STACK_FPU                then Func.FType:=-8
else
if FuncStruct.CallType = fl_STACK_CPU                then Func.FType:=-10
else
if FuncStruct.CallType = fl_INFINITE_EABX            then Func.FType:=-11
else
if FuncStruct.CallType = fl_INFINITE_EBCX            then Func.FType:=-12
else
if FuncStruct.CallType = fl_INFINITE_ECDX            then Func.FType:=-13
else
if FuncStruct.CallType = fl_INFINITE_STACK_CPU       then Func.FType:=-14
else
if FuncStruct.CallType = fl_MEMORY_ADDRESSES         then Func.FType:=-15
else
if FuncStruct.CallType = fl_PRECOMPILED              then Func.FType:=-16
else
if FuncStruct.CallType = fl_KERNEL_I                 then Func.FType:=1
else
if FuncStruct.CallType = fl_KERNEL_F                 then Func.FType:=2
else
if FuncStruct.CallType = fl_KERNEL_FI                then Func.FType:=3
else
if FuncStruct.CallType = fl_KERNEL_FF                then Func.FType:=4
else
ECode:=E_ERROR_AT_ADDITION_FUNCTION;

if ((FuncStruct.CallType = fl_KERNEL_I) or (FuncStruct.CallType = fl_KERNEL_F) or
   (FuncStruct.CallType = fl_KERNEL_FI) or (FuncStruct.CallType = fl_KERNEL_FF))  then
   begin
    if (FuncStruct.CallType = fl_KERNEL_I) or (FuncStruct.CallType = fl_KERNEL_F) then
     Func.Arg:=1
    else
    if (FuncStruct.CallType = fl_KERNEL_FI) or (FuncStruct.CallType = fl_KERNEL_FF) then
     Func.Arg:=2;
    if FuncStruct.DeepFPU = fl_UNKNOWN then ECode:=E_ERROR_AT_ADDITION_FUNCTION;
   end;


if  (FuncStruct.CallType = fl_STACK_FPU)  and (FuncStruct.Arg < 1)
 then ECode:=E_ERROR_AT_ADDITION_FUNCTION;



if (FuncStruct.CallType = fl_STACK_FPU)  and
   ((FuncStruct.Arg > 8) or (FuncStruct.Arg < 1))  then
   ECode:=E_ERROR_AT_ADDITION_FUNCTION;


if FuncStruct.CallType = fl_PRECOMPILED then
begin
  Foreval.ErrorCode:=0;
  E_Code:=0;

  P:=Pos('=',Func.Name);
  SN:=Copy(Func.Name,1,P-1);
  SF:=Copy(Func.Name,P+1,Length(Func.Name)-P+1);

  if (SF = '') or (SN = '') then begin ECode:=E_ERROR_AT_ADDITION_FUNCTION; Foreval.ErrorCode:=ECode; goto pcend; end;

  pcGetFuncVarName(SN,SN,VNS);
  if E_Code <> 0  then begin ECode:=E_Code; Foreval.ErrorCode:=ECode; goto pcend; end;

  Func.Arg:=Length(VNS);
  SetLength(ATL,Func.Arg);


  if (FuncStruct.ArgType = fl_DIFFER) or (FuncStruct.ArgTypeList <> nil) then
  begin
      //ATL:=TypeL^;
      TypeL:=@TArrayI(FuncStruct.ArgTypeList);
      Func.ArgType:=_Differ;
      SetLength(Func.ArgTypeList,Func.Arg);
      for i:=0 to Func.Arg-1 do
      begin
       case TypeL^[i] of
        fl_INTEGER:         Func.ArgTypeList[i]:=_Integer;
        fl_DOUBLE:          Func.ArgTypeList[i]:=_Double;
        fl_EXTENDED:        Func.ArgTypeList[i]:=_Extended;
        fl_SINGLE:          Func.ArgTypeList[i]:=_Single;
        fl_ARRAY_DOUBLE:    Func.ArgTypeList[i]:=_Integer;
        fl_ARRAY_EXTENDED:  Func.ArgTypeList[i]:=_Integer;
        fl_ARRAY_SINGLE:    Func.ArgTypeList[i]:=_Integer;
        fl_ARRAY_INTEGER:   Func.ArgTypeList[i]:=_Integer;
        fl_ADDRESS:         Func.ArgTypeList[i]:=_Address;
       else
       ECode:=E_ERROR_AT_ADDITION_FUNCTION;
       end;
       ATL[i]:=TypeL^[i];
      end;
  end
  else
  for I := 0 to Func.Arg - 1 do
    begin
      ATL[i]:=FuncStruct.ArgType;
    end;


  pcSetFunc(VNS,SF,SF);
  inc(F_CurrentIntFunc);

  if ECode = 0 then
   flCompile({$IFDEF STRING}SF{$ELSE}Pointer(SF){$ENDIF},0,CAdr);



  flGetErrorCode(CError);
  Func.addr:=CAdr;
  if CError = 0 then
  begin
     flGet(fl_COMPILE_OVFL,Cardinal(CAdr),CP);
     if CP = fl_YES then  Func.NST:=-1
     else
     if CP = fl_NO  then
     begin
      flGet(fl_COMPILE_STACK_DEEP,Cardinal(CAdr),CP);
      Func.NST:=CP;
     end;


     N:=Length(CVA);
     if N <> Func.Arg then   ECode:=E_ERROR_AT_ADDITION_FUNCTION;

     SetLength(Func.ArgAdr,N);

     for i:=0 to N-1 do
     begin
       Func.ArgAdr[i]:=CVA[i];
     end;

     // ( )  -    
     Foreval.FindFunc(SN,idf,ftype,adr);
     if idf <> -1 then
     begin
      if ftype = -16 then  //fl_PreCompiled
      begin
        flPerform(fl_CLEAR_NAMES_FUNC,idf);
        flPerform(fl_FREE,adr);
      end;
     end;
  end;
  Func.Name:=Copy(SN,1,Length(SN));

pcend:
end;

except
on E:  EAccessViolation do ECode:=E_ERROR_AT_ADDITION_FUNCTION;
end;



if ECode <> 0 then
begin
 Foreval.ErrorCode:=E_ERROR_AT_ADDITION_FUNCTION;
 Foreval.SyntaxErrorString:={$IFDEF STRING}Name{$ELSE}PtrToStr(Name){$ENDIF};
 Foreval.CalcException;
end
else
if CError = 0 then
Foreval.AddNewFunction(Func,ID);
endp:
end;




procedure flAddNameFunction(Code: Cardinal; NName: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});
begin
{$IFDEF STRING}Foreval.AddNewFuncName[Code]:=NName;{$ELSE}Foreval.AddNewFuncName[Code]:=PtrToStr(NName);{$ENDIF}

{$IFDEF STRING}ForevD.fdAddNewNameFunction(Foreval.GetFuncName(Code),NName);{$ELSE} ForevD.fdAddNewNameFunction(Foreval.GetFuncName(Code),PtrToStr(NName));{$ENDIF}

end;



procedure flGetErrorString(var S: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});
var
S1: String;
begin
S1:=Foreval.SyntaxErrorString;
if S1 = '' then  S1:= ForevD.SyntaxErrorString;

S:={$IFDEF STRING}S1{$ELSE}StrToPtr(S1){$ENDIF};
end;







procedure FindDiffExt(S: String;  var SC: String);
label 1,2,endp;
var
i,L,P1,P2,LA,br,DP,n1,n2,N,K: Integer;            //@diff(expr,n,difvar)
S1,S2,S3,S4: String;
addrF,addrV: Cardinal;
ptr: Pointer;
VType: Integer;
begin

2:
DP:=Pos('@diff',S);
if DP = 0 then goto endp;

N:=DP+6;
L:=Length(S);
br:=1;
P1:=0;
P2:=0;
for i := N to L - 1 do
begin
 if S[i] = '(' then inc(br) else
 if S[i] = ')' then dec(br);

 if (S[i] = ',') and (br = 1) and (P1 = 0) then P1:=i else
 if (S[i] = ',') and (br = 1) and (P1 <> 0) and (P2 = 0) then P2:=i;


 if (P1 <> 0) and (P2 <> 0) and (br = 1) and (S[i+1] = ')')  then
 begin
   LA:=i; goto 1;
 end;

end;

1:
S1:=Copy(S,N,P1-N);
S2:=Copy(S,P1+1,P2-P1-1);
S3:=Copy(S,P2+1,LA-P2);



Foreval.GetVarAdr({ForevD.DiffVar}S3,AddrV,VType);
flCompile({$IFDEF STRING}S1{$ELSE}StrToPtr(S1){$ENDIF},0,ptr);
if ptr = nil then goto endp;
addrF:=Cardinal(ptr);

K:=StrToInt(S2);

Delete(S,DP,LA-N+8);

if K = 1 then S4:='diff1('+IntToStr(addrF)+','+IntToStr(addrV)+','+InttoStr(VType)+')' else
if K = 2 then S4:='diff2('+IntToStr(addrF)+','+IntToStr(addrV)+','+InttoStr(VType)+')' else
if K = 3 then S4:='diff3('+IntToStr(addrF)+','+IntToStr(addrV)+','+InttoStr(VType)+')' else
//if K = 4 then S3:='diff4('+IntToStr(addrF)+','+IntToStr(addrV)+','+InttoStr(VType)+')' else
              S4:='diffn('+IntToStr(addrF)+','+IntToStr(addrV)+','+InttoStr(VType)+','+S2+')';


Insert(S4,S,DP);

goto 2;

endp:
SC:=S;
end;








procedure  flCompileDiff(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; N: Cardinal; var Addr: Pointer);
label endp;
var
Func,SDiff: String;
EC: Cardinal;
begin
 {$IFDEF STRING}
  Func:=Expr;
 {$ELSE}
  Func:=PtrToStr(Expr);
 {$ENDIF}

  DeleteSpace(Func,Func);

ForevD.SyntaxError:=0;
ForevD.SyntaxErrorString:='';

ForevD.fdDiffExpr(Func, N, SDiff);
FindDiffExt(SDiff,SDiff);
flGetErrorCode(EC);
if EC <> 0 then goto endp;


if ForevD.SyntaxError = 0 then
begin
 flCompile({$IFDEF STRING}SDiff{$ELSE}StrToPtr(SDiff){$ENDIF},0,Addr);
end;


endp:
end;




procedure  flSetDiffExpr(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});
var
Func: String;
begin
 {$IFDEF STRING}
  Func:=Expr;
 {$ELSE}
  Func:=PtrToStr(Expr);
 {$ENDIF}

 DeleteSpace(Func,Func);
 S_DiffExpr:=Copy(Func,1,Length(Func));
end;




procedure  flDiffExpr(N: Cardinal);
label endp;
var
SDiff: String;
EC: Cardinal;
begin
ForevD.SyntaxError:=0;
ForevD.SyntaxErrorString:='';

ForevD.fdDiffExpr(S_DiffExpr, N, SDiff);
flGetErrorCode(EC);
if EC <> 0 then goto endp;

if ForevD.SyntaxError = 0 then
begin
 S_DiffExpr:=Copy(SDiff,1,Length(SDiff));
end;

endp:
end;





procedure  flCompileDiffExpr(var Addr: Pointer);
label endp;
var
SDiff: String;
EC: Cardinal;
begin
Addr:=nil;
FindDiffExt(S_DiffExpr,SDiff);
flGetErrorCode(EC);
if EC <> 0 then goto endp;

if ForevD.SyntaxError = 0 then
begin
 flCompile({$IFDEF STRING}SDiff{$ELSE}StrToPtr(SDiff){$ENDIF},0,Addr);
end;

endp:
end;




procedure flGetDiffString(Expr: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF}; N: Cardinal; var S: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});
label endp;
var
Func,SDiff: String;
EC: Cardinal;
begin
{$IFDEF STRING}
  Func:=Expr;
 {$ELSE}
  Func:=PtrToStr(Expr);
 {$ENDIF}

  DeleteSpace(Func,Func);

ForevD.SyntaxError:=0;
ForevD.SyntaxErrorString:='';

ForevD.fdDiffExpr(Func, N, SDiff);
FindDiffExt(SDiff,SDiff);
flGetErrorCode(EC);
if EC <> 0 then goto endp;

S:={$IFDEF STRING}SDiff{$ELSE}StrToPtr(SDiff){$ENDIF};
endp:
end;




procedure flSetDiffVar(NName: {$IFDEF STRING}String{$ELSE}Pointer{$ENDIF});
begin
{$IFDEF STRING}ForevD.fdSetDiffVar(NName);{$ELSE} ForevD.fdSetDiffVar(PtrToStr(NName));{$ENDIF}
end;



procedure  flGet(What,Func: Cardinal; var Get: Cardinal);
label 1,endp;
var
i,C: Integer;
begin
//   - (Func)
if What = fl_ADDRESS then Get:=Foreval.GetF(2,Func)
else
if What = fl_INLINE then
begin
 if Foreval.GetF(3,Func) = 1 then Get:=fl_ENABLE
 else
 if Foreval.GetF(3,Func) = 0 then Get:=fl_DISABLE;
end
else
if What = fl_FUNC_STACK_DEEP then
begin
 if Foreval.GetF(5,Func) = -1 then Get:=fl_UNKNOWN
 else
 Get:=Foreval.GetF(5,Func);
end
else
if What = fl_FUNC_ID         then Get:=Foreval.GetF(6,Func)
else
if What = fl_SET_ID          then
begin
 if Foreval.GetF(7,Func) = 1 then Get:=fl_ENABLE
 else
 if Foreval.GetF(7,Func) = 0 then Get:=fl_DISABLE
end
else
if What = fl_NUM_ARG         then Get:=Foreval.GetF(8,Func)
else
if What = fl_ARROW           then
begin
 if Foreval.GetF(9,Func) = 0 then Get:=fl_RIGHT
 else
 if Foreval.GetF(9,Func) = 1 then Get:=fl_BACK;
end
else
if What = fl_CLST            then
begin
 if Foreval.GetF(10,Func) = 1 then Get:=fl_ENABLE
 else
 if Foreval.GetF(10,Func) = 0 then Get:=fl_DISABLE
end
else
if What = fl_ARG_TYPE          then
begin
 case Foreval.GetF(11,Func) of
  _SINGLE:   Get:=fl_SINGLE;
  _DOUBLE:   Get:=FL_DOUBLE;
  _EXTENDED: Get:=fl_EXTENDED;
  _INTEGER:  Get:=fl_INTEGER;
  _DIFFER:   Get:=fl_DIFFER;
 end;
end
else
if What = fl_SAVE_REG        then Get:=Foreval.GetF(13,Func)
else
if What = fl_CALL_TYPE       then
begin
  case Foreval.GetF(14,Func)  of
  -3:                                   Get:=fl_MEMORY_EAX;
  -4:                                   Get:=fl_MEMORY_EBX;
  -5:                                   Get:=fl_MEMORY_ECX;
  -6:                                   Get:=fl_MEMORY_EDX;
  -7:                                   Get:=fl_MEMORY_STACK_CPU;
  -8:                                   Get:=fl_STACK_FPU;
  -10:                                  Get:=fl_STACK_CPU;
  -11:                                  Get:=fl_INFINITE_EABX;
  -12:                                  Get:=fl_INFINITE_EBCX;
  -13:                                  Get:=fl_INFINITE_ECDX;
  -14:                                  Get:=fl_INFINITE_STACK_CPU;
  1:                                    Get:=fl_KERNEL_I;
  2:                                    Get:=fl_KERNEL_F;
  3:                                    Get:=fl_KERNEL_FI;
  4:                                    Get:=fl_KERNEL_FF;
 end;
end
else
// - (Func)
begin
 For i:=0 to High(DF) do
 begin
  if Func = DF[i].Func.ICode then
  begin
   C:=i;
   goto 1;
  end;
 end;

  Foreval.ErrorCode:=E_NONEXISTENT_FUNCTION;
  Foreval.SyntaxErrorString:=IntToStr(Func);
  Foreval.CalcException;
  goto endp;

1:
 case What of
  fl_EXCHANGE_BRANCH_STACK_DEEP:   Get:=DF[C].XchBrSDeep;
  fl_EXCHANGE_BRANCHE_NUM:         Get:=DF[C].XchBrNXch;
  fl_DINAMIC_LOAD_STACK_DEEP:      Get:=DF[C].DinLoadSDeep;
  fl_DINAMIC_LOAD_NUM:             Get:=DF[C].DinLoadNMem;
  fl_DINAMIC_LOAD_OVFL:            begin
                                    if DF[C].DinLoadOverFlow = 1 then Get:=fl_YES
                                    else
                                    if DF[C].DinLoadOverFlow = 0 then Get:=fl_NO;
                                   end;
  fl_COMPILE_STACK_DEEP:           Get:=DF[C].CmplSDeep;
  fl_COMPILE_OVFL:                 begin
                                    if DF[C].CmplOverFlow = 1 then Get:=fl_YES
                                    else
                                    if DF[C].CmplOverFlow = 0 then Get:=fl_NO;
                                   end;
  fl_REPLACE_FUNCTION_NUM:         Get:=DF[C].CopyStackXch;
  fl_MAX_REPLACE_LEVEL:            Get:=DF[C].MaxReplaceLevel;
  fl_CALC_CONST_NUM:               Get:=DF[C].CalcConst;
  fl_LENGTH_CODE:                  Get:=Cardinal(@DF[C].Func.Code[High(DF[C].Func.Code)])-DF[C].Func.ICode;
  fl_USE_EAX:                      if Foreval.UseReg[1] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_EBX:                      if Foreval.UseReg[2] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_ECX:                      if Foreval.UseReg[3] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_EDX:                      if Foreval.UseReg[4] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_ESP:                      if Foreval.UseReg[5] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_EBP:                      if Foreval.UseReg[6] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_ESI:                      if Foreval.UseReg[7] = 1 then Get:=fl_YES else Get:=fl_NO;
  fl_USE_EDI:                      if Foreval.UseReg[8] = 1 then Get:=fl_YES else Get:=fl_NO;
 end;
end;

if What = fl_VERSION        then
begin
 if What = fl_MAJOR          then Get:=8;
 if What = fl_MINOR          then Get:=4;
 if What = fl_RELEASE        then Get:=16;
end
else
if What = fl_ABOUT        then Get:=Cardinal(StrToPtr('Math compiler -Foreval-'))
else
if What = fl_AUTHOR       then Get:=Cardinal(StrToPtr('SOREL CopyRight (C) Russia S.-Petersburg'))
else
if What = fl_PACKAGE_COMPILE_LAST_ADDR then Get:=PkgLastAddr;

endp:
end;





procedure  flResultS(Addr: Pointer; var Res: Single);       stdcall;
asm
  call Addr
  fstp dword ptr [Res]
end;

procedure  flResultD(Addr: Pointer; var Res: Double);       stdcall;
asm
  call Addr
  fstp qword ptr [Res]
end;


procedure  flResultE(Addr: Pointer; var Res: Extended);     stdcall;
asm
  call Addr
  fstp tbyte ptr [Res]
end;




procedure  flResult(Addr: Pointer);       stdcall;
asm
  call Addr
end;


procedure InitFuncStruct(var Func: TAddFuncStruct);
begin
   Func.addr:=0;
   Func.Arg:=0;
   Func.CallType:=0;
   Func.ArgType:=0;
   Func.ArgTypeList:=0;
   Func.ClearStack:=fl_DISABLE;
   Func.Arrow:=fl_RIGHT;
   Func.DeepFPU:=fl_UNKNOWN;
   Func.Set_ID:=fl_DISABLE;
   Func.Id_Func:=0;
   Func.SaveReg:=0;
   Func.CodeInline:=0;
   Func.SizeCode:=0;
end;




function _fdDiff1(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  _fdDiff1:=ForevD.fdDiff1(Func,PV,VType);
end;

function _fdDiff2(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  _fdDiff2:=ForevD.fdDiff2(Func,PV,VType);
end;

function _fdDiff3(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  _fdDiff3:=ForevD.fdDiff3(Func,PV,VType);
end;

function _fdDiff4(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  _fdDiff4:=ForevD.fdDiff4(Func,PV,VType);
end;
{
function fdDiff5(Func,PV: TAddress;  VType: Integer): TFloatType; stdcall;
begin
  fdDiff5:=Derivative5(Func,PV,VType);
end; }

function _fdDiffN(Func,PV: TAddress;  VType: Integer; N: Integer): TFloatType; stdcall;
begin
  _fdDiffN:=ForevD.fdDiffN(Func,PV,VType,N);
end;


initialization
begin
 Foreval:=TForevalDll.Create;
 SetLength(DF,1);
 _STRINGTYPE:=fl_STRING;
 //_STRINGTYPE:=fl_PChar;
 //_STRINGTYPE:=fl_AnsiString;
 F_PkgCmpl:=False;
 F_CurrentIntFunc:=0;
 new(InternalVarList);
 BInternalVarList:=InternalVarList;




 //ForevalD
 ForevD:=TForevalD_Custom.Create;
 ForevD.ShowException:=False;
 ForevD.VarShift:=False;
 ForevD.FuncShift:=False;
 ForevD.fdCreateDiff;
 //ForevD.DiffVar:='x';

 flAddNameFunction(fl_COTAN,{$IFDEF STRING}'cot'{$ELSE}StrToPtr('cot'){$ENDIF});
 flAddNameFunction(fl_ARCSIN,{$IFDEF STRING}'asin'{$ELSE}StrToPtr('asin'){$ENDIF});
 flAddNameFunction(fl_ARCCOS,{$IFDEF STRING}'acos'{$ELSE}StrToPtr('acos'){$ENDIF});
 flAddNameFunction(fl_ARCTAN,{$IFDEF STRING}'atan'{$ELSE}StrToPtr('atan'){$ENDIF});
 flAddNameFunction(fl_ARCCOTAN,{$IFDEF STRING}'acot'{$ELSE}StrToPtr('acot'){$ENDIF});
 flAddNameFunction(fl_COTANH,{$IFDEF STRING}'coth'{$ELSE}StrToPtr('coth'){$ENDIF});
 flAddNameFunction(fl_ARCSINH,{$IFDEF STRING}'asinh'{$ELSE}StrToPtr('asinh'){$ENDIF});
 flAddNameFunction(fl_ARCCOSH,{$IFDEF STRING}'acosh'{$ELSE}StrToPtr('acosh'){$ENDIF});
 flAddNameFunction(fl_ARCTANH,{$IFDEF STRING}'atanh'{$ELSE}StrToPtr('atanh'){$ENDIF});
 flAddNameFunction(fl_ARCCOTANH,{$IFDEF STRING}'acoth'{$ELSE}StrToPtr('acoth'){$ENDIF});


 InitFuncStruct(Func);
 Func.addr:=@_fdDiff1;
 Func.Arg:=3;
 Func.ArgType:=fl_Integer;
 Func.CallType:=fl_STACK_CPU;
 Func.DeepFPU:=fl_UNKNOWN;
 Func.ClearStack:=fl_DISABLE;
 Func.Arrow:=fl_RIGHT;
 flSetFunction({$IFDEF STRING}'diff1'{$ELSE}StrToPtr('diff1'){$ENDIF},@Func,IDF1);
 Func.addr:=@_fdDiff2;
 flSetFunction({$IFDEF STRING}'diff2'{$ELSE}StrToPtr('diff2'){$ENDIF},@Func,IDF1);
 Func.addr:=@_fdDiff3;
 flSetFunction({$IFDEF STRING}'diff3'{$ELSE}StrToPtr('diff3'){$ENDIF},@Func,IDF1);
 Func.addr:=@_fdDiff4;
 flSetFunction({$IFDEF STRING}'diff4'{$ELSE}StrToPtr('diff4'){$ENDIF},@Func,IDF1);
 Func.Arg:=4;
 Func.addr:=@_fdDiffN;
 flSetFunction({$IFDEF STRING}'diffn'{$ELSE}StrToPtr('diffn'){$ENDIF},@Func,IDF1);


end;



finalization
begin


FreeCmplFuncList;
DF:=nil;
pcFreeIntVar;
Foreval.Destroy;
end;


end.
