object HelpD: THelpD
  Left = 350
  Top = 250
  BorderStyle = bsDialog
  Caption = 'Help'
  ClientHeight = 610
  ClientWidth = 426
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'Tahoma'
  Font.Style = []
  OldCreateOrder = False
  Position = poDesigned
  PixelsPerInch = 96
  TextHeight = 13
  object Memo1: TMemo
    Left = 8
    Top = 8
    Width = 410
    Height = 593
    Color = clBtnFace
    Font.Charset = ANSI_CHARSET
    Font.Color = clWindowText
    Font.Height = -11
    Font.Name = 'Tahoma'
    Font.Style = []
    Lines.Strings = (
      '(I) Integrals with const limits:['#8747'x], ['#8747#8747'xy], ['#8747#8747#8747'xyz]'
      ''
      
        '     b                  b    d                        b    d    ' +
        'g'
      '     '#8747'dxF0(x);    '#8747'dx'#8747'dyF0(x,y);      '#8747'dx'#8747'dy'#8747'dzF0(x,y,z);    '
      
        '    a                  a     c                       a     c    ' +
        'f'
      ''
      
        '    limits are brought in red registers: [a], [b], [c], [d], [f]' +
        ', [g]'
      ''
      '    e=partitions (100 by default)'
      ''
      ''
      ''
      '(II) Multiple integral with const. limits: ['#8747'...'#8747']; '
      '      variables - y1,y2,...'
      '      down limits - array: Xs'
      '      upper limits - array: Ys'
      '       '
      '      Ys[0]  Ys[1]   Ys[n-1]'
      '      '#8747'dy1  '#8747'dy2...'#8747'dynF0(y1,y2,...yn)             '
      '      Xs[0]  Xs[1]   Xs[n-1]'
      ''
      '     e=partitions (30 by default)'
      '          '
      ''
      
        '                                                                ' +
        '     F    F '
      '(III) Multiple integral with variables  limits: ['#8747'...'#8747']; '
      
        '      name of variables - y1,y2,...                 F    F      ' +
        '      '
      
        '     Limits are consistently put into the list of functions (Fi-' +
        '>F[i]);'
      ''
      '     F2     F4       F2n'
      '     '#8747'dy1'#8747'dy2...'#8747'dynF0(y1,y2,...yn)          e=partitions '
      '     F1    F3        F2n-1'
      ''
      '     Note: '
      
        '     F1,F2 = F(y1);  F3,F4=F(y1,y2);........  F2n-1,F2n=F(y1,y2,' +
        '...,yn);'
      ''
      '     e=partitions (30 by default)'
      ''
      '                                   x'
      '     Example:  F(x,a)= '#8747'exp(-x^2/a)dx'
      '                                  0'
      '     Rename x->y1'
      
        '     To save:                                                   ' +
        '                                                      '
      
        '        number:  a -> [A]                                       ' +
        '                                                 '
      
        '        expressions:  exp(-y1^2/a)->F[0];  0 -> F[1];  y1 -> F[2' +
        '];  '
      '                                     F   F'
      '      to type '#8216'x'#8217' ;  push ['#8747'..'#8747'] '
      
        '                                     F   F                      ' +
        '      '
      ''
      ''
      ''
      '(IV) Sums with const limits: ['#931'n], ['#931'n'#931'k], ['#931'n'#931'k'#931'm]'
      ''
      '      n=b        n=b  k=d                  n=b   k=d  m=g'
      
        '      '#8721'F0(x,n),    '#8721'    '#8721' F0(X,n,k),       '#8721'       '#8721'      '#8721' F0(x' +
        ',n,k,m)'
      '      n=a        n=a  k=c                   n=a  k=c   m=f'
      ''
      
        '     limits are brought in red registers: [a], [b], [c], [d], [f' +
        '], [g]'
      ''
      ''
      ' '
      '                                                    F      F'
      '(V) Sum with variables  limits:   ['#931'....'#931']'
      '                                                    F      F'
      ''
      '     name of  variables - n1,n2,...'
      
        '      Limits are consistently put into the list of functions (Fi' +
        '->F[i]);'
      ''
      '     n1=F2 n2=F4    nn=F2n '
      '        '#8721'       '#8721'  .......   '#8721' F0(x,n1,n2,...,nn)'
      '     n1=F1 n2=F3    nn=F2n-1'
      ''
      ''
      ''
      
        '                                                          F     ' +
        'F'
      '(VI) Product with variables  limits:   ['#1055'....'#1055']'
      
        '                                                          F     ' +
        'F'
      ''
      '      name of variables - n1,n2,...'
      
        '      Limits are consistently put into the list of functions (Fi' +
        '->F[i]);'
      ''
      '      n1=F2 n2=F4    nn=F2n '
      '         '#1055'       '#1055'  .......   '#1055' F0(x,n1,n2,...,nn)'
      '      n1=F1 n2=F3    nn=F2n-1'
      ''
      ''
      ''
      
        '(VII) The ordinary differential equations: [DE(1)], [DE(n)] - or' +
        'ders'
      '    specification: '
      
        '       (n)          (n-1)                                       ' +
        '                                '
      
        '     y    = F0(y,  ....., y,x);                                 ' +
        '             (n-1) '
      
        '     Xs[0]=x0;  Ys[0]=y(x0),Ys[0]=y'#39'(x0),....,Ys[n-1]=y(x0); F[0' +
        ']=F0;'
      '        '
      '    symbols:'
      '    y1(y'#39'), y2(y"), y3, y4 ,...'
      ''
      '    example (n=3): '
      '    y'#39#39#39'-5*y*y"+x*y'#39'-y*exp(x)=0;  y(1)=-1; y'#39'(1)=2; y"(1)=0;  '
      
        '    F[0] =   5*y*y"-x*y'#39'+y*exp(x) ; or (it same)   5*y*y2-x*y1+y' +
        '*exp(x)'
      '    Ys[0] = -1; Ys[1] = 2; Ys[2] = 0; Xs[0] = 1;'
      ''
      
        '    Note: the equation order is equal to number of units in the ' +
        'array Ys'
      '   '
      
        '    In [e] It is possible to bring step (0,0001 - by default ) (' +
        'for all DE)'
      ''
      ''
      ''
      
        '(VIII) System of    differential equations (first order)[DES(1)]' +
        '      '
      ''
      '      y1'#39'=F0(y1,...,yn,x)          ->F[0]'
      '      ................................    '
      '      yn'#39'=Fn-1(y1,...,yn,x)       ->F[n-1]'
      '    '
      '       Ys[0]=y1(x0);...;Ys[n-1]=yn(x0); Xs[0]=x0;'
      '       '
      '       Result (y1(x),...,yn(x)) ->Xs '
      ''
      
        '      F0,F1,F2,F3,F4,... - Functions are written in appropriate ' +
        'strings of array F'
      '                                     (List of functions - F[i])'
      '     Example:'
      '                     y1'#8217'=4*y2-2*y1;               y1(0)=-7;'
      '                     y2'#8217'=3*y2-y1+3*x^2;       y2(0)=-1,75;'
      '                     '
      '                      4*y2-2*y1->F[0]'
      '                      3*y2-y1+3*x^2->F[1]'
      '                      Xs[0]=0; Ys[0]=-7; Ys[1]=-1,75; '
      ''
      
        '      Note: Dimension of system is equal to number of the entere' +
        'd functions'
      '              (List  of functions)'
      ''
      
        '       In [e] It is possible to bring step (0,0001 - by default ' +
        ') (for all DE)'
      ''
      '       F0 - everywhere main function ->F[0]'
      ''
      ''
      ''
      
        '(IX)  [Root F] - finds  roots on a interval  (function - F0) on ' +
        'interval [a,b]'
      '            result->Xs'
      
        '       f - scanning step: xr:=xr+f;                             ' +
        '                      f=0.01 '
      
        '       e - exactitude of roots: | F0(xr)| < e  (also for [ROOT])' +
        '        e=1e-10'
      
        '       g - min. difference between  nearest roots |xr1-xr2| < g;' +
        '    g=1e-6 '
      '                 '
      
        '       [Root F'#39'] - finds  roots of derivaives (extrema)  (functi' +
        'on - F0) '
      '                    '
      
        '       [Root 1/F] - finds roots of  function 1/F0 (ruptupe of fu' +
        'nction F0) '
      
        '                                   (example: tan(x), x=pi/2*(2*k' +
        '+1))'
      ''
      
        '       [root 1/F'#8217'] - finds roots of  function 1/F0'#8217' (break point' +
        's of function F0) '
      
        '                                        (example: asin(cos(x)), ' +
        'x=pi*k)'
      ''
      
        '       [Upoints] -  points of local minima (concavity) of functi' +
        'on '
      ''
      
        '       ['#1055'points] -  points of local maxima (convexity) of functi' +
        'on                 '
      ''
      ''
      ''
      '(X) [SPL3] - create cubic splain Ys(Xs); data in Ys, Xs'
      '       Note: function with splain: splain'
      '      '
      
        '        [F->SPL3] -Creates a cubic spline of function F0(x) on i' +
        'nterval [a,b];  '
      
        '                         in  [e]  number of partitions of a inte' +
        'rval   (By default - 100)'
      ''
      '       '
      ''
      '(XI) ['#8747'Ys(Xs)] - integration of splain (data in arrays: Ys, Xs)'
      '                         '
      ''
      ''
      '(XII)  [F(Xs)->Ys] fills array Ys: Ys[i]=F0(Xs[i])'
      ''
      ''
      ''
      'Build-in functions (in bracket - addition names) : '
      
        '  sin, cos, tan(tg), cotan(ctg,cot), arcsin(asin), arccos(acos),' +
        '  '
      
        '  arctan(arctg), arccotan(arcctg,arccot,acot) sinh(sh), cosh(ch)' +
        ', tanh(th), '
      '  cotanh(cth,coth), arcsinh(arcsh,asinh), arccosh(arcch,acosh), '
      
        '  arctanh(arcth), arccotanh(arccth,arccoth), sqrt, sqr, ln, exp,' +
        ' lg(log10), '
      
        '  abs, log2(lg2),fact, trunc, frac, sign(sgn), rad(DegToRad), de' +
        'g(RadToDeg)'
      
        '  power, log(logn), root, if, splain(spl3), max, min, sum, sumq,' +
        ' avr, norm, len'
      ''
      '  note: function '#39'if'#39' have types:'
      
        '  if(arg1 op arg2,arg3,arg4)   works as:  if  arg1 op  arg2  the' +
        'n arg3 else arg4'
      
        '  if(arg1 op arg2,arg3)            works as:  if  arg1 op  arg2 ' +
        ' then arg3 else 0'
      
        '  if(arg1 op arg2)                    works as:  if  arg1 op  ar' +
        'g2  then 1 else 0'
      
        '  where '#39'op'#39': '#39'='#39'    '#39'<>'#39'    '#39'>'#39'    '#39'<'#39'    '#39'<='#39'    '#39'=<'#39'    '#39'>='#39' ' +
        '   '#39'=>'#39' '
      ''
      '  function with splain: splain'
      ''
      
        '  function with arrays Xs,Ys:   sum, sumq, prod, avr, max, min, ' +
        'len, norm'
      ''
      
        '  function with list of data:       sum, sumq, prod, avr, max, m' +
        'in, norm'
      ''
      '  Operators: +  -  /   *  ^   ! '
      '  Brackets: ( ) ; [ ] - trunc; { } - frac; | | -  abs;'
      ''
      '  Main argument - x'
      
        '  other variables: a,b,c,d,e,f,g  are brought in [A], [B], [C], ' +
        '[D], [E], [F], [G]'
      ''
      ''
      '  example of expressions: '
      
        '               root(a*x+b,n)*Xs[n]^y+[x/y]*splain(|x-1|)*sum(Ys)' +
        '/n!'
      
        '                      where |x-1|  should is in a define area of' +
        ' splain  '
      ''
      
        '              if(x<a,x^2,if(x=a,x^3,x^4))*max(sh(x),ch(x),min(x/' +
        'a,max(Xs)))')
    ParentFont = False
    ReadOnly = True
    ScrollBars = ssVertical
    TabOrder = 0
  end
end
