unit UMHCFS;
{                                                                              }
{        SOREL(R)   CopyRight(C)    Russia, S.-Petersburg.                     }
{                                                                              }
{                  calculator         MHC-FS2     ver 1.1    rev.7             }
{                                          build 110                           }
{                            e-mail: delphimanx@rambler.ru                     }
{                            web: http://dmanx.narod.ru;                       }
{                            web: http://mhcfs2.sourceforge.net                }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ComCtrls, ExtCtrls, DBCtrls, Buttons, Math,
  ThFortFunc, ThFlash, Foreval_Lib, Clipbrd, OpenML, LSE, MatrixCalc, Data;

const rPI: extended = 3.14159265358979323846264/180;
const dPI: extended = 180/3.14159265358979323846264;

const DRS = 999;

type
  TString1 = String[1];

type
  TString5 = String[5];

type
 TStack  = record
            X:    TFloat;
            COP:  Integer;    //1(+),2(-),3(*),4(/),5(^,logn,Cmn)
            Pr:   Integer;    //1(+,-),2(*,/),3(^,logn,Cmn)
            Br:   Integer;
           end;





type
  TForm1 = class(TForm)



    SBsum: TSpeedButton;
    Panel3: TPanel;
    Panel2: TPanel;
    Stdrg: TStaticText;
    StFH: TStaticText;
    Stsig: TStaticText;
    SBFH: TSpeedButton;
    SBsig: TSpeedButton;
    SBdrg: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    SBsub: TSpeedButton;
    SBmul: TSpeedButton;
    SBdvd: TSpeedButton;
    SBpoint: TSpeedButton;
    SB9: TSpeedButton;
    SB3: TSpeedButton;
    SB6: TSpeedButton;
    SB8: TSpeedButton;
    SB7: TSpeedButton;
    SBneg: TSpeedButton;
    SB2: TSpeedButton;
    SB5: TSpeedButton;
    SB4: TSpeedButton;
    SBC: TSpeedButton;
    SB1: TSpeedButton;
    SBeq: TSpeedButton;
    SB0: TSpeedButton;
    SBprc: TSpeedButton;
    SB1x: TSpeedButton;
    SBln: TSpeedButton;
    SBsin: TSpeedButton;
    SBcos: TSpeedButton;
    SBtg: TSpeedButton;
    SBctg: TSpeedButton;
    SBA: TSpeedButton;
    SBB: TSpeedButton;
    StA: TStaticText;
    StB: TStaticText;
    StC: TStaticText;
    SBeq2: TSpeedButton;
    SBsqr: TSpeedButton;
    SBxy: TSpeedButton;
    SBlogxy: TSpeedButton;
    SBxS: TSpeedButton;
    SBxM: TSpeedButton;
    SBSxS: TSpeedButton;
    SBMxM: TSpeedButton;
    SBSx: TSpeedButton;
    SBMx: TSpeedButton;
    SBSC: TSpeedButton;
    SBxplusM: TSpeedButton;
    StS: TStaticText;
    StM: TStaticText;
    StV: TStaticText;
    Stbr: TStaticText;
    DRG: TLabel;
    Lth: TLabel;
    Lcth: TLabel;
    Lash: TLabel;
    Lach: TLabel;
    Lath: TLabel;
    Lacth: TLabel;
    LMHC1S: TLabel;
    StHrs: TStaticText;
    StTime: TStaticText;
    StMns: TStaticText;
    T1: TTimer;
    SBesc: TSpeedButton;
    SBCE: TSpeedButton;
    SBarrow: TSpeedButton;
    SBb1: TSpeedButton;
    SBb2: TSpeedButton;
    SBdms: TSpeedButton;
    T2: TTimer;
    LF: TLabel;
    StFx: TStaticText;
    SBFunc: TSpeedButton;
    STFunc: TStaticText;
    L_FE: TLabel;
    LS: TLabel;
    SBD: TSpeedButton;
    SBis2: TSpeedButton;
    SBis1: TSpeedButton;
    SBE: TSpeedButton;
    StD: TStaticText;
    StE: TStaticText;
    ImMH: TImage;
    ST_ST: TStaticText;
    Image1: TImage;
    SBF: TSpeedButton;
    SBG: TSpeedButton;
    SBis3: TSpeedButton;
    SBspl: TSpeedButton;
    Image2: TImage;
    Image5: TImage;
    Image7: TImage;
    Image8: TImage;
    SBXSy: TSpeedButton;
    SBSyXSy: TSpeedButton;
    SBSyX: TSpeedButton;
    SBSyC: TSpeedButton;
    SBXsYs: TSpeedButton;
    SBLse: TSpeedButton;
    SBfx: TSpeedButton;
    SBi3f: TSpeedButton;
    SBi2F: TSpeedButton;
    SBData: TSpeedButton;
    STF: TStaticText;
    STG: TStaticText;
    StSy: TStaticText;
    StFS: TStaticText;
    Image12: TImage;
    Image6: TImage;
    Image9: TImage;
    Image19: TImage;
    Image10: TImage;
    Image11: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Label15: TLabel;
    Image17: TImage;
    Image18: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    Image25: TImage;
    Image26: TImage;
    Image27: TImage;
    Image28: TImage;
    Image29: TImage;
    Image30: TImage;
    Image31: TImage;
    Image32: TImage;
    Image34: TImage;
    Image35: TImage;
    Image36: TImage;
    Image37: TImage;
    Image3: TImage;


    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SB0Click(Sender: TObject);
    procedure SB1Click(Sender: TObject);
    procedure SB2Click(Sender: TObject);
    procedure SB3Click(Sender: TObject);
    procedure SB4Click(Sender: TObject);
    procedure SB5Click(Sender: TObject);
    procedure SB6Click(Sender: TObject);
    procedure SB7Click(Sender: TObject);
    procedure SB8Click(Sender: TObject);
    procedure SB9Click(Sender: TObject);
    procedure SBsumClick(Sender: TObject);
    procedure SBsubClick(Sender: TObject);
    procedure SBmulClick(Sender: TObject);
    procedure SBdvdClick(Sender: TObject);
    procedure SBeqClick(Sender: TObject);
    //procedure SBdigClick(Sender: TObject);
   



    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBdmsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBprcMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBsqrMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBxyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBctgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBtgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBcosMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBsinMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBeq2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB1xMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBlnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBlogxyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);


    procedure CalcExMath(S: String; NF:Integer = 1; NF1: Integer = 0; D: Integer = 0);
    procedure InsertFuncClp;
    procedure EFKeyInput(key: Integer; ud: Integer; sh: Integer);
    procedure CopyToRSD;
    procedure CopyToRSyD;
    procedure ERROR;
    procedure TRLERROR;
    procedure SBdmsClick(Sender: TObject);
    procedure WMVar(V: TFloat);
    procedure WEVar(E: TFloat);
    procedure OutVar(OV: TFloat);
    procedure XchPointA(S: String; var S1: String);
    procedure ShowVar;
    procedure WSMVar(S: String);
    procedure WSEVar;
    procedure NewNum;
    procedure NewNumA;
    procedure Sum;
    procedure Dvd;
    procedure Mul;
    procedure Sub;
    function  arcsh(X: TFloat): TFloat;
    function  Root(X,Y: TFloat):TFloat;
    function  LogN(X,Y: TFloat):TFloat;
    procedure XtoY;
    procedure XRootY;
    function  arcch(x: TFloat): TFloat;
    function  Qroot(x: TFloat): TFloat;
    function  Quad(x: TFloat): TFloat;
    function  Cnm: TFloat;
    procedure logxy;
    function  Factor(x: TFloat): TFloat;
    function  arccth(x: TFloat): TFloat;
    function  DToR(x: TFloat): TFloat;
    function  GToR(X:TFloat): TFloat;
    function  RToD(x: TFloat): TFloat;
    function  RToG(x: TFloat): TFloat;
    function  ch(x: TFloat): TFloat;
    function  sh(x: TFloat): TFloat;
    function  sinus(x: TFloat): TFloat;
    function  cosinus(x: TFloat): TFloat;
    function  ArcCosinus(X: TFloat): TFloat;
    function  Tang(x:TFloat):TFloat;
    function  CTang(x:TFloat):TFloat;
    function  ArcTang(x:TFloat):TFloat;
    function  ArcSinus(x:TFloat):TFloat;
    function  Aver:TFloat;
    function  MaxXs:TFloat;
    function  MinXs:TFloat;
    function  MulXs:TFloat;
    function  NumXs:TFloat;
    procedure SortMinXs;
    procedure SortMaxXs;
    function  CorXY:TFloat;
    function  ArcCTang(x:TFloat):TFloat;
    function  th(x: TFloat):TFloat;
    function  cth(x: TFloat):TFloat;
    function  Qsum:TFloat;
    function  SigN:TFloat;
    function  SigN1:TFloat;
    function  SumS:TFloat;
    function  Lne(x: TFloat):TFloat;
    function  QR12: TFloat;
    function  arcth(x:TFloat): TFloat;
    procedure Eq2;
    function  DMS(x: TFloat): TFloat;
    procedure SBnegClick(Sender: TObject);
    procedure SBpointClick(Sender: TObject);
    procedure SBescClick(Sender: TObject);
    procedure SBCEClick(Sender: TObject);
    procedure SBarrowClick(Sender: TObject);
    procedure WriteVar;
    procedure FormCreate(Sender: TObject);
    procedure SetFH;
    procedure SBFHClick(Sender: TObject);
    procedure SBAClick(Sender: TObject);
    procedure SBBClick(Sender: TObject);
    procedure SBCClick(Sender: TObject);
    procedure SBxMClick(Sender: TObject);
    procedure SBMxClick(Sender: TObject);
    procedure SBMxMClick(Sender: TObject);
    procedure SBxplusMClick(Sender: TObject);
    procedure SBSCClick(Sender: TObject);
    procedure SBxSClick(Sender: TObject);
    procedure SBSxClick(Sender: TObject);
    procedure SBSxSClick(Sender: TObject);
    procedure SBXSyClick(Sender: TObject);
    procedure SBSyXClick(Sender: TObject);
    procedure SBSyXSyClick(Sender: TObject);
    procedure SBSyCClick(Sender: TObject);
    procedure SBb1Click(Sender: TObject);
    procedure SBb2Click(Sender: TObject);
    procedure SBdrgClick(Sender: TObject);
    procedure SBsigClick(Sender: TObject);
    procedure SBxyClick(Sender: TObject);
    procedure SBsqrClick(Sender: TObject);
    procedure SBprcClick(Sender: TObject);
    procedure SBcosClick(Sender: TObject);
    procedure SBtgClick(Sender: TObject);
    procedure SBctgClick(Sender: TObject);
    procedure SBsinClick(Sender: TObject);
    procedure SBlnClick(Sender: TObject);
    procedure SB1xClick(Sender: TObject);
    procedure SBlogxyClick(Sender: TObject);
    procedure SBeq2Click(Sender: TObject);
    procedure T1Timer(Sender: TObject);
    procedure T2Timer(Sender: TObject);
    procedure SBFuncClick(Sender: TObject);
    procedure AddFunction(S: String);
    procedure SetFunctionA;
    procedure ViewerL;
    procedure ViewerR;
    procedure DelFuncSymbol;
    procedure SBeqMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBddxClick(Sender: TObject);
    //function Diff1(x: TFloat): TFloat;
    //procedure CreateFunc;
    procedure SBDClick(Sender: TObject);
    procedure SBEClick(Sender: TObject);
    procedure SBFClick(Sender: TObject);
    procedure SBGClick(Sender: TObject);
    procedure SBAMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBBMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBCMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBDMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBEMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBddxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBis1Click(Sender: TObject);
    procedure SBis1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBis2Click(Sender: TObject);
    procedure SBis2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
      procedure SBi3fClick(Sender: TObject);
    procedure SBis3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBfxClick(Sender: TObject);
    procedure SBi2fClick(Sender: TObject);
    procedure SBis3fClick(Sender: TObject);

   procedure  SetFunction(NF:Integer = 1; NF1: Integer = 0; D: Integer = 0);
   procedure  ComplFunc(S: String; var Adr: Pointer; var Er: Cardinal);
   procedure  FreeFunc(Adr: TAddress);
   procedure  PushOp(Cop: Integer; Pr: Integer);
   procedure  OutStack;
   procedure  Equal;
   procedure  InitStack;
   procedure  incs;
   procedure  decs;
   procedure  CalcOp;
   procedure  CalcBr;
    procedure SB0MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SBXsYsClick(Sender: TObject);
    procedure SBsplClick(Sender: TObject);
    procedure SBLseClick(Sender: TObject);
    procedure SBLseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBDataClick(Sender: TObject);
    procedure SBsplMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBXsYsMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB7MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB9MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBsumMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB5MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB6MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBsubMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBdvdMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function ToDeg: TFloatType;
    function ToDRG(x: TFloatType): TFloatType;
    procedure SBi2FMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBi3fMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    function  ToFloat(S: String): TFloat;
    procedure XchPoint(const S: String; var S1: String);
    procedure SB4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SB3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBmulMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);


  private

      //MN -   
      //EN -   
      //ES -    (String)
      //SN -    (0,1)
      //SE -      (0,1)
      //cRS - . -   Xs
      //cRSy - . -   Ys
      //FE -  . 
      //FF -  .  ( '.')
      //FNN -   
      //FSP -   ('.') = TRUE
      //FSE -   ('=') = TRUE
      //FER -   (TRUE)
      //FRS -    Xs (TRUE)
      //FRSy -    Ys (TRUE)
      //FEO -   (-  ')'   'A','B','C',..,'M')
      //FTF  - true     (. -)
      //FOP -  
      //DIG - -  
      //FSD1,FSD2 -   
      MN, EN, CInt, CFl, CTN, SN, SE, R_M,
      Con_E, Con_Pi, R_X1, R_X2, Sdms,
      MAX_NUM, MIN_NUM : TFloat;
      ES, SS, CSV: String;
      COP: String[5];
      FNN, FSP, FF, FE, FSE, FER, FRS, FRSy, FEO, FSS,FOP, FSH, FSD1,FSD2, FSD3: Boolean;
      FIF,FIFD: Boolean;
      LeN, LeS, {LeRS,DRS, cRS, LeRSy, cRSy,} Br, DIG, {cFP, cFS, LeFS,} S_Len,S_Top: Integer;
      FH, Sig, RX12, smd, Stime: String[1];
      Hrs, Mns, FFF: String[2];
      GRD: String[4];

      //R_Ys: array of extended;

      BN: array[0..99] of TFloat;
      BC: array[1..99] of String[5];



  public
    R_X, R_Y, V_X, V_Y, V_Z, V_T, V_Y1, V_Y2, V_Y3, V_PI, R_A, R_B, R_C, R_D, R_E, R_F, R_G, F_F, F_G,
    F_A, F_B, F_C, F_D, F_E,P_A,P_B,P_C,P_D,P_E, V_Y4, V_Y5,V_Y6,V_Y7,V_Y8,V_Y9,V_Y10: TFloat;
    R_Xs,R_Ys: array[0..DRS] of TFloat;
    F_S : array [0..DRS] of String;
    PC_S: array of String;
    V_N,V_K,V_M: Integer;
    LeRS,{DRS,}cRS,LeFS,LeRSy,cRSy,cFS,cFP: Integer;
    D_Xs, D_Ys, D_XA, D_YA: TArrayF;//array of extended;
    FTF: Boolean;
    SFunc, reg: String;
    C_Func,C_Func1,C_Func2,C_Func3,C_Func4,C_D1Func, C_D2Func, C_D3Func,C_IFFunc,C_IFD1Func,C_IFD2Func,C_IFD3Func: Pointer;
    C_IFFuncD,C_IFD1FuncD,C_IFD2FuncD,C_IFD3FuncD: Pointer;
    Stack: array [1..100] of TStack;
    F_Ctrl: Boolean;
    V_YM: TArrayF;
    V_IM: TArrayI;
    D_XIs, D_YIs: TArrayI;


    procedure BeginFort(FCOP: String; reg: string; X: TFloat = 0);
    procedure Delay(D: LongInt);
    procedure BeginFlash;
    function  CalcFunc: TFloat;
    function  Calc(Func: Pointer): TFloat;



  end;



var
  Form1: TForm1;
  Fort: TThFortFunc;
  Flash: TThFlash;
  Clp: TClipboard;
  FLSE: TFLSE;
  FLSEinv: TFLSEinv;
  FData: TFData;
  SPL3: TSplain;
  G_FMT: TFormatSettings;
  //MathProcA: TMathLib;
  procedure InitFuncStruct(var Func: TAddFuncStruct);


implementation





{$R *.DFM}

function TForm1.Calc(Func: Pointer): TFloat;
  asm
   Call Func
  end;


function TForm1.CalcFunc: TFloat;
var
S: String;
begin
(*S:=Copy(SFunc,1,Length(SFunc));
if UpperCase(S{Func}) = 'SPLAIN3' then CalcFunc:=MathProc.Splain3(V_X,SPL3)
else  *)
CalcFunc:=Calc(C_Func);
end;



function FSPL3(x: TFloat): TFloat; stdcall;
begin
  FSPL3:=MathProc.Splain3(x,SPL3);
end;



procedure TForm1.SetFunction(NF: Integer = 1; NF1: Integer = 0; D: Integer = 0);
label endp;
var
Er: Cardinal;
S: String;
begin
S:=Copy(SFunc,1,Length(SFunc));
//if   UpperCase(S){Func} <> 'SPLAIN3' then
 begin
//diff func
   if D = 1 then
   begin
     if FSD1 = True then
     begin
       if C_D1Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D1Func));
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end
     else
     if C_D1Func = nil then
     begin
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end;
   end
   else
   if D = 2 then
   begin
     if FSD1 = True then
     begin
       if C_D1Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D1Func));
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end
     else
     if C_D1Func = nil then
     begin
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end;

     if FSD2 = True then
     begin
       if C_D2Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D2Func));
        flCompileDiff(SFunc,2,C_D2Func);
        FSD2:=False;
     end
     else
     if C_D2Func = nil then
     begin
        flCompileDiff(SFunc,2,C_D2Func);
        FSD2:=False;
     end;
   end
   else
   if D = 3 then
   begin
     if FSD1 = True then
     begin
       if C_D1Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D1Func));
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end
     else
     if C_D1Func = nil then
     begin
        flCompileDiff(SFunc,1,C_D1Func);
        FSD1:=False;
     end;

     if FSD2 = True then
     begin
       if C_D2Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D2Func));
        flCompileDiff(SFunc,2,C_D2Func);
        FSD2:=False;
     end
     else
     if C_D2Func = nil then
     begin
        flCompileDiff(SFunc,2,C_D2Func);
        FSD2:=False;
     end;

     if FSD3 = True then
     begin
       if C_D3Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D3Func));
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end
     else
     if C_D3Func = nil then
     begin
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end;

   end;
//end diff func



   if (NF >= 1) and (NF1 = 0) then
   begin
     if C_Func <> nil then flPerform(fl_FREE,Cardinal(C_Func));
     flCompile(SFunc,0,C_Func);
   end;


   if (NF >= 3) and (NF1 = 0) then
   begin
     if C_Func1 <> nil then flPerform(fl_FREE,Cardinal(C_Func1));
     flCompile(F_S[1],0,C_Func1);
     flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
     if C_Func2 <> nil then flPerform(fl_FREE,Cardinal(C_Func2));
     flCompile(F_S[2],0,C_Func2);
     flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
   end;

   if (NF >= 5) and (NF1 = 0) then
   begin
     if C_Func3 <> nil then flPerform(fl_FREE,Cardinal(C_Func3));
     flCompile(F_S[3],0,C_Func3);
     flGetErrorCode(Er); if Er <> 0  then begin ERROR; goto endp; end;
     if C_Func4 <> nil then flPerform(fl_FREE,Cardinal(C_Func4));
     flCompile(F_S[4],0,C_Func4);
     flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
   end;


   if NF1 = 1 then
   begin
      if (NF >= 2) then
      begin
        if C_Func1 <> nil then flPerform(fl_FREE,Cardinal(C_Func1));
        flCompile(F_S[1],0,C_Func1);
        flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
        if C_Func2 <> nil then flPerform(fl_FREE,Cardinal(C_Func2));
        flCompile(F_S[2],0,C_Func2);
        flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
      end;
      if (NF >= 3) then
      begin
        if C_Func3 <> nil then flPerform(fl_FREE,Cardinal(C_Func3));
        flCompile(F_S[3],0,C_Func3);
        flGetErrorCode(Er); if Er <> 0  then begin TRLERROR; goto endp; end;
      end;
   end;

end;

endp:
end;






procedure TForm1.ComplFunc(S: String; var Adr: Pointer; var Er: Cardinal);
{var
Er: Cardinal;}
begin
 flCompile(S,0,Adr);
 flGetErrorCode(Er); if Er <> 0  then
 begin
 TRLERROR;
 end;
end;


procedure TForm1.FreeFunc(Adr: TAddress);
begin
 flPerform(fl_FREE,Adr);
end;


procedure TForm1.NewNum;
begin
CInt:=0; CFl:=0; MN:=0; CTN:=0; SN:=0; FNN:=False; FSP:=False;
FF:=False; Len:=0; FE:=False; EN:=0; ES:=Copy('00',1,2);SE:=1;
//SetLength(Stack,Length(Stack)+1);
end;

procedure TForm1.NewNumA;
begin
CInt:=0; CFl:=0; MN:=0; CTN:=0; SN:=0; FNN:=False; FSP:=False;
FF:=False; Len:=0; FE:=False; EN:=0; ES:=Copy('00',1,2);SE:=1;
//SetLength(Stack,Length(Stack)+1);
end;

procedure TForm1.WMVar(V: TFloat);
var
maxLenVar: Integer;
begin
//if (FNN = True) and V = 0 then

maxLenVar:=DIG;
WSMVar(FloatToStr(V,G_FMT));

if FNN = True then NewNum;

if (FSP = True) and (FF = False) then
begin
CInt:=0; FSP:=False; FF:=True;
CFl:=1; CTN:=abs(MN);
if CTN < 1 then Len:=Len+1;
end;

if LeN < MaxLenVar then
begin
LeN:=LeN+1;
CTN:=V*Power(10,-CInt-CFl)+CTN;
MN:=CTN*Power(10,CInt);

If FF = True then
begin
CFl:=CFl+1;
end
else
begin
CInt:=CInt+1;
end;

MN:=MN*Power(-1,SN);
If reg = 'x' then
begin
R_X:=MN; //R_X:=R_X; {StV.Caption:=FloatToStr(R_X);}
Stack[S_Top].X:=R_X;
end
else
begin
R_Y:=MN;
Stack[S_Top].X:=R_Y;
//R_Y:=R_Y; {StV.Caption:=FloatToStr(R_Y);}
//Stack[1].X:=R_Y;
end;
end;

ShowVar;
FOP:=False;
//SaveNum;
end;


procedure TForm1.WEVar(E: TFloat);
begin
Delete(ES,1,1);
Insert(FloatToStr(E,G_FMT),ES,2);
WSEVar;
EN:=SE*StrToFloat(ES,G_FMT);
try
if reg = 'x' then
begin
R_X:=MN*Power(10,EN);{StV.Caption:=FloatToStr(R_X);}
Stack[S_Top].X:=R_X;
end
else
begin
R_Y:=MN*Power(10,EN);{StV.Caption:=FloatToStr(R_Y);}
Stack[S_Top].X:=R_Y;
end;
except
ERROR;
end;

FOP:=False;
end;


procedure TForm1.WSEVar;
begin
Delete(SS,Length(SS)-2{3,4},3{4,5}); //EXP
If SE = 1 then Insert('+',SS,Length(SS)+1)
else  Insert('',SS,Length(SS)+1);
Insert(ES,SS,Length(SS)+1);
StV.Caption:=SS;
end;



procedure  TForm1.XchPointA(S: String; var S1: String);
var
  i: Integer;
begin
 for i := 1 to Length(S) do
 begin
   if S[i] = '.'  then
   begin
     Delete(S,i,1);
     Insert(',',S,i);
   end;
 end;

 S1:=S;
end;



procedure TForm1.OutVar(OV: TFloat);
label 1;
var
St, SV, M, E, MA, ex: String;
LE, i,  P, Lp: Integer;                           
Neg,SE: Boolean;                                  
begin
if abs(OV) > MAX_NUM then ERROR;
if abs(OV) <  MIN_NUM then OV:=0;
if FER =True then goto 1;
LE:=0;  P:=0; St:=FloatToStr(OV,G_FMT);  Neg:= False; E:=Copy('',1,1);
SE:=False; Lp:=0;
//XchPointA(St,St);

if St[1] = '-' then
 begin
  Neg:=True;
  Delete(St,1,1);
 end;

For i:=1 to Length(St) do
begin
if St[i] = 'E' then LE:=i;
end;

if LE > 0 then
 begin
  M:=Copy(St,1,LE-1);
  E:=Copy(St,LE,Length(St)-LE+1);
  SE:=True;
 end
else
 begin
  for i:=1 to Length(St) do
   begin
    //if St[i] = ',' then P:=i;
    if St[i] = '.' then P:=i;
   end;
  if P <> 0 then MA:=Copy(St,1,P-1)
  else MA:=Copy(St,1,Length(St));

  if Length(MA) > DIG then
   begin
    E:=IntToStr(Length(MA)-1);
    Insert('E',E,1);
    M:=Copy(MA,1,Length(MA));
    Insert(',',M,2);
    SE:=True;
   end
  else
  M:=Copy(St,1,Length(St));
 end;



for i:=1 to Length(M) do
begin
 //if M[i] = ',' then Lp:=1;
 if M[i] = '.' then Lp:=1;
end;

M:=Copy(M,1,DIG+Lp);

If Neg = True then
begin
Insert('',M,1);
end;

P:=0;
For i:=1 to Length(M) do
begin
 //if M[i] = ',' then P:=i;
 if M[i] = '.' then P:=i;
end;

If P <> 0 then
begin
Delete(M,P,1); Insert('.',M,P);
end
else  Insert('.',M,Length(M)+1);

If SE = True Then
begin
Delete(E,1,1); Insert('E',E,1);
If E[2] = '-' then
begin
Delete(E,2,1); Insert('',E,2);
end
else Insert('+',E,2);
ex:=Copy(E,3,Length(E)-2);
Delete(E,3,Length(E)-2);
If Length(ex) = 1 then Insert('0',ex,1);
Insert(ex,E,3);
end;
SV:=Copy(M,1,Length(M)); Insert(E,SV,Length(SV)+1);

CSV:=SV;
if FSH = True then StV.Caption:=SV;

1:
end;





procedure TForm1.WSMVar(S: String);
var
MaxLenVar: Integer;
begin
MaxLenVar:=DIG;
If FNN = True then
begin
SS:=Copy(' 0.',1,3); Delete(SS,2,1); LeS:=2;
end;
If (FSP = True) and (FF = False) then
begin
LeS:=LeS+1;
end;
if Len < MaxLenVar then
begin
Insert(S,SS,LeS);
LeS:=LeS+1;
end;
end;



procedure TForm1.ShowVar;
begin
if FER = False then
begin
if FE = False then
begin

  if SN = 1 then
  begin
   Delete(SS,1,1);
   Insert('',SS,1);
  end;
  StV.Caption:=SS;
  if SN = 1 then
  begin
   Delete(SS,1,1);
   Insert(' ',SS,1);
  end
end

else
begin
  If SE = 1 then
  begin
   Delete(SS,Length(SS)-2{3,4},1);   //EXP
   Insert('+',SS,Length(SS)-1{2,3});
  end
  else
  begin
   Delete(SS,Length(SS)-2{3,4},1);
   Insert('',SS,Length(SS)-1{2,3});          //EXP
  end;
 StV.Caption:=SS;
end;
end;
end;




procedure TForm1.Sum;
begin
R_X:=R_X+R_Y;
end;



procedure TForm1.Sub;
begin
R_X:=R_X-R_Y;
end;

procedure TForm1.Mul;
begin
try
R_X:=R_X*R_Y;
except
ERROR;
end;
end;

procedure TForm1.Dvd;
begin
try
R_X:=R_X/R_Y;
except
ERROR;
end;
end;





procedure TForm1.Equal;
label endp;
var
 L,H,MCop,PrM,Pr1,Cop1: Integer;
 X,Y: TFloat;
begin

 PrM:=Stack[S_Top].Pr;
 Pr1:=Stack[S_Top-1].Pr;


X:=Stack[S_Top-1].X; Y:=Stack[S_Top].X; MCop:=Stack[S_Top].COP;

try

  case MCOP of
   1:  X:=X+Y;
   2:  X:=X-Y;
   3:  X:=X*Y;
   4:  X:=X/Y;
   5:  X:=Power(X,Y);
   6:  X:=Root(Y,X);
   7:  X:=LogN(R_X,R_Y);
   8:  begin R_X:=X; R_Y:=Y; X:=Cnm; end;
   9:  begin  X:=X/100*Y;  end;
  end;
  R_X:=X;
  Stack[S_Top].COP:=0;//??
  decs;//dec(S_Top);
except
  ERROR;
end;

endp:
end;



function TForm1.arcsh(X: TFloat):TFloat;
begin
try
arcsh:=Logn(exp(1),x+sqrt(sqr(x)+1));
except
 ERROR;
end;
end;



function TForm1.Root(X,Y: TFloat):TFloat;
var
adr: Cardinal;
res: TFloat;
begin
flGet(fl_ADDRESS,fl_FROOT,adr);
try
asm
  fld Y
  fld X
  call adr
  fstp res
end;
except
ERROR;
end;
Root:=Res;
end;


function TForm1.LogN(X,Y: TFloat):TFloat;
var
adr: Cardinal;
res: TFloat;
begin
try
asm
  FLD1
  FLD  Y
  FYL2X
  FLD1
  FLD     X
  FYL2X
  FDIV
  fstp res
end;
except
ERROR;
end;
LogN:=Res;
end;




procedure TForm1.SBeqClick(Sender: TObject);
label 1,2;
var
 N: Integer;
begin
if (FER = False)  and (FTF = False) then
begin

if (FH = 'F') and (SFunc <> '') then
 begin
  SetFunction;
  try
   if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
    R_X:=calc(C_Func);
    OutVar(R_X);
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
    R_Y:=calc(C_Func);
    OutVar(R_Y);
   end;
  except
   ERROR;
  end;

  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  FEO:=True;
  FOP:=False;
  OutStack;
  goto 2;
 end;


if FH = 'F' then goto 1;

try
while (Stack[S_TOP].COP <> 0) and (Stack[S_TOP].Br = 0) do
begin
 Equal;
 Stack[S_Top].X:=R_X;
 if S_Top > 1 then
 begin
    N:=Stack[S_Top].COP;
    case N of
    1:  COP:='+';
    2:  COP:='-';
    3:  COP:='*';
    4:  COP:='/';
    5:  COP:='xy';
    6:  COP:='xRy';
    7:  COP:='logxy';
    8:  COP:='Cnm';
    9:  COP:='%';
    end;
 end
 else COP:='NOP';
end;
except
  ERROR;
end;




1:
R_Y:=0;
Reg:='x';
NewNumA;
FNN:=True;
MN:=R_X;
OutVar(R_X);
FEO:=False;
FOP:=False;
end;

2:
end;




procedure TForm1.CalcOp;
label 1,2;
var
 N: Integer;
begin
if (FER = False)  and (FTF = False) then
begin




if FH = 'F' then goto 1;

//new:
//if COP <> 'NOP' then
if Stack[S_TOP].COP <> 0 then

begin
 Equal;
 Stack[S_Top].X:=R_X;
 if S_Top > 1 then
 begin
    N:=Stack[S_Top].COP;
    case N of
    1:  COP:='+';
    2:  COP:='-';
    3:  COP:='*';
    4:  COP:='/';
    5:  COP:='xy';
    6:  COP:='xRy';
    7:  COP:='logxy';
    8:  COP:='Cnm';
    end;
 end
 else COP:='NOP';
end;

//old:
 {if COP = '+' then Sum;
 if COP = '-' then Sub;
 if COP = '/' then Dvd;
 if COP = '*' then Mul;
 if COP = 'xy'    then XtoY;
 if COP = 'xRy'   then XRootY;
 if COP = 'Cnm'   then Cnm;
 if COP = 'logxy' then logxy;}



1:
//COP:='NOP';  //  old 
R_Y:=0;
Reg:='x';
NewNumA;
FNN:=True;
MN:=R_X;
OutVar(R_X);
FEO:=False;
FOP:=False;
end;

2:
end;




procedure TForm1.CalcBr;
label 1,2;
var
 N: Integer;
begin
if (FER = False)  and (FTF = False) then
begin




if FH = 'F' then goto 1;

//new:
//if COP <> 'NOP' then
//if {Stack[S_TOP].COP <> 0} Stack[S_TOP].BR <> 0 then
if Stack[S_TOP].Br <> 0 then Stack[S_TOP].Br:= 0 else  //     
 while (Stack[S_TOP].COP <> 0) and (Stack[S_TOP].Br = 0) do
 begin
  Equal;
  Stack[S_Top].X:=R_X;
  if S_Top > 1 then
  begin
    N:=Stack[S_Top].COP;
    case N of
    1:  COP:='+';
    2:  COP:='-';
    3:  COP:='*';
    4:  COP:='/';
    5:  COP:='xy';
    6:  COP:='xRy';
    7:  COP:='logxy';
    8:  COP:='Cnm';
    end;
  end
  else COP:='NOP';

  if Stack[S_TOP].Br <> 0 then begin Stack[S_TOP].Br:=0; goto 1; end;
 end;

//old:
 {if COP = '+' then Sum;
 if COP = '-' then Sub;
 if COP = '/' then Dvd;
 if COP = '*' then Mul;
 if COP = 'xy'    then XtoY;
 if COP = 'xRy'   then XRootY;
 if COP = 'Cnm'   then Cnm;
 if COP = 'logxy' then logxy;}



1:
//COP:='NOP';  //  old 
R_Y:=0;
Reg:='x';
NewNumA;
FNN:=True;
MN:=R_X;
OutVar(R_X);
FEO:=False;
FOP:=False;
end;

2:
end;



procedure TForm1.WriteVar;
begin
{if Reg = 'x' then  R_X:=StrtoFloat(SS)
 else
 R_Y:=StrtoFloat(SS) }
end;



procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
label endp;
var
  S: String;
  sh: Integer;
begin
//Ctrl
if key = 17 then F_Ctrl:=False;


if (FFF = 'EF') and (sig = ' ') and (key <> 112) then
begin
 if (ssShift in Shift) then sh:=1 else sh:=0;
 EFKeyInput(key,0,sh);
 goto endp;
end;

if (ssShift in Shift) then sh:=1 else sh:=0;

if (key = 112)  then      //F1
begin
 SBFunc.Down:=False;
 SBFunc.GroupIndex:=0;
end else
if (key = 113)  then      //F2
begin
 SBFH.Down:=False;
 SBFH.GroupIndex:=0;
end else
if (key = 114)  then      //F3
begin
 SBsig.Down:=False;
 SBsig.GroupIndex:=0;
end else
if (key = 115)  then      //F4
begin
 SBdrg.Down:=False;
 SBdrg.GroupIndex:=0;
end else
if (key = 32) then        //space->F(x)
begin
 SBFx.Down:=False;
 SBFx.GroupIndex:=0;
end else
if (key = 49) or (key = 97) then
begin
SB1.Down:=False;
SB1.GroupIndex:=0;
end else
if (key = 50) or (key = 98) then
begin
SB2.Down:=False;
SB2.GroupIndex:=0;
end else
if (key = 51) or (key = 99) then
begin
SB3.GroupIndex:=0;
SB3.Down:=False;
end else
if (key = 52) or (key = 100) then
begin
SB4.GroupIndex:=0;
SB4.Down:=False;
end else
if (key = 53) or (key = 101) then
begin
SB5.GroupIndex:=0;
SB5.Down:=False;
end else
if ((key = 54) or (key = 102)) and (sh = 0) then
begin
SB6.GroupIndex:=0;
SB6.Down:=False;
end else
if (key = 55) or (key = 103) then
begin
SB7.GroupIndex:=0;
SB7.Down:=False;
end else
if ((key = 56) or (key = 104)) and (sh = 0) then
begin
SB8.GroupIndex:=0;
SB8.Down:=False;
end else
if ((key = 57) or (key = 105)) and (sh = 0) then
begin
SB9.GroupIndex:=0;
SB9.Down:=False;
end else
if ((key = 48) or (key = 96)) and (sh = 0) then
begin
SB0.GroupIndex:=0;
SB0.Down:=False;
end else
if (key = 13) or ((key = 187) and (sh = 0)) then
begin
SBeq.GroupIndex:=0;
SBeq.Down:=False;
end else
if key = 27 then
begin
SBesc.GroupIndex:=0;
SBesc.Down:=False;
end else
if (key = 46)  then
begin
SBce.GroupIndex:=0;
SBce.Down:=False;
end else
if (key = 37) or (key = 39) then
begin
  SBarrow.GroupIndex:=0;
  SBarrow.Down:=False;
end else
if (key = 106) {or ((key = 56) and (ssShift in Shift))} then
begin
SBmul.GroupIndex:=0;
SBmul.Down:=False;
end else
if (key = 111) or (key = 191) then
begin
SBdvd.GroupIndex:=0;
SBdvd.Down:=False;
end else
if (key = 109) or (key = 189) then
begin
SBsub.GroupIndex:=0;
SBsub.Down:=False;
end else
if (key = 107)  then
begin
SBsum.GroupIndex:=0;
SBsum.Down:=False;
end else
if (key = 110) or (key = 190) or (key = 188) then
begin
SBpoint.GroupIndex:=0;
SBpoint.Down:=False;
end else
if (key = 69)  then
begin
SBdms.GroupIndex:=0;
SBdms.Down:=False;
end else
if (key = 78)  then
begin
SBneg.GroupIndex:=0;
SBneg.Down:=False;
end else
if (key = 65)  then
begin
SBA.GroupIndex:=0;
SBA.Down:=False;
end else
if (key = 66)  then
begin
SBB.GroupIndex:=0;
SBB.Down:=False;
end else
if (key = 67)  then
begin
SBC.GroupIndex:=0;
SBC.Down:=False;
end else

if (key = 57) and (sh = 1) then
begin
SBb1.GroupIndex:=0;
SBb1.Down:=False;
end
else
if (key = 48) and (sh = 1) then
begin
SBb2.GroupIndex:=0;
SBb2.Down:=False;
end
else
if (key = 187) and (sh = 1) then
begin
SBsum.GroupIndex:=0;
SBsum.Down:=False;
end
else
if (key = 189)  then
begin
SBsub.GroupIndex:=0;
SBsub.Down:=False;
end
else
if (key = 191)  then
begin
SBdvd.GroupIndex:=0;
SBdvd.Down:=False;
end
else
if (key = 56) and (sh = 1) then
begin
SBmul.GroupIndex:=0;
SBmul.Down:=False;
end
else
if (key = 54) and (sh = 1) and (FH = ' ') then
begin
SBxy.GroupIndex:=0;
SBxy.Down:=False;
end;


endp:
end;




procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
label endp;
var
  S: String;
  sh: Integer;
begin
//Ctrl
if key = 17 then F_Ctrl:=True;

if (FFF = 'EF') and (sig = ' ') and (key <> 112) then
begin
 if (ssShift in Shift) then sh:=1 else sh:=0;
 EFKeyInput(key,1,sh);
 goto endp;
end;


if (ssShift in Shift) then sh:=1 else sh:=0;

if (key = 112) then   //F1
begin
 SBFunc.GroupIndex:=1;
 SBFunc.Down:=True;
 SBFunc.Click;
end else
if (key = 113) then   //F2
begin
 SBFH.GroupIndex:=1;
 SBFH.Down:=True;
 SBFH.Click;
end else
if (key = 114) then   //F3
begin
 SBsig.GroupIndex:=1;
 SBsig.Down:=True;
 SBsig.Click;
end else
if (key = 115) then   //F4
begin
 SBdrg.GroupIndex:=1;
 SBdrg.Down:=True;
 SBdrg.Click;
end else
if (key = 32) then   //space->F(x)
begin
 SBFx.GroupIndex:=1;
 SBFx.Down:=True;
 SBFx.Click;
end else

if (key = 49) or (key = 97) then
begin
SB1.GroupIndex:=1;
SB1.Down:=True;
SB1.Click;
end else
if (key = 50) or (key = 98) then
begin
SB2.GroupIndex:=1;
SB2.Down:=True;
SB2.Click;
end else
if (key = 51) or (key = 99) then
begin
SB3.GroupIndex:=1;
SB3.Down:=True;
SB3.Click;
end else
if (key = 52) or (key = 100) then
begin
SB4.GroupIndex:=1;
SB4.Down:=True;
SB4.Click;
end else
if (key = 53) or (key = 101) then
begin
SB5.GroupIndex:=1;
SB5.Down:=True;
SB5.Click;
end else
if ((key = 54) or (key = 102)) and (sh = 0) then
begin
SB6.GroupIndex:=1;
SB6.Down:=True;
SB6.Click;
end else
if (key = 55) or (key = 103) then
begin
SB7.GroupIndex:=1;
SB7.Down:=True;
SB7.Click;
end else
if ((key = 56) or (key = 104)) and (sh = 0) then
begin
SB8.GroupIndex:=1;
SB8.Down:=True;
SB8.Click;
end else
if ((key = 57) or (key = 105)) and (sh = 0) then
begin
SB9.GroupIndex:=1;
SB9.Down:=True;
SB9.Click;
end else
if ((key = 48) or (key = 96)) and (sh = 0) then
begin
SB0.GroupIndex:=1;
SB0.Down:=True;
SB0.Click;
end else
if (key = 13) or ((key = 187) and (sh = 0)) then
begin
SBeq.GroupIndex:=1;
SBeq.Down:=True;
SBeq.Click;
end else
if key = 27  then
begin
SBesc.GroupIndex:=1;
SBesc.Down:=True;
SBesc.Click;
end else
if (key = 46)  then
begin
SBce.GroupIndex:=1;
SBce.Down:=True;
SBce.Click;
end else
if (key = 37) or (key = 39) then
begin
  SBarrow.GroupIndex:=1;
  SBarrow.Down:=True;
  SBarrow.Click;
end else
if (key = 106) {or ((key = 56) and (ssShift in Shift))} then
begin
SBmul.GroupIndex:=1;
SBmul.Down:=True;
SBmul.Click;
end else
if (key = 111) or (key = 191) then
begin
SBdvd.GroupIndex:=1;
SBdvd.Down:=True;
SBdvd.Click;
end else
if (key = 109) or (key = 189) then
begin
SBsub.GroupIndex:=1;
SBsub.Down:=True;
SBsub.Click;
end else
if (key = 107)  then
begin
SBsum.GroupIndex:=1;
SBsum.Down:=True;
SBsum.Click;
end else
if (key = 110) or (key = 190) or (key = 188) then
begin
SBpoint.GroupIndex:=1;
SBpoint.Down:=True;
SBpoint.Click;
end else
if (key = 69)  then
begin
SBdms.GroupIndex:=1;
SBdms.Down:=True;
SBFH.Click;
SBdms.Click;
end else
if (key = 78)  then
begin
SBneg.GroupIndex:=1;
SBneg.Down:=True;
SBneg.Click;
end else
if (key = 65)  then
begin
SBA.GroupIndex:=1;
SBA.Down:=True;
SBA.Click;
end else
if (key = 66)  then
begin
SBB.GroupIndex:=1;
SBB.Down:=True;
SBB.Click;
end else
if (key = 67)  then
begin
SBC.GroupIndex:=1;
SBC.Down:=True;
SBC.Click;
end
else
if (key = 57) and (sh = 1) then
begin
SBb1.GroupIndex:=1;
SBb1.Down:=True;
SBb1.Click;
end
else
if (key = 48) and (sh = 1) then
begin
SBb2.GroupIndex:=1;
SBb2.Down:=True;
SBb2.Click;
end
else
if (key = 187) and (sh = 1) then
begin
SBsum.GroupIndex:=1;
SBsum.Down:=True;
SBsum.Click;
end
else
if (key = 189)   then
begin
SBsub.GroupIndex:=1;
SBsub.Down:=True;
SBsub.Click;
end
else
if (key = 191)  then
begin
SBdvd.GroupIndex:=1;
SBdvd.Down:=True;
SBdvd.Click;
end
else
if (key = 56) and (sh = 1) then
begin
SBmul.GroupIndex:=1;
SBmul.Down:=True;
SBmul.Click;
end
else
if (key = 54) and (sh = 1) and (FH = ' ') then
begin
SBxy.GroupIndex:=1;
SBxy.Down:=True;
SBxy.Click;
end;


endp:
end;




procedure TForm1.EFKeyInput(key: Integer; ud: Integer; sh: Integer);
label endp;
var
Bl: Boolean;
S: String;
begin

case key of
16: goto endp;
17: goto endp;
18: goto endp;
end;

if ud = 1 then Bl:=True else Bl:=False;

if key = 39 then   //->
   begin
    SBxM.GroupIndex:=ud;
    SBxM.Down:=Bl;
    if Bl = True then SBxM.Click;
   end
   else
 if key = 37 then   //<-
   begin
    SBMx.GroupIndex:=ud;
    SBMx.Down:=Bl;
    if Bl = True then SBMx.Click;
   end
 else
 if (key = 8)   then   //<-|
   begin
    SBMxM.GroupIndex:=ud;
    SBMxM.Down:=Bl;
    if Bl = True then SBMxM.Click;
   end
   else
 if (key = 46)  then   //Del
   begin
    SBCE.GroupIndex:=ud;
    SBCE.Down:=Bl;
    if Bl = True then SBCE.Click;
   end
   else
 if (key = 27) then   //esq
   begin
     SBesc.GroupIndex:=ud;
     SBesc.Down:=Bl;
     if Bl = True then SBesc.Click;
   end
 else
 if (key = 57) and (sh = 1) then   // (
   begin
     SBb1.GroupIndex:=ud;
     SBb1.Down:=Bl;
     if Bl = True then SBb1.Click;
   end
 else
 if (key = 48) and (sh = 1) then   // )
   begin
     SBb2.GroupIndex:=ud;
     SBb2.Down:=Bl;
     if Bl = True then SBb2.Click;
   end
 else
 if ((key = 187) {and (sh = 1)}) or (key = 107) then   // +
   begin
     SBsum.GroupIndex:=ud;
     SBsum.Down:=Bl;
     if Bl = True then SBsum.Click;
   end
   else
 if ((key = 56) and (sh = 1)) or (key = 106) then   // *
   begin
     SBmul.GroupIndex:=ud;
     SBmul.Down:=Bl;
     if Bl = True then SBmul.Click;
   end
   else
 if ((key = 189) {and (sh = 1)}) or (key = 109) then   // -
   begin
     SBsub.GroupIndex:=ud;
     SBsub.Down:=Bl;
     if Bl = True then SBsub.Click;
   end
   else
 if ((key = 191) {and (sh = 1)}) or (key = 111) then   // /
   begin
     SBdvd.GroupIndex:=ud;
     SBdvd.Down:=Bl;
     if Bl = True then SBdvd.Click;
   end
   else
 if  ((key = 54) and (sh = 1)) then   // ^
   begin
     SBxy.GroupIndex:=ud;
     SBxy.Down:=Bl;
     if Bl = True then SBxy.Click;
   end
   else
 if  ((key = 49) and (sh = 1)) then   // !
   begin
     FH:='F';
     SB1x.GroupIndex:=ud;
     SB1x.Down:=Bl;
     if Bl = True then SB1x.Click;
     FH:=' ';
   end
   else
 if  ((key = 48) or (key = 96)) then   // 0
   begin
     SB0.GroupIndex:=ud;
     SB0.Down:=Bl;
     if Bl = True then SB0.Click;
   end
   else
 if  ((key = 49) or (key = 97)) then   // 1
   begin
     SB1.GroupIndex:=ud;
     SB1.Down:=Bl;
     if Bl = True then SB1.Click;
   end
   else
 if  ((key = 50) or (key = 98)) then   // 2
   begin
     SB2.GroupIndex:=ud;
     SB2.Down:=Bl;
     if Bl = True then SB2.Click;
   end
   else
 if  ((key = 51) or (key = 99)) then   // 3
   begin
     SB3.GroupIndex:=ud;
     SB3.Down:=Bl;
     if Bl = True then SB3.Click;
   end
   else
 if  ((key = 52) or (key = 100)) then   // 4
   begin
     SB4.GroupIndex:=ud;
     SB4.Down:=Bl;
     if Bl = True then SB4.Click;
   end
   else
 if  ((key = 53) or (key = 101)) then   // 5
   begin
     SB5.GroupIndex:=ud;
     SB5.Down:=Bl;
     if Bl = True then SB5.Click;
   end
   else
 if  ((key = 54) or (key = 102)) then   // 6
   begin
     SB6.GroupIndex:=ud;
     SB6.Down:=Bl;
     if Bl = True then SB6.Click;
   end
   else
 if  ((key = 55) or (key = 103)) then   // 7
   begin
     SB7.GroupIndex:=ud;
     SB7.Down:=Bl;
     if Bl = True then SB7.Click;
   end
   else
 if  ((key = 56) or (key = 104)) then   // 8
   begin
     SB8.GroupIndex:=ud;
     SB8.Down:=Bl;
     if Bl = True then SB8.Click;
   end
   else
 if  ((key = 57) or (key = 105)) then   // 9
   begin
     SB9.GroupIndex:=ud;
     SB9.Down:=Bl;
     if Bl = True then SB9.Click;
   end
   else
 if  ((key = 110) or (key = 190)) then   // .
   begin
     SBpoint.GroupIndex:=ud;
     SBpoint.Down:=Bl;
     if Bl = True then SBpoint.Click;
   end
  else
 if  (key = 222) and (sh = 0) then                       // '
   begin
     SBLSE.GroupIndex:=ud;
     SBLSE.Down:=Bl;
     if Bl = True then SBLSE.Click;
   end
   else
 if  (key = 222) and (sh = 1) then        // "
   begin
     SBspl.GroupIndex:=ud;
     SBspl.Down:=Bl;
     if Bl = True then SBspl.Click;
   end
 {  else
 if  (key = 65) then   // A
   begin
     SBA.GroupIndex:=ud;
     SBA.Down:=Bl;
     if Bl = True then SBA.Click;
   end
   else
 if  (key = 66) then   // B
   begin
     SBB.GroupIndex:=ud;
     SBB.Down:=Bl;
     if Bl = True then SBB.Click;
   end
   else
 if  (key = 67) then   // C
   begin
     SBC.GroupIndex:=ud;
     SBC.Down:=Bl;
     if Bl = True then SBC.Click;
   end
   else
 if  (key = 68) then   // D
   begin
     SBD.GroupIndex:=ud;
     SBD.Down:=Bl;
     if Bl = True then SBD.Click;
   end
   else
 if  (key = 69) then   // E
   begin
     SBE.GroupIndex:=ud;
     SBE.Down:=Bl;
     if Bl = True then SBE.Click;
   end
   else
 if  (key = 88) then   // X
   begin
     SBxplusM.GroupIndex:=ud;
     SBxplusM.Down:=Bl;
     if Bl = True then SBxplusM.Click;
   end
   else
 if  (key = 89) then   // Y
   begin
     SBddx.GroupIndex:=ud;
     SBddx.Down:=Bl;
     if Bl = True then SBddx.Click;
   end
   else
 if  (key = 78) then   // N
   begin
     SBis1.GroupIndex:=ud;
     SBis1.Down:=Bl;
     if Bl = True then SBis1.Click;
   end
   else
 if  (key = 75) then   // K
   begin
     SBis2.GroupIndex:=ud;
     SBis2.Down:=Bl;
     if Bl = True then SBis2.Click;
   end }
   else
 if  (key = 13) then   // enter
   begin
     {SBfunc.GroupIndex:=ud;
     SBfunc.Down:=Bl;
     if Bl = True then} SBfunc.Click;
   end
 else
 if key = 45  then InsertFuncClp    //insert
 else
 if Bl = True then
 begin
   if (key = 86) and (F_Ctrl = True) then goto endp; //ctrl+v

   if ((key = 219) and (sh = 0)) then S:='[' else
   if ((key = 221) and (sh = 0)) then S:=']' else
   if ((key = 219) and (sh = 1)) then S:='{' else
   if ((key = 221) and (sh = 1)) then S:='}' else
   if ((key = 220) {and (sh = 1)}) then S:='|' else
   if ((key = 188) and (sh = 0)) then S:=',' else
   S:=LowerCase(chr(key));

   AddFunction(S); FH:=' '; StFH.Caption:=FH;
 end;

endp:
end;





procedure TForm1.SB0Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('0'); goto 1; end;


If FNN = True Then
begin
 //WMVar(0);
 if reg = 'x' then
 begin
  R_X:=0; Stack[S_Top].X:=R_X;
 end
 else
 begin
  R_Y:=0; Stack[S_Top].X:=R_Y;
 end;
 StV.Caption:=' 0.';
 //NewNum;
 FOP:=False;
end;
if (MN <> 0) or (FSP = True) or (FF = True) then
 if FE = False then WMVar(0)
  else Form1.WEVar(0);
end;
1:
end;



procedure TForm1.SB1Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('1'); goto 1; end;




if FE = False then WMVar(1)
else Form1.WEVar(1);
end;

1:
end;



procedure TForm1.SB2Click(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('2'); goto 1; end;

//DE(1)
if FH = 'F' then begin  CalcExMath('DIFFEQ1'); goto 1; end;

if FE = False then WMVar(2)
else Form1.WEVar(2);
end;
1:
end;



procedure TForm1.SB3Click(Sender: TObject);
label 1;
var
f1,f2,max: TFloat;
i: Integer;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('3'); goto 1; end;

//DE(n)
if FH = 'F' then begin  CalcExMath('DIFFEQN'); goto 1; end;

(*
if FH = 'F' then
begin
 if FSD3 = True then
     begin
       if C_D3Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D3Func));
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end
     else
     if C_D3Func = nil then
     begin
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end;
 CalcExMath('SCANROOTD_max',1,0,2);
 goto 1;
end;
*)

if FE = False then WMVar(3)
else Form1.WEVar(3);
end;
1:
end;




procedure TForm1.SB4Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('4'); goto 1; end;
//if FH = 'F' then begin  CalcExMath('DIFFEQ1'); goto 1; end;

if FH = 'F' then
begin
 if FIF = True then
     begin
       if C_IFFunc <> nil  then
        begin
         flPerform(fl_FREE,Cardinal(C_IFFunc));
         flPerform(fl_FREE,Cardinal(C_IFD1Func));
         flPerform(fl_FREE,Cardinal(C_IFD2Func));
        end;
         flCompile('1/('+SFunc+')',0,C_IFFunc);
         flCompileDiff('1/('+SFunc+')',1,C_IFD1Func);
         flCompileDiff('1/('+SFunc+')',2,C_IFD2Func);

       FIF:=False;
     end
     else
     if C_IFFunc = nil then
     begin
         flCompile('1/('+SFunc+')',0,C_IFFunc);
         flCompileDiff('1/('+SFunc+')',1,C_IFD1Func);
         flCompileDiff('1/('+SFunc+')',2,C_IFD2Func);
        FIF:=False;
     end;
 CalcExMath('SCANROOTD_excess',1,0,0);       // 
 goto 1;
end;




if FE = False then WMVar(4)
else Form1.WEVar(4);
end;
1:
end;




procedure TForm1.SB5Click(Sender: TObject);
label 1;
var
SDFunc: String;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('5'); goto 1; end;


if FH = 'F' then
begin
 flGetDiffString(SFunc,1,SDFunc);
 if FIFD = True then
     begin
       if C_IFFuncD <> nil  then
        begin
         flPerform(fl_FREE,Cardinal(C_IFFuncD));
         flPerform(fl_FREE,Cardinal(C_IFD1FuncD));
         flPerform(fl_FREE,Cardinal(C_IFD2FuncD));
        end;
         flCompile('1/('+SDFunc+')',0,C_IFFuncD);
         flCompileDiff('1/('+SDFunc+')',1,C_IFD1FuncD);
         flCompileDiff('1/('+SDFunc+')',2,C_IFD2FuncD);

       FIFD:=False;
     end
     else
     if C_IFFuncD = nil then
     begin
         flCompile('1/('+SDFunc+')',0,C_IFFuncD);
         flCompileDiff('1/('+SDFunc+')',1,C_IFD1FuncD);
         flCompileDiff('1/('+SDFunc+')',2,C_IFD2FuncD);
        FIFD:=False;
     end;
 CalcExMath('SCANROOTD_excessd',1,0,1);       // 
 goto 1;
end;




if FE = False then WMVar(5)
else Form1.WEVar(5);
end;
1:
end;



procedure TForm1.SB6Click(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False)then
begin
if FFF = 'EF' then begin AddFunction('6'); goto 1; end;


if FH = 'F' then
begin
 CalcExMath('SCANROOTD_conv',1,0,3);       //
 goto 1;
end;



if FE = False then WMVar(6)
else Form1.WEVar(6);
end;
1:
end;


procedure TForm1.SB7Click(Sender: TObject);
label 1;
var
Er: Cardinal;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('7'); goto 1; end;


if  FH = 'F' then
begin
 //CalcExMath('DERIVATIVE1');  goto 1;

 if  {(SFunc <> '') and }(FSD1 = True) then
 begin
  if C_D1Func <> nil then flPerform(fl_FREE,Cardinal(C_D1Func));
     flCompileDiff(SFunc,1,C_D1Func);
     flGetErrorCode(Er);
     if Er <> 0  then begin TRLERROR; goto 1; end;
     FSD1:=False;
 end;

  try
   if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
    R_X:=calc(C_D1Func);
    OutVar(R_X);
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
    R_Y:=calc(C_D1Func);
    OutVar(R_Y);
   end;
  except
   ERROR;
  end;

  NewNum;
  FNN:=True;
  FEO:=True;
  FOP:=False;
  FH:=' ';
  StFH.Caption:=FH;
  OutStack;

 goto 1;
end;



if FE = False then WMVar(7)
else Form1.WEVar(7);
end;
1:
end;




procedure TForm1.SB8Click(Sender: TObject);
label 1;
var
Er: Cardinal;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('8'); goto 1; end;

if  FH = 'F' then
begin
 //CalcExMath('DERIVATIVE2');  goto 1;
 if  {(SFunc <> '') and }(FSD2 = True) then
 begin
  if C_D2Func <> nil then flPerform(fl_FREE,Cardinal(C_D2Func));
     flCompileDiff(SFunc,2,C_D2Func);
     flGetErrorCode(Er);
     if Er <> 0  then begin TRLERROR; goto 1; end;
     FSD2:=False;
 end;

  try
   if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
    R_X:=calc(C_D2Func);
    OutVar(R_X);
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
    R_Y:=calc(C_D2Func);
    OutVar(R_Y);
   end;
  except
   ERROR;
  end;


  NewNum;
  FNN:=True;
  FEO:=True;
  FOP:=False;
  FH:=' ';
  StFH.Caption:=FH;
  OutStack;

 goto 1;

end;


if FE = False then WMVar(8)
else Form1.WEVar(8);
end;
1:
end;



procedure TForm1.SB9Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('9'); goto 1; end;

if FH = 'F' then begin  CalcExMath('SCANROOT',1,0,2); goto 1; end;

{else
if  FH = 'H' then
begin
 CalcExMath('ROOTD1');  goto 1;
end};


if FE = False then WMVar(9)
else Form1.WEVar(9);
end;
1:
end;


procedure TForm1.SBsumClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('+'); goto 1; end;


if FH = 'F' then
begin
 {if FSD3 = True then
     begin
       if C_D3Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D3Func));
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end
     else
     if C_D3Func = nil then
     begin
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end; }
 CalcExMath('SCANROOTD',1,0,3);

 goto 1;
end;




If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
begin
 while (Stack[S_Top].Pr >= 1) and (Stack[S_TOP].Br = 0) do CalcOp;
end;


if FOP = False then incs;//inc(S_TOP);

PushOp(1,1);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='+';

FOP:=True;
end;
1:
end;




procedure TForm1.PushOp(Cop: Integer; Pr: Integer);
begin
if reg = 'x' then Stack[S_Top].X:=R_X else Stack[S_Top].X:=R_Y;
Stack[S_Top].Pr:=Pr;
Stack[S_Top].Cop:=Cop;
end;



procedure TForm1.OutStack;
begin
if reg = 'x' then Stack[S_Top].X:=R_X else Stack[S_Top].X:=R_Y;
end;





procedure TForm1.SBsubClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('-'); goto 1; end;


if FH = 'F' then
begin
 CalcExMath('SCANROOTD_conc',1,0,3);    //
 goto 1;
end;




If (COP <> 'NOP') and (FNN = False) or (FEO = True) then
begin
while (Stack[S_Top].Pr >= 1) and (Stack[S_TOP].Br = 0) do CalcOp;

{if Stack[S_Top].Pr >= 1 then
   CalcOp;}
end;

if FOP = False then incs;//inc(S_TOP);



PushOp(2,1);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='-';

FOP:=True;
end;
1:
end;





procedure TForm1.SBmulClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('*'); goto 1; end;

//DES(1)
if FH = 'F' then begin  CalcExMath('DIFFEQSYS1',LeFS,1); goto 1; end;

(*
if FH = 'F' then
begin
 if FSD3 = True then
     begin
       if C_D3Func <> nil  then  flPerform(fl_FREE,Cardinal(C_D3Func));
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end
     else
     if C_D3Func = nil then
     begin
        flCompileDiff(SFunc,3,C_D3Func);
        FSD3:=False;
     end;
 CalcExMath('SCANROOTD_min',1,0,2);
 goto 1;
end;
*)

If (COP <> 'NOP') and (FNN = False) or (FEO = True) then
begin
  while (Stack[S_Top].Pr >= 2)  and (Stack[S_TOP].Br = 0) do CalcOp;
 {if Stack[S_Top].Pr >= 2 then
 CalcOp;}
end;


if FOP = False then incs;//inc(S_TOP);

PushOp(3,2);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='*';

FOP:=True;
end;
1:
end;



procedure TForm1.SBdvdClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('/'); goto 1; end;

//FIF:=True;
//FID3:=True;


If (COP <> 'NOP')  and (FNN = False) or (FEO = True) then
begin
while (Stack[S_Top].Pr >= 2) and (Stack[S_TOP].Br = 0) do CalcOp;


end;

if FOP = False then incs;//inc(S_TOP);

PushOp(4,2);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='/';

FOP:=True;
end;
1:
end;



procedure TForm1.SBnegClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False)then
begin
if FFF = 'EF' then begin AddFunction('-'); goto 1; end;


If FNN = False then
begin

if FE = False then
begin
 if SN = 0 then SN:=1 else SN:=0;
 MN:=(-1)*MN;
 If reg = 'x' then
 begin
   R_X:=MN; {StV.Caption:=FloatToStr(R_X);}
 end
 else
 begin
   R_Y:=MN; {StV.Caption:=FloatToStr(R_Y);}
 end;
   Stack[S_Top].X:=MN;
   ShowVar;
end

else
begin
if SE = 1 then SE:=-1 else SE:=1;
EN:=(-1)*EN;
If reg = 'x' then
begin
R_X:=MN*Power(10,EN); {StV.Caption:=FloatToStr(R_X);}
end
else
begin
R_Y:=MN*Power(10,EN); {StV.Caption:=FloatToStr(R_Y);}
end;
Stack[S_Top].X:=MN*Power(10,EN);
ShowVar;
end;
end;
end;
1:
end;



procedure TForm1.SBpointClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('.'); goto 1; end;

if FNN = True then
begin
NewNum;
SS:=Copy(' 0.',1,3);
StV.Caption:=SS;
{Delete(SS,2,1);} LeS:=3;
if reg = 'x' then R_X:=0
else R_Y:=0;
end;
FSP:=True;
end;
1:
end;


procedure TForm1.SBescClick(Sender: TObject);
label 1;
begin
NewNum;
FH:=' ';
StFH.Caption:=FH;
COP:='NOP';
R_X:=0; R_Y:=0;
R_X1:=0;
R_X2:=0;
FNN:=True;
Reg:='x';
RX12:='1';
smd:='d';
SS:=Copy(' 0.',1,3);
StV.Caption:=SS;
Br:=0;
FEO:=False;
StBr.Caption:='   ';
FOP:=False;
ST_ST.Caption:='  ';

InitStack;

If FTF = True then
begin
 Fort.Suspend;
 Fort.Terminate;
 Stv.Font.Color:=clAqua;
 FTF:=False;
 StV.Caption:=SS;
 Form1.STFunc.Caption:='  ';
end;

if FFF = 'EF' then
begin
FSS:=False;
cFS:=LeFS-1;
if LeFS <> 0 then begin StFS.Caption:='F'+IntToStr(cFS); cFP:=0; end;
if FER = False then SFunc:='';
LF.Caption:=SFunc;
goto 1;
end;

FRS:=False;
cRS:=LeRS-1;
if LeRS <> 0 then StS.Caption:='Xs:'+IntToStr(LeRS);

FRSy:=False;
//cRSy:=LeRSy;
cRSy:=LeRSy-1;
if LeRSy <> 0 then StSy.Caption:='Ys:'+IntToStr({cRSy}LeRSy);

1:
FER:=False;
end;



procedure TForm1.SBCEClick(Sender: TObject);
label 1;
var
i: Integer;
begin
if (FER = False) and (FTF = False) then
begin
if (FFF = 'EF') and (FSS = True) then
begin

 cFS:=cFS+1;
 for i:=cFS to  LeFS-1 do
 begin
 F_S[i]:=F_S[i+1];
 end;
 LeFS:=LeFS-1;
 cFS:=LeFS-1;
 if cFS <> -1 then
 begin
  StFS.Caption:='F'+IntToStr(LeFS);
  SFunc:=Copy(F_S[0],1,Length(SFunc));
  LF.Caption:=Copy(SFunc,1,Length(SFunc));
 end
 else
 begin
  StFS.Caption:='  ';
  SFunc:='';
  LF.Caption:='';
 end;

 FSS:=False;

 goto 1;
end;

If Reg='x' Then
begin
R_X:=0;
end
else
begin
R_Y:=0;
end;
NewNum;
FNN:=True;
SS:=Copy(' 0.',1,3);
StV.Caption:=SS;

if FRS = True then
begin

 cRS:=cRS+1;
 for i:=cRS to LeRS-1 do
 begin
  R_Xs[i]:=R_Xs[i+1];
 end;
 LeRS:=LeRS-1;
 cRS:=LeRS-1;
 if cRS <> -1 then StS.Caption:='Xs:'+IntToStr(LeRS)
 else StS.Caption:='   ';
 FRS:=False;

 CopyToRSD;
end;


if FRSy = True then
begin


 cRSy:=cRSy+1;
 for i:=cRSy to LeRSy-1 do
 begin
  R_Ys[i]:=R_Ys[i+1];
 end;
 LeRSy:=LeRSy-1;
 cRSy:=LeRSy-1;
 if cRSy <> -1 then StSy.Caption:='Ys:'+IntToStr(LeRSy)
 else StSy.Caption:='   ';
 FRSy:=False;
 CopyToRSyD;
end;


end;
1:
end;



procedure TForm1.SBarrowClick(Sender: TObject);
var
xch,xch1: TFloat;
L: Integer;
begin
if (FER = False) and (FTF = False) then
begin
if reg = 'x' then
begin
xch:=R_Y; reg:= 'y';   xch1:=Stack[S_Top].X;
end
else
begin
xch:=R_X; reg:='x';   xch1:=Stack[S_Top-1].X;
end;


if reg = 'x' then
begin
reg:= 'y'; R_X:=R_Y; R_Y:=xch;
Stack[S_Top-1].X:=Stack[S_Top].X; Stack[S_Top].X:=xch1;
end
else
begin
reg:= 'x'; R_Y:=R_X; R_X:=xch;
Stack[S_Top].X:=Stack[S_Top-1].X;  Stack[S_Top-1].X:=xch1;
end;
xch:=xch1;   R_X:=Stack[S_Top-1].X; R_Y:=Stack[S_Top].X;


NewNum;
FNN:=True;
OutVar(xch);
end;
end;




procedure InitFuncStruct(var Func: TAddFuncStruct);
begin
   Func.addr:=0;
   Func.Arg:=0;
   Func.CallType:=0;
   Func.ArgType:=0;
   Func.ArgTypeList:=0;
   Func.ClearStack:=fl_DISABLE;
   Func.Arrow:=fl_RIGHT;
   Func.DeepFPU:=fl_UNKNOWN;
   Func.Set_ID:=fl_DISABLE;
   Func.Id_Func:=0;
   Func.SaveReg:=0;
   Func.CodeInline:=0;
   Func.SizeCode:=0;
end;




procedure TForm1.FormCreate(Sender: TObject);
var
S: String;
Func: TAddFuncStruct;
TypeList: array of Integer;
ID: Cardinal;
i: Integer;
Code: array of byte;
P: ^Cardinal;
IV: TArrayPI;
Adr: Pointer;
F: TFloatType;
FuncN: TArrayA;
DefaultLCID: Integer;
DC: Char;
Fmt: TFormatSettings;
begin
{
Grad(x)=trunc(x)
Minut(x)=trunc(frac(x)*60)
Sec(x)=(frac(frac(x)*60)*60)
}


GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';

L_FE.Font.Color:=RGB(160,160,255);
Con_E:=2.718281828459045;
Con_Pi:=3.141592653589793238462643;
V_PI:=3.141592653589793238462643;
NewNum;
SetLength(ES,4);
//DRS:=99;
COP:='NOP';
R_X:=0; R_Y:=0;
R_X1:=0;
R_X2:=0;
Reg:='x';
RX12:='1';
smd:='d';
FH:=' ';
FSH:=True;
FSE:=False;
FNN:=True;
FFF:='  ';
SS:=Copy(' 0.',1,3);
StFx.Caption:='    ';
Stime:=':';
LeFS:=0;
cFS:=LeFS-1;
LeRS:=0;
cRS:=LeRS-1;
LeRSy:=0;
//cRSy:=LeRSy;
cRSy:=LeRSy-1;
Br:=0;
FEO:=False;
GRD:='rad';
StDRG.Caption:=GRD;
Sig:=' ';
FRS:=False;
FRSy:=False;
FSS:=False;
DIG:=15;  //-  
MAX_NUM:=9.999999999999E99;
MIN_NUM:=9.999999999999E-100;
SFunc:='';
cFP:=0;
S_Len:=8;
S_Top:=1;
FOP:=False;
InitStack;
FSD1:=True;
FSD2:=True;
FSD3:=True;
FIF:=True;
FIFD:=True;


FTF:=False;
F_Ctrl:=False;
Clp:=TClipboard.Create;

//SetLength(R_Ys,DRS);

flSet(fl_DATA_TYPE,fl_EXTENDED,0);

flSetDiffVar('x');

SetLength(V_YM,99);
SetLength(D_Xs,1);
D_Xs[0]:=0;
SetLength(D_Ys,1);
D_Ys[0]:=0;

flSetVar('A',@R_A,fl_Extended);
flSetVar('B',@R_B,fl_Extended);
flSetVar('C',@R_C,fl_Extended);
flSetVar('D',@R_D,fl_Extended);
flSetVar('E',@R_E,fl_Extended);
flSetVar('F',@R_F,fl_Extended);
flSetVar('G',@R_G,fl_Extended);
flSetVar('x',@V_X,fl_Extended);
flSetVar('y',@V_Y,fl_Extended);
flSetVar('z',@V_Z,fl_Extended);
flSetVar('t',@V_T,fl_Extended);
flSetVar('n',@V_N,fl_Integer);
flSetVar('k',@V_K,fl_Integer);
flSetVar('m',@V_M,fl_Integer);
flSetParam('pi',@V_PI,fl_Extended);

for i := 0 to 98 do
begin
  S:='y'+IntToStr(i+1);
  flSetVar(S,@V_YM[i],fl_Extended);
end;

SetLength(V_IM,99);

for i := 0 to 98 do
begin
  S:='n'+IntToStr(i+1);
  flSetVar(S,@V_IM[i],fl_Integer);
end;

S:='y'+chr(39); //y'
flSetVar(S,@V_YM[0]{V_Y1},fl_Extended);
flSetVar('y"',@V_YM[1]{V_Y2},fl_Extended);
S:='y'+chr(39)+chr(39)+chr(39); //y'''
flSetVar(S,@V_YM[2]{V_Y3},fl_Extended);
S:='y"'+chr(39); //y"'
flSetVar(S,@V_YM[2]{V_Y3},fl_Extended);
S:='y'+chr(39)+'"'; //y'"
flSetVar(S,@V_YM[2]{V_Y3},fl_Extended);



flSetVar('Xs',@D_Xs,fl_ARRAY_EXTENDED);
flSetVar('Ys',@D_Ys,fl_ARRAY_EXTENDED);


C_Func:=nil;
C_Func1:=nil;
C_Func2:=nil;
C_Func3:=nil;
C_Func4:=nil;
C_D1Func:=nil;
C_D2Func:=nil;
C_D3Func:=nil;
C_IFFunc:=nil;
C_IFD1Func:=nil;
C_IFD2Func:=nil;
C_IFD3Func:=nil;

InitFuncStruct(Func);
Func.addr:=@FSPL3;
Func.Arg:=1;
SetLength(TypeList,1);
TypeList[0]:=fl_EXTENDED;
Func.ArgTypeList:=@TypeList[0];
Func.CallType:=fl_STACK_CPU;
Func.DeepFPU:=2;
Func.ClearStack:=fl_DISABLE;
Func.Arrow:=fl_RIGHT;
flSetFunction('splain',@Func,ID);
flAddNameFunction(ID,'splain3');
flAddNameFunction(ID,'spl3');
{
asm
 fld tbyte ptr [rPI]
 fmulp
end;
}


//rad(x: deg)
InitFuncStruct(Func);
SetLength(Code,8);
Code[0]:=$DB; Code[1]:=$2D;       //fld tbyte ptr []
P:=@Code[2]; P^:=Cardinal(@rPI);  //addr(rPI)
Code[6]:=$DE; Code[7]:=$C9;       //fmulp
Func.CallType:=fl_KERNEL_F;
Func.DeepFPU:=1;
Func.SizeCode:=8;
Func.CodeInline:=@Code[0];
flSetFunction('rad',@Func,ID);
flAddNameFunction(ID,'degToRad');

//deg(x: rad)
InitFuncStruct(Func);
SetLength(Code,8);
Code[0]:=$DB; Code[1]:=$2D;       //fld tbyte ptr []
P:=@Code[2]; P^:=Cardinal(@dPI);  //addr(dPI)
Code[6]:=$DE; Code[7]:=$C9;       //fmulp
Func.CallType:=fl_KERNEL_F;
Func.DeepFPU:=1;
Func.SizeCode:=8;
Func.CodeInline:=@Code[0];
flSetFunction('deg',@Func,ID);
flAddNameFunction(ID,'RadToDeg');





{
SetLength(Form1.D_XIs,3);  SetLength(Form1.D_YIs,3);
D_XIs[0]:=0;   D_XIs[1]:=1;  D_XIs[2]:=2;
D_YIs[0]:=10;  D_YIs[1]:=11; D_YIs[2]:=12;
SetLength(IV,3);
IV[0]:=@V_IM[0]; IV[1]:=@V_IM[1]; IV[2]:=@V_IM[2];
flCompile('n1+n2^2/(n1+n3)',0,Adr);

F:=MathProc.SumN(3,Form1.D_XIs,Form1.D_YIs,IV,Cardinal(Adr));

Stv.Caption:=FloatToStr(F);}

{
SetLength(FuncN,6);
flCompile('1',0,Adr);  FuncN[0]:=Cardinal(Adr);
flCompile('10',0,Adr); FuncN[1]:=Cardinal(Adr);
flCompile('n1',0,Adr);  FuncN[2]:=Cardinal(Adr);
flCompile('n1^2',0,Adr);  FuncN[3]:=Cardinal(Adr);
flCompile('n2-n1',0,Adr);  FuncN[4]:=Cardinal(Adr);
flCompile('n2+n1^2',0,Adr);  FuncN[5]:=Cardinal(Adr);

SetLength(IV,3);
IV[0]:=@V_IM[0]; IV[1]:=@V_IM[1]; IV[2]:=@V_IM[2];
flCompile('n1+n2^2/(n1+n3)',0,Adr);

F:=MathProc.SumNF(3,FuncN,IV,Cardinal(Adr));
Stv.Caption:=FloatToStr(F);
}


end;






procedure TForm1.InitStack;
var
i: Integer;
begin
//S_Len:=8;
S_Top:=1;
for i:= 1 to 8 do
begin
 Stack[i].X:=0; Stack[i].COP:=0; Stack[i].Pr:=0;  Stack[i].Br:=0;
end;
end;

{procedure TForm1.InitMathLib;
begin
 MathProcA:=TMathLib.Create;
end; }



procedure TForm1.SetFH;
begin
If FH = ' ' then
begin
StFH.Font.Color:=clRed; FH:='F';
end
else
if FH = 'F' then
begin
StFH.Font.Color:=clYellow; FH:='H';
end
else
begin
FH:=' ';
end;
StFH.Caption:=FH;
end;


procedure TForm1.SBFHClick(Sender: TObject);
begin
if (FER = False) and (FTF = False) then
begin
SetFH;
end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
{If Button = mbRight then SetFH;}
end;

procedure TForm1.SBdmsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBprcMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBsqrMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBxyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBctgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBtgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBcosMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBsinMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;


procedure TForm1.SBsplClick(Sender: TObject);
label 1;
var
i,N: Integer;
S: String;
a,b,x1,h: extended;
begin
if (FER = False) and (FTF = False) then
begin


if (FH = ' ') then
begin
if FFF = 'EF' then begin AddFunction('y"'); FH:=' '; StFH.Caption:=FH; goto 1; end;
 try
 if (LeRS > 0) and (LeRSy > 0) then
  begin
   MathLib.SetMode(ml_LSE_Method,ml_Gauss);
   MathProc.CreateSplain3(D_Xs,D_Ys,SPL3);
   SFunc:='splain(x)';
   LF.Caption:=SFunc;
   cFP:=Length(SFunc);
   BeginFort('INTEGRALSPLAIN3',reg);
  end;
 except
  SFunc:='';
  ERROR;
 end;
end
else
if FH = 'F' then
begin
  if FFF = 'EF' then begin AddFunction('splain(x)'); FH:=' '; StFH.Caption:=FH; goto 1; end;

 try
  FH:=' ';
  StFH.Caption:=FH;

  if (LeRS > 0) and (LeRSy > 0) then
  begin
   MathLib.SetMode(ml_LSE_Method,ml_Gauss);
   MathProc.CreateSplain3(D_Xs,D_Ys,SPL3);
   SFunc:='splain(x)';
   LF.Caption:=SFunc;
   cFP:=Length(SFunc);
  end;

  //SBFunc.Click;
 except
  SFunc:='';
  ERROR;
 end;

end
else
if FH = 'H' then
begin
  FH:=' ';
  StFH.Caption:=FH;
  if F_E > 0 then n:=Trunc(F_E) else n:=100;

  h:=abs(F_B-F_A)/n;
  if F_A < F_B then a:=F_A else a:=F_B;
  SetFunction;
  SetLength(D_XA,n+1);
  SetLength(D_YA,n+1);
 try
  X1:=V_X;
  for I := 0 to n do
  begin
    D_XA[i]:=a+i*h;
    V_X:=D_XA[i];
    D_YA[i]:=calc(C_Func);
  end;
  V_X:=X1;


  //if (LeRS > 0) and (LeRSy > 0) then
  begin
   MathLib.SetMode(ml_LSE_Method,ml_Gauss);
   MathProc.CreateSplain3(D_XA,D_YA,SPL3);
   SFunc:='splain(x)';
   LF.Caption:=SFunc;
   cFP:=Length(SFunc);
  end;

  //SBFunc.Click;
 except
  SFunc:='';
  ERROR;
 end;

end;


NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
end;
1:
end;




procedure TForm1.SBeq2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB1xMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBlnMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBlogxyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;


procedure TForm1.SBLseClick(Sender: TObject);
var
S: String;
begin
if (FER = False) and (FTF = False) then
begin
 if FFF = 'EF' then begin S:='y'+chr(39); AddFunction(S) end
 else
 if FH = 'F' then
 begin
   FLSEinv:=TFLSEinv.Create(Form1);
   FLSEinv.ShowModal;
   //HelpB.Init(Sett);
   //if SelMode.ShowModal = mrOk then Sett:=H_Sett;
   FLSEinv.Destroy;
   FH:=' ';
   StFH.Caption:=FH;
 end
 else
 if FH = ' ' then
 begin
   FLSE:=TFLSE.Create(Form1);
   FLSE.ShowModal;
   //HelpB.Init(Sett);
   //if SelMode.ShowModal = mrOk then Sett:=H_Sett;
   FLSE.Destroy;
 end;

end;
end;




procedure TForm1.SBLseMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If Button = mbRight then SetFH;
end;


function TForm1.ToDRG(x: TFloatType): TFloatType;
begin
  if GRD = 'deg' then
begin
 ToDRG:=x
end
else
if GRD = 'grad' then
begin
 ToDRG:=x*100/90;
end
else
begin
 ToDRG:=DToR(x);
end;
end;



procedure TForm1.SBdmsClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FH = 'F' then
begin
if FFF = 'EF' then goto 1;

if reg = 'x' then
begin
 R_X:=DMS(R_X);
 R_X:=ToDRG(R_X);
 OutVar(R_X);
end
else
begin
 R_Y:=DMS(R_Y);
 R_Y:=ToDRG(R_Y);
 OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end

else

if FH = ' ' then
begin
if FFF = 'EF' then goto 1;

if (FNN = False) and (FE = False) then
begin
FE:=True;
Insert('E+00',SS,Length(SS)+1);
if SN = 1 then
begin
Delete(SS,1,1);
Insert('',SS,1);
end;
StV.Caption:=SS;
end;
FH:=' '; StFH.Caption:=FH;
//OutStack;
//FOP:=False;
end


else
begin
if FFF = 'EF' then begin AddFunction('arcth()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=arcth(R_X);
OutVar(R_X);
end
else
begin
R_Y:=arcth(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end;
end;

1:
end;



procedure TForm1.XchPoint(const S: String; var S1: String);
var i: Integer;
S2: String;
begin
i:=Length(S);
S2:=Copy(S,1,Length(S));
 while i >= 1 do
 begin
   if (S2[i] = '.') then
   begin
    Delete(S2,i,1);   Insert(',',S2,i);
   end;
   if (S2[i] = '') then
   begin
    Delete(S2,i,1);   Insert('-',S2,i);
   end;
   dec(i);
 end;

S1:=Copy(S2,1,Length(S2));
end;


function TForm1.ToFloat(S: String): TFloat;
begin
 {XchPoint(S,S);
 if S[Length(S)] = ',' then Delete(S,Length(S),1);
 ToFloat:=StrToFloat(S,G_FMT);
 }
 if S[Length(S)] = '.' then Delete(S,Length(S),1);
end;



procedure TForm1.SBAClick(Sender: TObject);
label 1;
var
f: TFloatType;
S: String;
begin
 If (FER = False) and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('A'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
    if StA.Caption = 'A' then
    begin
     If reg = 'x' then R_X:=R_A else R_Y:=R_A;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_A:=f;
     StA.Caption:='A';
    end;
    OutVar(R_A);
    OutStack;
    NewNum;
    FNN:=True;
    FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_A:=R_X
    else R_A:=R_Y;
    If R_A = 0 then StA.Caption:=' '
    else StA.Caption:='A';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
   If reg = 'x' then F_A:=R_X
    else F_A:=R_Y;
   FH:=' ';
   StFH.Caption:=FH;
   NewNum;
   FNN:=True;
   BeginFlash;
  end;

 end;
1:
end;





procedure TForm1.SBBClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False) and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('B'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_B
   else R_Y:=R_B;}
   if StB.Caption = 'B' then
    begin
     If reg = 'x' then R_X:=R_B else R_Y:=R_B;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_B:=f;
     StB.Caption:='B';
    end;
   OutVar(R_B);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_B:=R_X
    else R_B:=R_Y;
    If R_B = 0 then StB.Caption:=' '
    else StB.Caption:='B';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_B:=R_X
    else F_B:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;



procedure TForm1.SBCClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False) and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('C'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_C
   else R_Y:=R_C; }
   if StC.Caption = 'C' then
    begin
     If reg = 'x' then R_X:=R_C else R_Y:=R_C;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_C:=f;
     StC.Caption:='C';
    end;
   OutVar(R_C);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_C:=R_X
    else R_C:=R_Y;
    If R_C = 0 then StC.Caption:=' '
    else StC.Caption:='C';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_C:=R_X
    else F_C:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;





procedure TForm1.SBxMClick(Sender: TObject);
label 1;
begin
IF (FER = False) and (FTF = False) then
begin
 if FFF = 'EF' then begin ViewerL; goto 1; end;

 if sig = 's' then
  begin
   if reg = 'x' then
   begin
    R_X:=MaxXs;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=MaxXs;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end;



If reg = 'x' then R_M:=R_X
else R_M:=R_Y;
If R_M = 0 then StM.Caption:=' '
else StM.Caption:='M';
NewNum;
FNN:=True;
end;
1:
end;

procedure TForm1.SBMxClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
 if FFF = 'EF' then begin ViewerR; goto 1; end;

 if sig = 's' then
  begin
   if reg = 'x' then
   begin
    R_X:=MinXs;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=MinXs;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end;



If reg = 'x' then R_X:=R_M
else R_Y:=R_M;
OutVar(R_M);
OutStack;
NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
end;
1:
end;

procedure TForm1.SBMxMClick(Sender: TObject);
label 1;
var
xch: TFloat;
begin
if (FER = False) and (FTF = False) then
begin

 if FFF = 'EF' then begin DelFuncSymbol; goto 1; end;

 if sig = 's' then
  begin
   SortMinXs;
   goto 1;
  end;



 xch:=R_M;
 If reg = 'x' then R_M:=R_X
  else R_M:=R_Y;
 If R_M = 0 then StM.Caption:=' '
  else StM.Caption:='M';
 NewNum;
 FNN:=True;
 If reg = 'x' then R_X:=xch
  else R_Y:=xch;
 OutVar(xch);
 OutStack;
 FOP:=False;
end;
1:
end;






procedure TForm1.SBxSClick(Sender: TObject);
label 1;
var
i: Integer;
begin
if (FER = False)and (FTF = False) Then
begin
  if sig = 's' then
  begin
   if FFF = 'EF' then begin AddFunction('avr(Xs)'); FH:=' '; StFH.Caption:=FH; goto 1; end;

   if reg = 'x' then
   begin
    R_X:=aver;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=aver;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end
  else
  if (FFF = 'EF')  then
  begin
   if  (SFunc <> '') then
   begin
    if LeFS-1 < DRS then LeFS:=LeFS+1;
    F_S[LeFS-1]:=SFunc;
    StFS.Caption:='F'+IntToStr(LeFS-1);
    cFS:=LeFS-1;
  end
 end
else
begin
 if FRS = True then
  begin
   If reg = 'x' then R_Xs[cRS+1]:=R_X
   else R_Xs[cRS+1]:=R_Y; goto 1;
  end;

 if LeRS-1 < DRS then LeRS:=LeRS+1;
 If reg = 'x' then R_Xs[LeRS-1]:=R_X
 else R_Xs[LeRS-1]:=R_Y;
 StS.Caption:='Xs:'+IntToStr(LeRS-1);
 FNN:=True;
 cRS:=LeRS-1;
 CopyToRSD;

end;
end;
1:
end;



procedure TForm1.SBSxClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin

 if sig = 's' then
  begin
   if reg = 'x' then
   begin
    R_X:=MulXs;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=MulXs;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end;

if FFF = 'EF' then
 begin

  if LeFS <> 0 then
  begin
   if cFS = -1 Then cFS:=LeFS-1;
   SFunc:=Copy(F_S[cFS],1,Length(F_S[cFS]));
   LF.Caption:=SFunc;
   StFS.Caption:='F'+IntToStr(cFS);
   FSS:=True;
   cFS:=cFS-1;
   cFP:=Length(SFunc);
  end;
  goto 1;
 end;

if LeRS <> 0 then
begin

 if cRS = -1 Then cRS:=LeRS-1;
 If reg = 'x' then R_X:=R_Xs[cRS]
 else R_Y:=R_Xs[cRS];
 OutVar(R_Xs[cRS]);
 OutStack;
 StS.Caption:='Xs:'+IntToStr(cRS);
 FRS:=True;
 cRS:=cRS-1;

 if COP <> 'NOP' then FNN:=False
 else FNN:=True;

end;
FOP:=False;
end;
1:
end;



procedure TForm1.SBSxSClick(Sender: TObject);
label 1;
var
xch: TFloat;
Sxch: String;
begin
if (FER = False) and (FTF = False) then
begin

 if sig = 's' then
  begin
   if reg = 'x' then
   begin
    R_X:=NumXs;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=NumXs;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end;

if FFF = 'EF' then
 begin
  if FSS = True then
  begin


   Sxch:=F_S[cFS+1];
   F_S[cFS+1]:=SFunc;
   SFunc:=Copy(Sxch,1,Length(Sxch));
   LF.Caption:=SFunc;
   FSS:=False;


   end;
  goto 1;
 end;

if FRS = True then
begin

xch:=R_Xs[cRS+1];

If reg = 'x' then R_Xs[cRS+1]:=R_X
else R_Xs[cRS+1]:=R_Y;


If reg = 'x' then R_X:=xch
else R_Y:=xch;

OutVar(xch);

CopyToRSD;
FNN:=True;
FRS:=False;
end;
end;
1:
end;



procedure TForm1.SBSCClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin

if sig = 's' then
  begin
   if reg = 'x' then
   begin
    R_X:=CorXY;
    OutVar(R_X);
   end
   else
   begin
    R_Y:=CorXY;
    OutVar(R_Y);
   end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
  end;


 if FFF = 'EF' then
 begin
  LeFS:=0;
  StFS.Caption:='  ';
  goto 1;
 end;

 LeRS:=0;
 StS.Caption:='  ';
 CopyToRSD;
end;
1:
end;






procedure TForm1.SBxplusMClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('Xs[]'); goto 1; end;

 if sig = 's' then
  begin
   SortMaxXs;
   goto 1;
  end;

If reg = 'x' then R_M:=R_M+R_X
else  R_M:=R_M+R_Y;
If R_M = 0 then StM.Caption:=' '
else StM.Caption:='M';
FNN:=True; ;
end;
1:
end;



procedure TForm1.SBXSyClick(Sender: TObject);
label 1;
var
i: Integer;
begin
if (FER = False)and (FTF = False) Then
begin

 //if FFF = 'EF' then begin ViewerR; goto 1; end;

 if sig = 's' then
 begin
  if FFF = 'EF' then begin AddFunction('sum(Xs)'); FH:=' '; StFH.Caption:=FH; goto 1; end;

  if reg = 'x' then
  begin
   R_X:=SumS;
   OutVar(R_X);
  end
  else
  begin
   R_Y:=SumS;
   OutVar(R_Y);
  end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
 end

else
//if FFF <> 'EF' then
 begin
  if FRSy = True then
  begin
   If reg = 'x' then R_Ys[cRSy+1]:=R_X
   else R_Ys[cRSy+1]:=R_Y; goto 1;
  end;

  if LeRSy-1 < DRS then LeRSy:=LeRSy+1;
  If reg = 'x' then R_Ys[LeRSy-1]:=R_X
  else R_Ys[LeRSy-1]:=R_Y;
  StSy.Caption:='Ys:'+IntToStr(LeRSy-1);
  FNN:=True;
  cRSy:=LeRSy-1;
  CopyToRSyD;
 end;

end;
1:
end;




procedure TForm1.SBSyXClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin

if sig = 's' then
begin
 if FFF = 'EF' then begin AddFunction('sumq(Xs)'); FH:=' '; StFH.Caption:=FH; goto 1; end;


 if reg = 'x' then
 begin
  R_X:=Qsum;
  OutVar(R_X);
 end
 else
 begin
  R_Y:=Qsum;
  OutVar(R_Y);
 end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
end
else

if LeRSy <> 0 then
begin

 if cRSy = -1 Then cRSy:=LeRSy-1;
 If reg = 'x' then R_X:=R_Ys[cRSy]
 else R_Y:=R_Ys[cRSy];
 OutVar(R_Ys[cRSy]);
 OutStack;
 StSy.Caption:='Ys:'+IntToStr(cRSy);
 FRSy:=True;
 cRSy:=cRSy-1;



 if COP <> 'NOP' then FNN:=False
 else FNN:=True;
end;
FOP:=False;
end;
1:
end;



procedure TForm1.SBSyXSyClick(Sender: TObject);
label 1;
var
xch: TFloat;
Sxch: String;
begin
if (FER = False) and (FTF = False) then
begin

if sig = 's' then
begin
if FFF = 'EF' then goto 1;

if reg = 'x' then
 begin
 R_X:=SigN;
 OutVar(R_X);
 end
else
 begin
 R_Y:=SigN;
 OutVar(R_Y);
 end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
   goto 1;
end
else


if FRSy = True then
begin

xch:=R_Ys[cRSy+1];

If reg = 'x' then R_Ys[cRSy+1]:=R_X
else R_Ys[cRSy+1]:=R_Y;


If reg = 'x' then R_X:=xch
else R_Y:=xch;

OutVar(xch);

CopyToRSD;
FNN:=True;
FRSy:=False;
end;
end;
1:
end;



procedure TForm1.SBSyCClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
//if FFF = 'EF' then begin AddFunction('Ys[]'); goto 1; end;


 if sig = 's' then
 begin
  if reg = 'x' then
  begin
   R_X:=SigN1;
   OutVar(R_X);
  end
  else
  begin
   R_Y:=SigN1;
   OutVar(R_Y);
  end;
   NewNum;
   FNN:=True;
   FEO:=True;
   FOP:=False;
   OutStack;
  goto 1;
 end;

LeRSy:=0;
StSy.Caption:='  ';
CopyToRSyD;
end;
1:
end;






procedure TForm1.CopyToRSD;
var
i,j: Integer;
begin
  SetLength(D_Xs,LeRS);
  for I := 0 to LeRS-1 do
    begin
      D_Xs[i]:=R_Xs[i];
    end;
  flSetVar('Xs',@D_Xs,fl_ARRAY_EXTENDED);
  if LeRS = 0 then begin SetLength(D_Xs,1); D_Xs[0]:=0; end;
end;



procedure TForm1.CopyToRSyD;
var
i,j: Integer;
begin
  SetLength(D_Ys,LeRSy);
  for I := 0 to LeRSy-1 do
    begin
      D_Ys[i]:=R_Ys[i];
    end;
  flSetVar('Ys',@D_Ys,fl_ARRAY_EXTENDED);
  if LeRSy = 0 then begin SetLength(D_Ys,1); D_Ys[0]:=0; end;
end;



procedure TForm1.SBb1Click(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('('); goto 1; end;
if Br < 99 then
begin
Br:=Br+1;
Stack[S_TOP].Br:=Br;
BN[Br]:=R_X;
BC[Br]:=Copy(COP,1,5);
FNN:=True;
COP:='NOP';
reg:='x';
StV.Caption:=' 0.';
StBr.Caption:='('+IntToStr(Br);
R_X:=0;
end;
end;
1:
end;


procedure TForm1.SBb2Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction(')'); goto 1; end;
if Br > 0 then
begin
//Sbeq.Click;
CalcBr;
FNN:=True;
FEO:=True;
R_Y:=R_X;
//R_X:=BN[Br];
COP:=BC[Br];
Br:=Br-1;
if Br <>0 then StBr.Caption:='('+IntToStr(Br)
else StBr.Caption:='   ';
if COP = 'NOP' then OutVar(R_X);
OutStack;
end;
end;
1:
end;


procedure TForm1.SBdrgClick(Sender: TObject);
var
x: extended;
begin
if (FER = False) and (FTF = False) then
begin
 if reg = 'x' then x:=R_X
 else x:=R_Y;

if GRD = 'deg' then
begin
 x:=DToR(x);
 GRD:='rad';
end
else
if GRD = 'grad' then
begin
 GRD:='deg';
 x:=x*90/100;
end
else
begin
 GRD:='grad';
 x:=RtoG(x);
end;


if reg = 'x' then R_X:=x
else R_Y:=x;


StDRG.Caption:=GRD;
OutVar(x);
end;
end;


procedure TForm1.SBsigClick(Sender: TObject);
begin
if (FER = False) and (FTF = False) then
begin
if Sig = 's' then Sig:= ' '
else
Sig:= 's';
Stsig.Caption:=Sig;
end;
end;

procedure TForm1.SBxyClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FH = ' ' then
begin
 if FFF = 'EF' then
 begin
  if FH = ' ' then begin AddFunction('^'); FH:=' '; StFH.Caption:=FH; goto 1 end
 end;

 If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
 begin
 while (Stack[S_Top].Pr >= 3)  and (Stack[S_TOP].Br = 0) do CalcOp;
  {if Stack[S_Top].Pr >= 3 then
  CalcOp;}
 end;

 if FOP = False then incs;//inc(S_TOP);

 PushOp(5,3);
 R_Y:=R_X;
 NewNum;
 FNN:=True;
 Reg:='y';
 COP:='xy';
 FOP:=True;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then  begin AddFunction('root(,)'); FH:=' '; StFH.Caption:=FH; goto 1 end;

If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
begin
while (Stack[S_Top].Pr >= 3)  and (Stack[S_TOP].Br = 0) do CalcOp;
 {if Stack[S_Top].Pr >= 3 then
 CalcOp;}
end;

if FOP = False then incs;//inc(S_TOP);

PushOp(6,3);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='xRy';
FOP:=True;
FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('arcsh()'); FH:=' '; StFH.Caption:=FH; goto 1; end;
try
if reg = 'x' then
begin
R_X:=arcsh(R_X);
OutVar(R_X);
end
else
begin
R_Y:=arcsh(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end;
1:
end;


procedure TForm1.incs;
begin
 inc(S_TOP);
 ST_ST.Caption:=IntToStr(S_TOP);
end;

procedure TForm1.decs;
begin
dec(S_TOP);
 if S_Top = 1 then ST_ST.Caption:='  '
 else
 ST_ST.Caption:=IntToStr(S_TOP);

end;


procedure TForm1.ERROR;
begin
NewNum;
R_X:=0;
R_Y:=0;
COP:='NOP';
FER:=True;
stV.Caption:='ERROR';
end;



procedure TForm1.TRLERROR;
begin
{NewNum;
R_X:=0;
R_Y:=0;
COP:='NOP';
FER:=True;
StV.Caption:='ERROR'; }
FER:=True;
StV.Caption:='TRANSLATION ERROR';
end;



procedure TForm1.XtoY;
begin
try
R_X:=Power(R_X,R_Y);
except
ERROR;
end;
end;

procedure TForm1.XRootY;
begin
try
R_X:=Power(R_X,1/R_Y);
except
ERROR;
end;
end;

procedure TForm1.SBsqrClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FH = ' ' then
begin
if FFF = 'EF' then goto 1;

try
if reg = 'x' then
begin
R_X:=Qroot(R_X);
OutVar(R_X);
end
else
begin
R_Y:=Qroot(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
except
 ERROR;
end;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then goto 1;

if reg = 'x' then
begin
R_X:=Quad(R_X);
OutVar(R_X);
end
else
begin
R_Y:=Quad(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('arcch()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=arcch(R_X);
OutVar(R_X);
end
else
begin
R_Y:=arcch(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end;
1:
end;

function TForm1.Qroot(x: TFloat):TFloat;
begin
try
Qroot:=sqrt(x);
except
ERROR;
end;
end;

function TForm1.Quad(x: TFloat):TFloat;
begin
try
Quad:=sqr(x);
except
ERROR;
end;
end;


function TForm1.arcch(x: TFloat):TFloat;
begin
try
arcch:=LogN(exp(1),x+sqrt(sqr(x)-1));
except
ERROR;
end;
end;


function TForm1.ToDeg: extended;
var
x: extended;
begin

if reg = 'x' then x:=R_X else x:=R_Y;

if GRD = 'deg' then
begin
 x:=x;
end
else
if GRD = 'grad' then
begin
 x:=x*90/100;
end
else
begin
 x:=RtoD(x);
end;
 ToDeg:=x;
end;


procedure TForm1.SBprcClick(Sender: TObject);
label 1;
var
Gr,Mnt: Integer;
Sec,arg: TFloatType;
begin

if (FER = False) and (FTF = False) then
begin


if FH = ' ' then
begin
if FFF = 'EF' then goto 1;
//%
 If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
  begin
   while (Stack[S_Top].Pr >= 3)  and (Stack[S_TOP].Br = 0) do CalcOp;
  end;

  if FOP = False then incs;

  PushOp(9,3);
  R_Y:=R_X;
  NewNum;
  FNN:=True;
  Reg:='y';
  COP:='%';
  FOP:=True;
  FH:=' ';
  StFH.Caption:=FH;
  goto 1;

end

else
if FH = 'F' then     //-> o ' "
begin


 Gr:=trunc(ToDeg);
 Mnt:=trunc(frac(ToDeg)*60);
 Sec:=frac(frac(ToDeg)*60)*60;

 FSH:=False;  OutVar(Sec); FSH:=True;

 StV.Caption:=IntToStr(Gr)+chr(186)+'  '+IntToStr(Mnt)+chr(39)+'  '+CSV{FloatToStr(Sec)}+'"';
 FH:=' ';
 StFH.Caption:=FH;
 NewNum;
 FNN:=True;
 FEO:=True;
 FOP:=False;
 goto 1;
end

else
begin
if FFF = 'EF' then begin AddFunction('arccth()'); FH:=' '; StFH.Caption:=FH; goto 1; end;
try
if reg = 'x' then
begin
R_X:=arccth(R_X);
OutVar(R_X);
end
else
begin
R_Y:=arccth(R_Y);
OutVar(R_Y);
end;
except
 ERROR;
end;
FH:=' ';
StFH.Caption:=FH;
OutStack;
FOP:=False;
end;
NewNum;
FNN:=True;
FEO:=True;
end;
1:
end;



(*
procedure TForm1.SBnmClick(Sender: TObject);
label 1;
begin

if (FER = False) and (FTF = False) then
begin


if FH = ' ' then
begin
if FFF = 'EF' then goto 1;

If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
begin
while (Stack[S_Top].Pr >= 3)  and (Stack[S_TOP].Br = 0) do CalcOp;
 {if Stack[S_Top].Pr >= 3 then
 Sbeq.Click; }
end;

if FOP = False then incs;//inc(S_TOP);

PushOp(8,3);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='Cnm';
FOP:=True;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('!'); FH:=' '; StFH.Caption:=FH; goto 1; end;

if reg = 'x' then
begin
R_X:=factor(R_X);
OutVar(R_X);
end
else
begin
R_Y:=factor(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
OutStack;
FOP:=False;
end

else
begin
if reg = 'x' then
begin
if FFF = 'EF' then begin AddFunction('cth()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

R_X:=cth(R_X);
OutVar(R_X);
end
else
begin
R_Y:=cth(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
OutStack;
FOP:=False;
end;
NewNum;
FNN:=True;
FEO:=True;
end;
1:
end;
*)



function TForm1.Cnm: TFloat;
label 1;
var
fn, fm, fnm: TFloat;
i: Integer;
begin
If (R_Y > R_X) or (Trunc(R_X) <> R_X) or (Trunc(R_Y) <> R_Y) or (R_X < 0) or (R_Y < 0) then
begin
ERROR;
goto 1;
end;
if R_X = 0 then R_X:=1;
if R_Y = 0 then R_Y:=1;
fn:=1; fm:=1; fnm:=1;
try
for i:=1 to Trunc(R_X) do
begin
fn:=fn*i;
end;

for i:=1 to Trunc(R_Y) do
begin
fm:=fm*i;
end;

for i:=1 to Trunc(R_X-R_Y) do
begin
fnm:=fnm*i;
end;
R_X:=fn/(fm*fnm);
Cnm:=R_X;
except
ERROR;
end;
1:
end;


function TForm1.Factor(X: TFloat): TFloat;
var
i: Integer;
fac: TFloat;
begin
try
If (Trunc(X) = X) and (x>=0)  then
begin
if X =0 then X:=1;
Fac:=1;
for i:=1 to Trunc(X) do
begin
Fac:=Fac*i;
end;
Factor:=fac;
end
else
ERROR;
except
ERROR;
end;
end;

function TForm1.arccth(x:TFloat): TFloat;
begin
try
arccth:=0.5*logn(exp(1),(1+x)/(x-1));
except
ERROR;
end;
end;

function TForm1.DToR(x: TFloat):TFloat;
begin
DToR:=x*Pi/180;
end;

function TForm1.GToR(x: TFloat): TFloat;
begin
GToR:=x*Pi/200;
end;


function TForm1.RToD(x: TFloat): TFloat;
begin
RToD:=x*180/Pi;
end;

function TForm1.RToG(x: TFloat): TFloat;
begin
RToG:=x*200/Pi;
end;


procedure TForm1.SBcosClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FH = ' ' then
begin
if FFF = 'EF' then begin AddFunction('cos()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

if reg = 'x' then
begin
R_X:=cosinus(R_X);
OutVar(R_X);
end
else
begin
R_Y:=cosinus(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('arccos()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=ArcCosinus(R_X);
OutVar(R_X);
end
else
begin
R_Y:=ArcCosinus(R_Y);
OutVar(R_Y);
end;
except
  ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('ch()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=ch(R_X);
OutVar(R_X);
end
else
begin
R_Y:=ch(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
OutStack;
end;
1:
end;


function TForm1.Cosinus(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
Cosinus:=cos(DToR(x));
if abs(cos(DToR(x))) < 1e-18 then Cosinus:=0;
end
else
begin
if GRD = 'grad' then
begin
Cosinus:=cos(GToR(x));
if abs(cos(GToR(x))) < 1e-18 then Cosinus:=0;
end
else
begin
Cosinus:=cos(x);
if abs(cos(x)) < 1e-18 then Cosinus:=0;
end;
end;
end;

function TForm1.ch(x: TFloat):TFloat;
begin
ch:=(exp(x)+exp(-x))/2;
end;


function TForm1.ArcCosinus(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
ArcCosinus:=RToD(Arccos(x));
if abs(Arccos(x)) < 1e-19 then ArcCosinus:=0;
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
ArcCosinus:=RToG(Arccos(x));
if abs(Arccos(x)) < 1e-19 then ArcCosinus:=0;
except
ERROR;
end;
end
else
begin
try
ArcCosinus:=arccos(x);
if abs(arccos(x)) < 1e-19 then ArcCosinus:=0;
except
ERROR;
end;
end;
end;
end;


procedure TForm1.SBtgClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False)  then
begin

if FH = ' ' then
begin
if FFF = 'EF' then begin AddFunction('tg()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

if reg = 'x' then
begin
R_X:=Tang(R_X);
OutVar(R_X);
end
else
begin
R_Y:=Tang(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('arctg()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=ArcTang(R_X);
OutVar(R_X);
end
else
begin
R_Y:=ArcTang(R_Y);
OutVar(R_Y);
end;
except
  ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('th()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=th(R_X);
OutVar(R_X);
end
else
begin
R_Y:=th(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
OutStack;
end;
1:
end;


function TForm1.Tang(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
Tang:=Tan(DToR(x));
if abs(Tan(DToR(x))) > 1e18 then ERROR;
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
Tang:=Tan(GToR(x));
if abs(Tan(GToR(x))) > 1e18 then ERROR;
except
ERROR;
end;
end
else
begin
try
Tang:=Tan(x);
if abs(Tan(x)) > 1e18 then ERROR;
except
ERROR;
end;
end;
end;
end;


function TForm1.ArcTang(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
ArcTang:=RToD(ArcTan(x));
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
ArcTang:=RToG(ArcTan(x));
except
ERROR;
end;
end
else
begin
try
ArcTang:=arctan(x);
except
ERROR;
end;
end;
end;
end;

function TForm1.th(x: TFloat):TFloat;
begin
th:=(exp(x)-exp(-x))/(exp(x)+exp(-x))
end;

procedure TForm1.SBctgClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FH = ' ' then
begin
if FFF = 'EF' then begin AddFunction('ctg()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

if reg = 'x' then
begin
R_X:=CTang(R_X);
OutVar(R_X);
end
else
begin
R_Y:=CTang(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('arcctg()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=ArcCTang(R_X);
OutVar(R_X);
end
else
begin
R_Y:=ArcCTang(R_Y);
OutVar(R_Y);
end;
except
  ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('cth()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=cth(R_X);
OutVar(R_X);
end
else
begin
R_Y:=cth(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;
FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
OutStack;
end;
1:
end;


function TForm1.CTang(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
CTang:=coTan(DToR(x));
if abs(coTan(DToR(x))) > 1e18 then ERROR;
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
CTang:=coTan(GToR(x));
if abs(coTan(GToR(x))) > 1e18 then ERROR;
except
ERROR;
end;
end
else
begin
try
CTang:=coTan(x);
if abs(coTan(x)) > 1e18 then ERROR;
except
ERROR;
end;
end;
end;
end;


function TForm1.ArcCTang(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
ArcCTang:=RToD(Pi/2-ArcTan(x));
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
ArcCTang:=RToG(Pi/2-ArcTan(x));
except
ERROR;
end;
end
else
begin
try
ArcCTang:=Pi/2-arctan(x);
except
ERROR;
end;
end;
end;
end;


function TForm1.cth(x: TFloat):TFloat;
begin
try
cth:=(exp(x)+exp(-x))/(exp(x)-exp(-x));
except
ERROR;
end;
end;

procedure TForm1.SBsinClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
begin
if FH = ' ' then
begin
if FFF = 'EF' then begin AddFunction('sin()'); FH:=' '; StFH.Caption:=FH; goto 1; end;
if reg = 'x' then
begin
R_X:=sinus(R_X);
OutVar(R_X);
end
else
begin
R_Y:=sinus(R_Y);
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('arcsin()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=Arcsinus(R_X);
OutVar(R_X);
end
else
begin
R_Y:=Arcsinus(R_Y);
OutVar(R_Y);
end;
except
  ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end

else
begin
if FFF = 'EF' then begin AddFunction('sh()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

try
if reg = 'x' then
begin
R_X:=sh(R_X);
OutVar(R_X);
end
else
begin
R_Y:=sh(R_Y);
OutVar(R_Y);
end;
except
ERROR;
end;

FH:=' ';
StFH.Caption:=FH;
end;
end;
NewNum;
FNN:=True;
FEO:=True;
FOP:=False;
OutStack;
end;
1:
end;



function TForm1.Sinus(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
Sinus:=sin(DToR(x));
if abs(sin(DToR(x))) < 1e-18 then Sinus:=0;
end
else
begin
if GRD = 'grad' then
begin
Sinus:=sin(GToR(x));
if abs(sin(GToR(x))) < 1e-18 then Sinus:=0;
end
else
begin
Sinus:=sin(x);
if abs(sin(x)) < 1e-18 then Sinus:=0;
end;
end;
end;


function TForm1.ArcSinus(x:TFloat):TFloat;
begin
if GRD = 'deg' then
begin
try
ArcSinus:=RToD(Arcsin(x));
if abs(Arcsin(x)) < 1e-19 then ArcSinus:=0;
except
ERROR;
end;
end
else
begin
if GRD = 'grad' then
begin
try
ArcSinus:=RToG(Arcsin(x));
if abs(Arcsin(x)) < 1e-19 then ArcSinus:=0;
except
ERROR;
end;
end
else
begin
try
ArcSinus:=arcsin(x);
if abs(arcsin(x)) < 1e-19 then ArcSinus:=0;
except
ERROR;
end;
end;
end;
end;



function TForm1.sh(x: TFloat):TFloat;
begin
sh:=(exp(x)-exp(-x))/2;
end;


function TForm1.Aver:TFloat;
var
i: Integer;
Ssum: TFloat;
begin
try
Ssum:=0;
for i:=0 to LeRS-1 do
begin
Ssum:=Ssum+R_Xs[i];
end;
Aver:=Ssum/LeRS;
except
ERROR;
end;
end;



function TForm1.MaxXs:TFloat;
var
i: Integer;
Max: TFloat;
begin
try
 Max:=R_Xs[0];
for i:=1 to LeRS-1 do
begin
 if R_Xs[i] > Max then Max:=R_Xs[i];
end;
 MaxXs:=Max;
except
 ERROR;
end;
end;



function TForm1.MinXs:TFloat;
var
i: Integer;
Min: TFloat;
begin
try
 Min:=R_Xs[0];
for i:=1 to LeRS-1 do
begin
 if R_Xs[i] < Min then Min:=R_Xs[i];
end;
 MinXs:=Min;
except
 ERROR;
end;
end;



function TForm1.MulXs:TFloat;
var
i: Integer;
Mul: TFloat;
begin
try
 Mul:=1;
for i:=0 to LeRS-1 do
begin
 Mul:=Mul*R_Xs[i];
end;
 MulXs:=Mul;
except
 ERROR;
end;
end;



function TForm1.NumXs:TFloat;
var
i,Nx: Integer;
a,b: TFloat;
begin
try
 Nx:=0;
 if F_A < F_B then begin a:=F_A; b:=F_B end else
    if F_A > F_B then begin a:=F_B; b:=F_A end else
       begin a:=F_A; b:=F_A; end;

for i:=0 to LeRS-1 do
begin
 if (R_Xs[i] >= a) and (R_Xs[i] <= b) then inc(Nx);

end;
 NumXs:=Nx;
except
 ERROR;
end;
end;



procedure TForm1.SortMaxXs;
var
i,nm,j,T: Integer;
Max: TFloat;
begin
try

for i:=0 to LeRS-1 do
begin
 T:=0;
 Max:=R_Xs[i];
 for j:=i to LeRS-1 do
 begin
   if R_Xs[j] > Max then begin Max:=R_Xs[j]; nm:=j; T:=1; end
 end;
 if T = 1 then begin R_Xs[nm]:=R_Xs[i]; R_Xs[i]:=Max; end;
end;
except
 ERROR;
end;
end;



procedure TForm1.SortMinXs;
var
i,nm,j,T: Integer;
Min: TFloat;
begin
try

for i:=0 to LeRS-1 do
begin
 Min:=R_Xs[i];
 T:=0;
 for j:=i to LeRS-1 do
 begin
   if R_Xs[j] < Min then begin Min:=R_Xs[j]; nm:=j; T:=1; end
 end;
 if T = 1 then begin R_Xs[nm]:=R_Xs[i]; R_Xs[i]:=Min; end;
end;
except
 ERROR;
end;
end;





function TForm1.CorXY:TFloat;
var
i,L: Integer;
Ssum,AvrXs,AvrYs,PS,DXs,DYs,SXs,SYs: TFloat;
begin
try
 if LeRS < LeRSy then L:=LeRS else L:=LeRSy;

 SXs:=0;  SYs:=0;
 for i:=0 to L-1 do
 begin
  SXs:=SXs+R_Xs[i];
  SYs:=SYs+R_Ys[i];
 end;
 AvrXs:=SXs/L; AvrYs:=SYs/L;

 PS:=0;  DXs:=0; DYs:=0;
 for i:=0 to L-1 do
 begin
  PS:=PS+(R_Xs[i]-AvrXs)*(R_Ys[i]-AvrYs);
  DXs:=DXs+sqr(R_Xs[i]-AvrXs);
  DYs:=DYs+sqr(R_Ys[i]-AvrYs);
 end;
 DXs:=sqrt(DXs);  DYs:=sqrt(DYs);

 CorXY:=PS/(DXs*DYs);

 except
  ERROR;
 end;
end;




procedure TForm1.SBlnClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
 if FH = ' ' then
 begin
  if FFF = 'EF' then begin AddFunction('ln()'); FH:=' '; StFH.Caption:=FH; goto 1; end;
 try
  if reg = 'x' then
  begin
   R_X:=Lne(R_X);
   OutVar(R_X);
  end
  else
  begin
   R_Y:=Lne(R_Y);
   OutVar(R_Y);
  end;
   FH:=' ';
   StFH.Caption:=FH;
 except
  ERROR;
 end
 end
else
 if FH = 'F' then
 begin
  if FFF = 'EF' then begin AddFunction('exp()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

  try
  if reg = 'x' then
  begin
   R_X:=exp(R_X);
   OutVar(R_X);
  end
  else
  begin
   R_Y:=exp(R_Y);
   OutVar(R_Y);
  end;
  except
  ERROR;
  end;

   FH:=' ';
   StFH.Caption:=FH;
 end;

 NewNum;
 FNN:=True;
 FEO:=True;
 OutStack;
 FOP:=False;
end;
1:
end;



function TForm1.Qsum:TFloat;
var
i: Integer;
Ssum: TFloat;
begin
Ssum:=0;
for i:=0 to LeRS-1 do
begin
Ssum:=Ssum+sqr(R_Xs[i]);
end;
Qsum:=Ssum;
end;


function TForm1.Lne(x:TFloat):TFloat;
begin
try
Lne:=LogN(exp(1),x);
except
ERROR;
end;
end;


procedure TForm1.SB1xClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
 if FH = ' ' then
 begin
  if FFF = 'EF' then goto 1;

  if reg = 'x' then
  begin
   try
    R_X:=1/R_X;
    OutVar(R_X);
   except
    ERROR;
   end;
  end
  else
  begin
   try
    R_Y:=1/R_Y;
    OutVar(R_Y);
   except
    ERROR;
   end;
  end;
  FH:=' ';
  StFH.Caption:=FH;
 end
else
 if FH = 'F' then
 begin
  if FFF = 'EF' then begin AddFunction('pi'); FH:=' '; StFH.Caption:=FH; goto 1; end;

  if reg = 'x' then
  begin
   R_X:=Con_Pi;
   OutVar(R_X);
  end
  else
  begin
   R_Y:=Con_Pi;
   OutVar(R_Y);
  end;
   FH:=' ';
   StFH.Caption:=FH;
 end
 else

 if FH = 'H' then
 begin
  if FFF = 'EF' then begin AddFunction('!'); FH:=' '; StFH.Caption:=FH; goto 1; end;

  try
  if reg = 'x' then
  begin
   R_X:=factor(R_X);
   OutVar(R_X);
  end
  else
  begin
   R_Y:=factor(R_Y);
   OutVar(R_Y);
  end;
  except
   ERROR;
  end;
   FH:=' ';
   StFH.Caption:=FH;
   //OutStack;
   //FOP:=False;
 end;

NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end;
1:
end;


function TForm1.SigN:TFloat;
var
i: Integer;
Ssum,Avr: TFloat;
begin
try
Ssum:=0; Avr:=Aver;
for i:=0 to LeRS-1 do
begin
Ssum:=SSum+sqr(R_Xs[i]-Avr);
end;
SigN:=sqrt(Ssum/LeRS);
except
ERROR;
end;
end;

procedure TForm1.SBlogxyClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if  FH = ' ' then
begin
if FFF = 'EF' then begin AddFunction('log(,)'); FH:=' '; StFH.Caption:=FH; goto 1; end;


If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
begin
 if Stack[S_Top].Pr >= 3 then
 Sbeq.Click;
end;

if FOP = False then incs;//inc(S_TOP);

PushOp(7,3);
R_Y:=R_X;
NewNum;
FNN:=True;
Reg:='y';
COP:='logxy';
FOP:=True;
FH:= ' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if FFF = 'EF' then begin AddFunction('lg()'); FH:=' '; StFH.Caption:=FH; goto 1; end;

if reg = 'x' then
begin
try
R_X:=Log10(R_X);
OutVar(R_X);
except
ERROR;
end;
end
else
begin
try
R_Y:=Log10(R_Y);
OutVar(R_Y);
except
ERROR;
end;
end;
FH:=' ';
StFH.Caption:=FH;
OutStack;
FOP:=False;
end;

NewNum;
FNN:=True;
FEO:=True;
end;
1:
end;


function TForm1.SigN1:TFloat;
var
i: Integer;
Ssum,Avr: TFloat;
begin
try
Ssum:=0; Avr:=Aver;
for i:=0 to LeRS-1 do
begin
Ssum:=SSum+sqr(R_Xs[i]-Avr);
end;
SigN1:=sqrt(Ssum/(LeRS-1));
except
ERROR;
end;
end;


procedure TForm1.logxy;
begin
try
R_X:=LogN(R_X,R_Y);
except
ERROR;
end;
end;

function TForm1.SumS:TFloat;
var
i: Integer;
Ssum: TFloat;
begin
Ssum:=0;
for i:=0 to LeRS-1 do
begin
Ssum:=SSum+R_Xs[i];
end;
SumS:=Ssum;
end;


procedure TForm1.Eq2;
var
D: TFloat;
begin
try
If R_A = 0 then R_A:=1;
D:=sqrt(sqr(R_B)-4*R_A*R_C);
R_X1:=(-R_B+D)/(2*R_A);
R_X2:=(-R_B-D)/(2*R_A);
StV.Caption:=' 0.';
except
ERROR;
end;
end;



procedure TForm1.SBeq2Click(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then goto 1;

if FH = 'H' then   //Cmn
begin
 If ((COP <> 'NOP') and (FNN = False)) or (FEO = True) then
 begin
  while (Stack[S_Top].Pr >= 3)  and (Stack[S_TOP].Br = 0) do CalcOp;
 end;

 if FOP = False then incs;

 PushOp(8,3);
 R_Y:=R_X;
 NewNum;
 FNN:=True;
 Reg:='y';
 COP:='Cnm';
 FOP:=True;
 FH:=' ';
 StFH.Caption:=FH;
 goto 1;

end
else
begin
if FH = ' ' then
begin
eq2;
FH:=' ';
StFH.Caption:=FH;
end

else
if FH = 'F' then
begin
if reg = 'x' then
begin
R_X:=QR12;
OutVar(R_X);
end
else
begin
R_Y:=QR12;
OutVar(R_Y);
end;
FH:=' ';
StFH.Caption:=FH;
end;
NewNum;
FNN:=True;
FEO:=True;
OutStack;
FOP:=False;
end;
end;
1:
end;



function TForm1.QR12: TFloat;
begin
If RX12 = '1' then
begin
RX12:='2'; QR12:=R_X1;
end

else
begin
RX12:='1'; QR12:=R_X2;
end;
end;

function TForm1.arcth(x:TFloat): TFloat;
begin
try
arcth:=0.5*logn(exp(1),(1+x)/(1-x));
except
ERROR;
end;
end;


function TForm1.DMS(x: TFloat): TFloat;
begin
if smd = 'd' then
begin
smd:='m'; DMS:=x;  Sdms:=x;
end
else
if smd = 'm' then
begin
smd:='s'; DMS:=Sdms+x/60;   Sdms:=Sdms+x/60;;
end
else
begin
smd:='d';DMS:=Sdms+x/3600;
end;
end;


procedure TForm1.T1Timer(Sender: TObject);
var
QH:String[1];
begin
StTime.Caption:=':';
QH:=Copy(TimeToStr(Time),2,1);
If QH = ':' then
begin
Hrs:=Copy(TimeToStr(Time),1,1);
Insert('0',Hrs,1);
Mns:=Copy(TimeToStr(Time),3,2);
end
else
begin
Hrs:=Copy(TimeToStr(Time),1,2);
Mns:=Copy(TimeToStr(Time),4,2);
end;
StHrs.Caption:=Hrs;
StMns.Caption:=Mns;
T2.Enabled:=True;

if FTF = True then
begin
  STFunc.Font.Color:=clAqua;
  STFunc.Caption:=IntToStr(Trunc(OpenML.G_Progress))+'%';
end;
end;





procedure TForm1.T2Timer(Sender: TObject);
begin
StTime.Caption:=' ';
T2.Enabled:=False;
end;


procedure TForm1.SBFuncClick(Sender: TObject);
var
EC: Cardinal;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = '  ' then
begin
 FFF:='EF';
 STFunc.Font.Color:=RGB(175,175,255);
 STFunc.Caption:=FFF;
 StFx.Caption:='f(x)';
 LF.Caption:=SFunc;
 if LeFS <> 0 then
 StFS.Caption:='F'+IntToStr(LeFS) else StFS.Caption:='  ';
end
else
begin
 FFF:='  ';
 LF.Caption:=Copy(SFunc,1,Length(SFunc));
 STFunc.Caption:=FFF;
 cFP:=Length(SFunc);
 if cFP <> 0 then F_S[0]:=Copy(SFunc,1,Length(SFunc)) else F_S[0]:='';
 if (cFP <> 0) and (LeFS = 0) then LeFS:=1;
 if (LeFS = 1) and (cFP = 0) then LeFS:=0;


 if LeFS <> 0 then
 StFS.Caption:='F'+IntToStr(LeFS) else StFS.Caption:='  ';
 //CreateFunc;
 SetFunction;
 if SFunc = '' then StFx.Caption:='    ';
 flGetErrorCode(EC);
 if EC <> 0 then
 begin
 FER:=True; StV.Caption:='TRANSLATION ERROR';
 FFF:='  ';
 SBFunc.Click;
 end;
 FSD1:=True;
 FSD2:=True;
 FSD3:=True;
 FIF:=True;
 FIFD:=True;
end;
end;

end;




procedure TForm1.SetFunctionA;
var
EC: Cardinal;
begin
 SetFunction;
 flGetErrorCode(EC);
 if EC <> 0 then
 begin
  FER:=True; StV.Caption:='TRANSLATION ERROR';
 end;
 flPerform(fl_CLEAR,fl_ERROR_CODE);
 FSD1:=True;
 FSD2:=True;
 FSD3:=True;
 FIF:=True;
 FIFD:=True;
end;



procedure TForm1.AddFunction(S: String);
begin
Insert(S,SFunc,cFP+1);
cFP:=cFP+Length(S);
LF.Caption:=Copy(SFunc,1,cFP);
end;




procedure TForm1.ViewerL;
begin
if cFP > 1 then
begin
 dec(cFP);
 LF.Caption:=Copy(SFunc,1,cFP);
end;
end;




procedure TForm1.ViewerR;
begin
if cFP < Length(SFunc) then
begin
 inc(cFP);
 LF.Caption:=Copy(SFunc,1,cFP);
end;
end;



procedure TForm1.DelFuncSymbol;
begin
if cFP > 0 then
begin
Delete(SFunc,cFP,1);
dec(cFP);
LF.Caption:=Copy(SFunc,1,cFP);
end;
end;




procedure TForm1.SBeqMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;



procedure TForm1.BeginFort(FCOP: String; reg: String; X: TFloat = 0);
begin
Fort:=TThFortFunc.Create(FCOP,reg,X);
Fort.FreeOnTerminate:= True;
Fort.Priority:= tpLower;
Fort.Resume;
FTF:=True;
//Stv.Font.Color:=clBlack;
StV.Caption:='CALCULATION'
end;


procedure TForm1.BeginFlash;
begin
Flash:=TThFlash.Create;
Flash.FreeOnTerminate:= True;
Flash.Priority:= tpLower;
Flash.Resume;
end;



procedure TForm1.SBddxClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin

if FFF = 'EF' then begin AddFunction('y'); goto 1; end;

if (FH = ' ') or (FH = 'F') then
begin
if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
   end;
SetFunction;
end;

if FH = ' ' then
begin
BeginFort('DERIVATIVE1',reg);
FH:=' ';
StFH.Caption:=FH;
end
else
if FH = 'F' then
begin
BeginFort('ROOT1',reg);
FH:=' ';
StFH.Caption:=FH;
end;


FOP:=False;
NewNum;
FNN:=True;
FEO:=True;

end;
1:
end;





procedure TForm1.SBDataClick(Sender: TObject);
begin
   FData:=TFData.Create(Form1);
   FData.ShowModal;
   FData.Destroy;
end;

procedure TForm1.SBDClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False) and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('D'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_D
   else R_Y:=R_D; }
   if StD.Caption = 'D' then
    begin
     If reg = 'x' then R_X:=R_D else R_Y:=R_D;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_D:=f;
     StD.Caption:='D';
    end;
   OutVar(R_D);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_D:=R_X
    else R_D:=R_Y;
    If R_D = 0 then StD.Caption:=' '
    else StD.Caption:='D';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_D:=R_X
    else F_D:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;



procedure TForm1.SBEClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False)  and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('E'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_E
   else R_Y:=R_E;}
   if StE.Caption = 'E' then
    begin
     If reg = 'x' then R_X:=R_E else R_Y:=R_E;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_E:=f;
     StE.Caption:='E';
    end;
   OutVar(R_E);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_E:=R_X
    else R_E:=R_Y;
    If R_E = 0 then StE.Caption:=' '
    else StE.Caption:='E';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_E:=R_X
    else F_E:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;



procedure TForm1.SBGClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False)  and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('G'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_G
   else R_Y:=R_G;}
   if StG.Caption = 'G' then
    begin
     If reg = 'x' then R_X:=R_G else R_Y:=R_G;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_G:=f;
     StG.Caption:='G';
    end;
   OutVar(R_G);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_G:=R_X
    else R_G:=R_Y;
    If R_G = 0 then StG.Caption:=' '
    else StG.Caption:='G';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_G:=R_X
    else F_G:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;



procedure TForm1.SBFClick(Sender: TObject);
label 1;
var
f: TFloat;
begin
 If (FER = False)  and (FTF = False) then
 begin
 if FFF = 'EF' then begin AddFunction('F'); goto 1; end;

  if FH = ' ' then
  begin

   if (COP <> 'NOP') and (FNN = True) Then
   begin
   {If reg = 'x' then R_X:=R_F
   else R_Y:=R_F; }
   if StF.Caption = 'F' then
    begin
     If reg = 'x' then R_X:=R_F else R_Y:=R_F;
    end
    else
    begin
     f:=ToFloat(StV.Caption);
     if f <> 0 then  R_F:=f;
     StF.Caption:='F';
    end;
   OutVar(R_F);
   OutStack;
   NewNum;
   FNN:=True;
   FEO:=True;
   end

   else
    begin
    If reg = 'x' then R_F:=R_X
    else R_F:=R_Y;
    If R_F = 0 then StF.Caption:=' '
    else StF.Caption:='F';
    NewNum;
    FNN:=True;
    end;
   goto 1;
  end;

  if FH = 'F' then
  begin
  If reg = 'x' then F_F:=R_X
    else F_F:=R_Y;
  FH:=' ';
  StFH.Caption:=FH;
  NewNum;
  FNN:=True;
  BeginFlash;
  end;

 end;
1:
end;




procedure TForm1.SBAMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;

procedure TForm1.SBBMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;

procedure TForm1.SBCMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;

procedure TForm1.SBDMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;

procedure TForm1.SBEMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;

procedure TForm1.SBddxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;




procedure TForm1.SBis1Click(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('n'); goto 1; end;

if FH = ' ' then begin  CalcExMath('INTEGRAL1'); goto 1; end;
//if FH = 'F' then begin  CalcExMath('INTEGRAL1F',3); goto 1; end;
if FH = 'H' then begin  CalcExMath('SUM1'); goto 1; end;


end;

1:
end;








procedure TForm1.SBis1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;



procedure TForm1.Delay(D: LongInt);
var
T1,T2: LongInt;
begin
T1:=D+GetTickCount;
T2:=GetTickCount;
while T2 < T1 do
begin
T2:=GetTickCount;
end;
end;









procedure TForm1.SBis2Click(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('k'); goto 1; end;

if FH = ' ' then begin  CalcExMath('INTEGRAL2'); goto 1; end;
//if FH = 'F' then  CalcExMath('INTEGRAL2F',3);
if FH = 'H' then begin  CalcExMath('SUM2'); goto 1; end;


end;
1:
end;





procedure TForm1.SBis3fClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('m'); goto 1; end;

if FH = ' ' then begin  CalcExMath('INTEGRAL3'); goto 1; end;
//if FH = 'F' then  CalcExMath('INTEGRAL3F',5);
if FH = 'H' then begin  CalcExMath('SUM3'); goto 1; end;


end;
1:
end;



procedure TForm1.SBi2fClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
 if FFF = 'EF' then  begin AddFunction('y'); goto 1; end;
 if FH = ' ' then  begin CalcExMath('INTEGRALN'); goto 1; end;
 if FH = 'H' then begin  CalcExMath('SUMNF'); goto 1; end;
end;
1:
end;




procedure TForm1.SBi3fClick(Sender: TObject);
label 1;
begin
if (FER = False) and (FTF = False) then
begin
 if FFF = 'EF' then begin AddFunction('z'); goto 1; end;
 if FH = ' ' then  begin CalcExMath('INTEGRALNF'); goto 1; end;
 if FH = 'H' then begin  CalcExMath('MULNF'); goto 1; end;
end;
1:
end;




procedure TForm1.SBfxClick(Sender: TObject);
label 1;
begin
if (FER = False)  and (FTF = False) then
begin
if FFF = 'EF' then  begin AddFunction('x'); goto 1; end;

if  (SFunc <> '') then
 begin
  SetFunction;
  try
   if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
    R_X:=calcFunc;//(C_Func);
    OutVar(R_X);
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
    R_Y:=calcFunc;//(C_Func);
    OutVar(R_Y);
   end;
  except
   ERROR;
  end;

  NewNum;
  FNN:=True;
  FEO:=True;
  FOP:=False;
  OutStack;
 end;
end;

1:
end;







procedure TForm1.SBis2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;




procedure TForm1.SBis3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;


procedure TForm1.SB0MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 If Button = mbRight then SetFH;
end;


procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #$16) and (F_Ctrl = True) then
  begin
    InsertFuncClp;
  end;
end;


procedure TForm1.InsertFuncClp;
var
n: Integer;
begin
 if Clp.HasFormat(cf_TEXT) then
    begin
      if FFF = 'EF' then
      begin
       n:=POS(#$D,Clp.AsText);
       if n <> 0 then
       SFunc:=Copy(Clp.AsText,1,n-1)
       else
       SFunc:=Copy(Clp.AsText,1,Length(Clp.AsText));
       cFP:=Length(SFunc);
       LF.Caption:=Copy(SFunc,1,cFP);
      end;
    end;
end;



procedure TForm1.SBXsYsClick(Sender: TObject);
label 1;
var
i,t: Integer;
Sx: Array of extended;
X1: extended;
begin
if (FER = False) and (FTF = False) then
begin
if FFF = 'EF' then begin AddFunction('Ys[]'); goto 1; end;

if FH = 'F' then
begin
 if LeRS > 0 then
 begin
  SetFunction;
  LeRSy:=LeRS;
  X1:=V_X;
  for I := 0 to LeRS-1 do
    begin
     V_X:=R_Xs[i];
     R_Ys[i]:=calc(C_Func);
    end;
  V_X:=X1;
  CopyToRSyD;
  StSy.Caption:='Ys:'+IntToStr(LeRSy);
 end;
 FH:=' ';
 StFH.Caption:=FH;
 goto 1;
end;

if (LeRS = 0) and (LeRSy = 0)  then goto 1;

if (LeRS = 0) and  (LeRSy <> 0)  then
begin
 for i:= 0 to LeRSy-1 do
  begin
    R_Xs[i]:=R_Ys[i];
  end;

 LeRS:=LeRSy;
 LeRSy:=0;
 StSy.Caption:='   ';
 StS.Caption:='Xs:'+IntToStr(LeRS);
 CopyToRSD;
 CopyToRSyD;
end
else
if (LeRSy = 0) and  (LeRS <> 0)  then
begin
 for i:= 0 to LeRS-1 do
  begin
    R_Ys[i]:=R_Xs[i];
  end;

 LeRSy:=LeRS;
 LeRS:=0;
 StS.Caption:='   ';
 StSy.Caption:='Ys:'+IntToStr(LeRSy);
 CopyToRSD;
 CopyToRSyD;
end
else
if (LeRS <> 0) and  (LeRSy <> 0)  then
begin
 t:=LeRS;
 SetLength(Sx,LeRS);
 for i:= 0 to LeRS-1 do
  begin
    Sx[i]:=R_Xs[i];
  end;
 for i:= 0 to LeRSy-1 do
  begin
    R_Xs[i]:=R_Ys[i];
  end;
 for i:= 0 to LeRS-1 do
  begin
    R_Ys[i]:=Sx[i];
  end;

 LeRS:=LeRSy;
 LeRSy:=t;
 StS.Caption:='Xs:'+IntToStr(LeRS);
 StSy.Caption:='Ys:'+IntToStr(LeRSy);
 CopyToRSD;
 CopyToRSyD;
end;


1:
end;
end;




procedure TForm1.CalcExMath(S: String; NF:Integer = 1; NF1: Integer = 0; D: Integer = 0);
begin

 if reg = 'x' then
   begin
    V_X:=R_X;
    V_Y:=R_Y;
   end
   else
   begin
    V_X:=R_Y;
    V_Y:=R_X;
   end;
 if SFunc <> '' then
 begin
   SetFunction(NF,NF1,D);
   BeginFort(S,reg);
 end;
 FH:=' ';
 StFH.Caption:=FH;
 FOP:=False;
 NewNum;
 FNN:=True;
 FEO:=True;
end;





procedure TForm1.SBsplMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBXsYsMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB7MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB9MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBsumMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB5MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB6MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBsubMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBdvdMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBi2FMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBi3fMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SB3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

procedure TForm1.SBmulMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
If Button = mbRight then SetFH;
end;

end.
